/**
 * @license
 * Copyright 2021 Google LLC. All Rights Reserved.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =============================================================================
 */
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?t(exports,require("crypto")):"function"==typeof define&&define.amd?define(["exports","crypto"],t):t((e="undefined"!=typeof globalThis?globalThis:e||self).tf=e.tf||{},e.require$$0)}(this,(function(e,t){"use strict";function n(e){return e&&"object"==typeof e&&"default"in e?e:{default:e}}var r=n(t),a=function(e,t){return(a=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n])})(e,t)};function o(e,t){function n(){this.constructor=e}a(e,t),e.prototype=null===t?Object.create(t):(n.prototype=t.prototype,new n)}function i(e,t,n,r){return new(n||(n=Promise))((function(a,o){function i(e){try{u(r.next(e))}catch(e){o(e)}}function s(e){try{u(r.throw(e))}catch(e){o(e)}}function u(e){var t;e.done?a(e.value):(t=e.value,t instanceof n?t:new n((function(e){e(t)}))).then(i,s)}u((r=r.apply(e,t||[])).next())}))}function s(e,t){var n,r,a,o,i={label:0,sent:function(){if(1&a[0])throw a[1];return a[1]},trys:[],ops:[]};return o={next:s(0),throw:s(1),return:s(2)},"function"==typeof Symbol&&(o[Symbol.iterator]=function(){return this}),o;function s(o){return function(s){return function(o){if(n)throw new TypeError("Generator is already executing.");for(;i;)try{if(n=1,r&&(a=2&o[0]?r.return:o[0]?r.throw||((a=r.return)&&a.call(r),0):r.next)&&!(a=a.call(r,o[1])).done)return a;switch(r=0,a&&(o=[2&o[0],a.value]),o[0]){case 0:case 1:a=o;break;case 4:return i.label++,{value:o[1],done:!1};case 5:i.label++,r=o[1],o=[0];continue;case 7:o=i.ops.pop(),i.trys.pop();continue;default:if(!(a=i.trys,(a=a.length>0&&a[a.length-1])||6!==o[0]&&2!==o[0])){i=0;continue}if(3===o[0]&&(!a||o[1]>a[0]&&o[1]<a[3])){i.label=o[1];break}if(6===o[0]&&i.label<a[1]){i.label=a[1],a=o;break}if(a&&i.label<a[2]){i.label=a[2],i.ops.push(o);break}a[2]&&i.ops.pop(),i.trys.pop();continue}o=t.call(e,i)}catch(e){o=[6,e],r=0}finally{n=a=0}if(5&o[0])throw o[1];return{value:o[0]?o[1]:void 0,done:!0}}([o,s])}}}function u(e){var t="function"==typeof Symbol&&Symbol.iterator,n=t&&e[t],r=0;if(n)return n.call(e);if(e&&"number"==typeof e.length)return{next:function(){return e&&r>=e.length&&(e=void 0),{value:e&&e[r++],done:!e}}};throw new TypeError(t?"Object is not iterable.":"Symbol.iterator is not defined.")}function l(e,t){var n="function"==typeof Symbol&&e[Symbol.iterator];if(!n)return e;var r,a,o=n.call(e),i=[];try{for(;(void 0===t||t-- >0)&&!(r=o.next()).done;)i.push(r.value)}catch(e){a={error:e}}finally{try{r&&!r.done&&(n=o.return)&&n.call(o)}finally{if(a)throw a.error}}return i}function c(){for(var e=[],t=0;t<arguments.length;t++)e=e.concat(l(arguments[t]));return e}var h=function(){function e(e,t){this.backend=e,this.dataMover=t,this.data=new WeakMap,this.dataIdsCount=0}return e.prototype.get=function(e){return this.data.has(e)||this.dataMover.moveData(this.backend,e),this.data.get(e)},e.prototype.set=function(e,t){this.dataIdsCount++,this.data.set(e,t)},e.prototype.has=function(e){return this.data.has(e)},e.prototype.delete=function(e){return this.dataIdsCount--,this.data.delete(e)},e.prototype.numDataIds=function(){return this.dataIdsCount},e}(),f=function(){function e(){}return e.prototype.refCount=function(e){return d("refCount")},e.prototype.incRef=function(e){return d("incRef")},e.prototype.timerAvailable=function(){return!0},e.prototype.time=function(e){return d("time")},e.prototype.read=function(e){return d("read")},e.prototype.readSync=function(e){return d("readSync")},e.prototype.numDataIds=function(){return d("numDataIds")},e.prototype.disposeData=function(e,t){return d("disposeData")},e.prototype.write=function(e,t,n){return d("write")},e.prototype.move=function(e,t,n,r,a){return d("move")},e.prototype.memory=function(){return d("memory")},e.prototype.floatPrecision=function(){return d("floatPrecision")},e.prototype.epsilon=function(){return 32===this.floatPrecision()?1e-7:1e-4},e.prototype.dispose=function(){return d("dispose")},e}();function d(e){throw new Error("'"+e+"' not yet implemented or not found in the registry. This kernel may not be supported by the tfjs backend you have chosen")}function p(e){for(var t=e.length,n=0;t>0;)n=Math.random()*t|0,g(e,--t,n)}function v(e,t,n){return Math.max(e,Math.min(t,n))}function g(e,t,n){var r=e[t];e[t]=e[n],e[n]=r}function m(e,t){if(!e)throw new Error("string"==typeof t?t:t())}function y(e,t,n){void 0===n&&(n=""),m(x(e,t),(function(){return n+" Shapes "+e+" and "+t+" must match"}))}function b(e){m(null!=e,(function(){return"The input to the tensor constructor must be a non-null value."}))}function w(e,t,n){if(void 0===t&&(t=[]),void 0===n&&(n=!1),null==t&&(t=[]),Array.isArray(e)||D(e)&&!n)for(var r=0;r<e.length;++r)w(e[r],t,n);else t.push(e);return t}function k(e){if(0===e.length)return 1;for(var t=e[0],n=1;n<e.length;n++)t*=e[n];return t}function x(e,t){if(e===t)return!0;if(null==e||null==t)return!1;if(e.length!==t.length)return!1;for(var n=0;n<e.length;n++)if(e[n]!==t[n])return!1;return!0}function E(e){return e%1==0}function S(e,t){return t<=e.length?e:e+" ".repeat(t-e.length)}function A(e,t){var n=t.length;return m((e=null==e?t.map((function(e,t){return t})):[].concat(e)).every((function(e){return e>=-n&&e<n})),(function(){return"All values in axis param must be in range [-"+n+", "+n+") but got axis "+e})),m(e.every((function(e){return E(e)})),(function(){return"All values in axis param must be integers but got axis "+e})),e.map((function(e){return e<0?n+e:e}))}function _(e,t){for(var n=[],r=[],a=null!=t&&Array.isArray(t)&&0===t.length,o=null==t||a?null:A(t,e).sort(),i=0,s=0;s<e.length;++s){if(null!=o){if(o[i]===s&&1!==e[s])throw new Error("Can't squeeze axis "+s+" since its dim '"+e[s]+"' is not 1");(null==o[i]||o[i]>s)&&1===e[s]&&(n.push(e[s]),r.push(s)),o[i]<=s&&i++}1!==e[s]&&(n.push(e[s]),r.push(s))}return{newShape:n,keptDims:r}}function N(e,t){var n=null;if(null==e||"float32"===e)n=new Float32Array(t);else if("int32"===e)n=new Int32Array(t);else{if("bool"!==e)throw new Error("Unknown data type "+e);n=new Uint8Array(t)}return n}function I(e,t){var n=null;if(null==e||"float32"===e)n=new Float32Array(t);else if("int32"===e)n=new Int32Array(t);else if("bool"===e)n=new Uint8Array(t);else{if("string"!==e)throw new Error("Unknown data type "+e);n=new Array(t)}return n}function M(e,t){for(var n=0;n<e.length;n++){var r=e[n];if(isNaN(r)||!isFinite(r))throw Error("A tensor of type "+t+" being uploaded contains "+r+".")}}function T(e){return"bool"===e||"complex64"===e||"float32"===e||"int32"===e||"string"===e}function D(e){return e instanceof Float32Array||e instanceof Int32Array||e instanceof Uint8Array||e instanceof Uint8ClampedArray}function R(e){if("float32"===e||"int32"===e)return 4;if("complex64"===e)return 8;if("bool"===e)return 1;throw new Error("Unknown dtype "+e)}function F(e){if(null==e)return 0;var t=0;return e.forEach((function(e){return t+=e.length})),t}function B(e){return"string"==typeof e||e instanceof String}function C(e){return"boolean"==typeof e}function P(e){return"number"==typeof e}function O(e){return Array.isArray(e)?O(e[0]):e instanceof Float32Array?"float32":e instanceof Int32Array||e instanceof Uint8Array||e instanceof Uint8ClampedArray?"int32":P(e)?"float32":B(e)?"string":C(e)?"bool":"float32"}function L(e){return!!(e&&e.constructor&&e.call&&e.apply)}function z(e,t){for(var n=t;n<e;++n)if(e%n==0)return n;return e}function K(e){var t=e.length;if(t<2)return[];var n=new Array(t-1);n[t-2]=e[t-1];for(var r=t-3;r>=0;--r)n[r]=n[r+1]*e[r+1];return n}function q(e,t,n,r){void 0===r&&(r=!1);var a=new Array;if(1===t.length)for(var o=t[0]*(r?2:1),i=0;i<o;i++)a[i]=n[e+i];else{o=t[0];var s=t.slice(1),u=s.reduce((function(e,t){return e*t}))*(r?2:1);for(i=0;i<o;i++)a[i]=q(e+i*u,s,n,r)}return a}function W(e,t,n){if(void 0===n&&(n=!1),0===e.length)return t[0];var r=e.reduce((function(e,t){return e*t}))*(n?2:1);if(0===r)return[];if(r!==t.length)throw new Error("["+e+"] does not match the input size "+t.length+(n?" for a complex tensor":"")+".");return q(0,e,t,n)}function U(e,t){for(var n=G(e,t),r=0;r<n.length;r++)n[r]=1;return n}function G(e,t){if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t)return new Uint8Array(e);throw new Error("Unknown data type "+t)}function H(e){e.forEach((function(t){m(Number.isInteger(t)&&t>=0,(function(){return"Tensor must have a shape comprised of positive integers but got shape ["+e+"]."}))}))}function V(e){return e&&e.then&&"function"==typeof e.then}function j(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];Q().getBool("IS_TEST")||Q().getBool("PROD")||console.warn.apply(console,c(e))}var J,Z="tfjsflags",Y=function(){function e(e){this.global=e,this.flags={},this.flagRegistry={},this.urlFlags={},this.getQueryParams=X,this.populateURLFlags()}return e.prototype.setPlatform=function(e,t){null!=this.platform&&j("Platform "+this.platformName+" has already been set. Overwriting the platform with "+t+"."),this.platformName=e,this.platform=t},e.prototype.registerFlag=function(e,t,n){if(this.flagRegistry[e]={evaluationFn:t,setHook:n},null!=this.urlFlags[e]){var r=this.urlFlags[e];j("Setting feature override from URL "+e+": "+r+"."),this.set(e,r)}},e.prototype.getAsync=function(e){return i(this,void 0,void 0,(function(){var t,n;return s(this,(function(r){switch(r.label){case 0:return e in this.flags?[2,this.flags[e]]:(t=this.flags,n=e,[4,this.evaluateFlag(e)]);case 1:return t[n]=r.sent(),[2,this.flags[e]]}}))}))},e.prototype.get=function(e){if(e in this.flags)return this.flags[e];var t=this.evaluateFlag(e);if(V(t))throw new Error("Flag "+e+" cannot be synchronously evaluated. Please use getAsync() instead.");return this.flags[e]=t,this.flags[e]},e.prototype.getNumber=function(e){return this.get(e)},e.prototype.getBool=function(e){return this.get(e)},e.prototype.getFlags=function(){return this.flags},Object.defineProperty(e.prototype,"features",{get:function(){return this.flags},enumerable:!0,configurable:!0}),e.prototype.set=function(e,t){if(null==this.flagRegistry[e])throw new Error("Cannot set flag "+e+" as it has not been registered.");this.flags[e]=t,null!=this.flagRegistry[e].setHook&&this.flagRegistry[e].setHook(t)},e.prototype.evaluateFlag=function(e){if(null==this.flagRegistry[e])throw new Error("Cannot evaluate flag '"+e+"': no evaluation function found.");return this.flagRegistry[e].evaluationFn()},e.prototype.setFlags=function(e){this.flags=Object.assign({},e)},e.prototype.reset=function(){this.flags={},this.urlFlags={},this.populateURLFlags()},e.prototype.populateURLFlags=function(){var e=this;if("undefined"!=typeof this.global&&"undefined"!=typeof this.global.location&&"undefined"!=typeof this.global.location.search){var t=this.getQueryParams(this.global.location.search);if(Z in t)t.tfjsflags.split(",").forEach((function(t){var n=l(t.split(":"),2),r=n[0],a=n[1];e.urlFlags[r]=function(e,t){if("true"===(t=t.toLowerCase())||"false"===t)return"true"===t;if(""+ +t===t)return+t;throw new Error("Could not parse value flag value "+t+" for flag "+e+".")}(r,a)}))}},e}();function X(e){var t={};return e.replace(/[?&]([^=?&]+)(?:=([^&]*))?/g,(function(e){for(var n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];return $(t,n[0],n[1]),n.join("=")})),t}function $(e,t,n){e[decodeURIComponent(t)]=decodeURIComponent(n||"")}function Q(){return e.ENV}function ee(){if(null==J){var e=void 0;if("undefined"!=typeof window)e=window;else if("undefined"!=typeof global)e=global;else if("undefined"!=typeof process)e=process;else{if("undefined"==typeof self)throw new Error("Could not find a global object");e=self}J=e}return J}function te(e,t){var n,r=(null==(n=ee())._tfGlobals&&(n._tfGlobals=new Map),n._tfGlobals);if(r.has(e))return r.get(e);var a=t();return r.set(e,a),r.get(e)}e.ENV=null;var ne="Acos",re="Acosh",ae="Add",oe="AddN",ie="ArgMax",se="ArgMin",ue="Asin",le="Asinh",ce="Atan",he="Atanh",fe="Atan2",de="AvgPool",pe="AvgPool3D",ve="BatchMatMul",ge="BatchToSpaceND",me="Bincount",ye="BroadcastArgs",be="Cast",we="Ceil",ke="ClipByValue",xe="Complex",Ee="ComplexAbs",Se="Concat",Ae="Conv2D",_e="Conv2DBackpropFilter",Ne="Conv2DBackpropInput",Ie="Conv3D",Me="Conv3DBackpropInputV2",Te="Cosh",De="Cumsum",Re="CropAndResize",Fe="DenseBincount",Be="DepthToSpace",Ce="DepthwiseConv2dNative",Pe="DepthwiseConv2dNativeBackpropFilter",Oe="DepthwiseConv2dNativeBackpropInput",Le="Diag",ze="Dilation2D",Ke="RealDiv",qe="Einsum",We="Equal",Ue="ExpandDims",Ge="Expm1",He="Fill",Ve="FlipLeftRight",je="Floor",Je="FloorDiv",Ze="FusedBatchNorm",Ye="GatherV2",Xe="GatherNd",$e="Greater",Qe="GreaterEqual",et="Identity",tt="IFFT",nt="Imag",rt="IsFinite",at="IsInf",ot="IsNan",it="LeakyRelu",st="Less",ut="LessEqual",lt="LinSpace",ct="Log1p",ht="LogicalAnd",ft="LogicalNot",dt="LogicalOr",pt="Maximum",vt="MaxPool",gt="MaxPool3D",mt="MaxPoolWithArgmax",yt="Mean",bt="Minimum",wt="MirrorPad",kt="Multinomial",xt="Multiply",Et="NotEqual",St="NonMaxSuppressionV3",At="NonMaxSuppressionV4",_t="NonMaxSuppressionV5",Nt="OnesLike",It="OneHot",Mt="Pack",Tt="PadV2",Dt="Prelu",Rt="Prod",Ft="Range",Bt="Real",Ct="Reciprocal",Pt="Relu",Ot="Reshape",Lt="ResizeNearestNeighbor",zt="ResizeBilinear",Kt="Relu6",qt="Reverse",Wt="Round",Ut="Rsqrt",Gt="ScatterNd",Ht="Select",Vt="Selu",jt="Slice",Jt="Sinh",Zt="Sign",Yt="Sigmoid",Xt="Softplus",$t="Sqrt",Qt="SpaceToBatchND",en="SplitV",tn="Softmax",nn="SparseFillEmptyRows",rn="SparseReshape",an="SparseSegmentMean",on="SparseSegmentSum",sn="SparseToDense",un="SquaredDifference",ln="StridedSlice",cn="StringNGrams",hn="StringSplit",fn="StringToHashBucketFast",dn="Tanh",pn="Tile",vn="TopK",gn="Transform",mn="Transpose",yn="Unique",bn="Unpack",wn="UnsortedSegmentSum",kn="ZerosLike",xn="Step",En="FromPixels",Sn="RotateWithOffset",An="_FusedMatMul",_n="FusedConv2D",Nn="FusedDepthwiseConv2D",In=te("kernelRegistry",(function(){return new Map})),Mn=te("gradRegistry",(function(){return new Map}));function Tn(e,t){var n=Bn(e,t);return In.get(n)}function Dn(e){return Mn.get(e)}function Rn(e){for(var t=In.entries(),n=[];;){var r=t.next(),a=r.done,o=r.value;if(a)break;var i=l(o,2),s=i[0],u=i[1];l(s.split("_"),1)[0]===e&&n.push(u)}return n}function Fn(e){var t=e.kernelName,n=e.backendName,r=Bn(t,n);In.has(r)&&j("The kernel '"+t+"' for backend '"+n+"' is already registered"),In.set(r,e)}function Bn(e,t){return t+"_"+e}var Cn=On,Pn=null;try{Pn=new WebAssembly.Instance(new WebAssembly.Module(new Uint8Array([0,97,115,109,1,0,0,0,1,13,2,96,0,1,127,96,4,127,127,127,127,1,127,3,7,6,0,1,1,1,1,1,6,6,1,127,1,65,0,11,7,50,6,3,109,117,108,0,1,5,100,105,118,95,115,0,2,5,100,105,118,95,117,0,3,5,114,101,109,95,115,0,4,5,114,101,109,95,117,0,5,8,103,101,116,95,104,105,103,104,0,0,10,191,1,6,4,0,35,0,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,126,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,127,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,128,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,129,34,4,66,32,135,167,36,0,32,4,167,11,36,1,1,126,32,0,173,32,1,173,66,32,134,132,32,2,173,32,3,173,66,32,134,132,130,34,4,66,32,135,167,36,0,32,4,167,11])),{}).exports}catch(e){}function On(e,t,n){this.low=0|e,this.high=0|t,this.unsigned=!!n}function Ln(e){return!0===(e&&e.__isLong__)}On.prototype.__isLong__,Object.defineProperty(On.prototype,"__isLong__",{value:!0}),On.isLong=Ln;var zn={},Kn={};function qn(e,t){var n,r,a;return t?(a=0<=(e>>>=0)&&e<256)&&(r=Kn[e])?r:(n=Un(e,(0|e)<0?-1:0,!0),a&&(Kn[e]=n),n):(a=-128<=(e|=0)&&e<128)&&(r=zn[e])?r:(n=Un(e,e<0?-1:0,!1),a&&(zn[e]=n),n)}function Wn(e,t){if(isNaN(e))return t?$n:Xn;if(t){if(e<0)return $n;if(e>=Jn)return rr}else{if(e<=-Zn)return ar;if(e+1>=Zn)return nr}return e<0?Wn(-e,t).neg():Un(e%jn|0,e/jn|0,t)}function Un(e,t,n){return new On(e,t,n)}On.fromInt=qn,On.fromNumber=Wn,On.fromBits=Un;var Gn=Math.pow;function Hn(e,t,n){if(0===e.length)throw Error("empty string");if("NaN"===e||"Infinity"===e||"+Infinity"===e||"-Infinity"===e)return Xn;if("number"==typeof t?(n=t,t=!1):t=!!t,(n=n||10)<2||36<n)throw RangeError("radix");var r;if((r=e.indexOf("-"))>0)throw Error("interior hyphen");if(0===r)return Hn(e.substring(1),t,n).neg();for(var a=Wn(Gn(n,8)),o=Xn,i=0;i<e.length;i+=8){var s=Math.min(8,e.length-i),u=parseInt(e.substring(i,i+s),n);if(s<8){var l=Wn(Gn(n,s));o=o.mul(l).add(Wn(u))}else o=(o=o.mul(a)).add(Wn(u))}return o.unsigned=t,o}function Vn(e,t){return"number"==typeof e?Wn(e,t):"string"==typeof e?Hn(e,t):Un(e.low,e.high,"boolean"==typeof t?t:e.unsigned)}On.fromString=Hn,On.fromValue=Vn;var jn=4294967296,Jn=jn*jn,Zn=Jn/2,Yn=qn(1<<24),Xn=qn(0);On.ZERO=Xn;var $n=qn(0,!0);On.UZERO=$n;var Qn=qn(1);On.ONE=Qn;var er=qn(1,!0);On.UONE=er;var tr=qn(-1);On.NEG_ONE=tr;var nr=Un(-1,2147483647,!1);On.MAX_VALUE=nr;var rr=Un(-1,-1,!0);On.MAX_UNSIGNED_VALUE=rr;var ar=Un(0,-2147483648,!1);On.MIN_VALUE=ar;var or=On.prototype;or.toInt=function(){return this.unsigned?this.low>>>0:this.low},or.toNumber=function(){return this.unsigned?(this.high>>>0)*jn+(this.low>>>0):this.high*jn+(this.low>>>0)},or.toString=function(e){if((e=e||10)<2||36<e)throw RangeError("radix");if(this.isZero())return"0";if(this.isNegative()){if(this.eq(ar)){var t=Wn(e),n=this.div(t),r=n.mul(t).sub(this);return n.toString(e)+r.toInt().toString(e)}return"-"+this.neg().toString(e)}for(var a=Wn(Gn(e,6),this.unsigned),o=this,i="";;){var s=o.div(a),u=(o.sub(s.mul(a)).toInt()>>>0).toString(e);if((o=s).isZero())return u+i;for(;u.length<6;)u="0"+u;i=""+u+i}},or.getHighBits=function(){return this.high},or.getHighBitsUnsigned=function(){return this.high>>>0},or.getLowBits=function(){return this.low},or.getLowBitsUnsigned=function(){return this.low>>>0},or.getNumBitsAbs=function(){if(this.isNegative())return this.eq(ar)?64:this.neg().getNumBitsAbs();for(var e=0!=this.high?this.high:this.low,t=31;t>0&&0==(e&1<<t);t--);return 0!=this.high?t+33:t+1},or.isZero=function(){return 0===this.high&&0===this.low},or.eqz=or.isZero,or.isNegative=function(){return!this.unsigned&&this.high<0},or.isPositive=function(){return this.unsigned||this.high>=0},or.isOdd=function(){return 1==(1&this.low)},or.isEven=function(){return 0==(1&this.low)},or.equals=function(e){return Ln(e)||(e=Vn(e)),(this.unsigned===e.unsigned||this.high>>>31!=1||e.high>>>31!=1)&&(this.high===e.high&&this.low===e.low)},or.eq=or.equals,or.notEquals=function(e){return!this.eq(e)},or.neq=or.notEquals,or.ne=or.notEquals,or.lessThan=function(e){return this.comp(e)<0},or.lt=or.lessThan,or.lessThanOrEqual=function(e){return this.comp(e)<=0},or.lte=or.lessThanOrEqual,or.le=or.lessThanOrEqual,or.greaterThan=function(e){return this.comp(e)>0},or.gt=or.greaterThan,or.greaterThanOrEqual=function(e){return this.comp(e)>=0},or.gte=or.greaterThanOrEqual,or.ge=or.greaterThanOrEqual,or.compare=function(e){if(Ln(e)||(e=Vn(e)),this.eq(e))return 0;var t=this.isNegative(),n=e.isNegative();return t&&!n?-1:!t&&n?1:this.unsigned?e.high>>>0>this.high>>>0||e.high===this.high&&e.low>>>0>this.low>>>0?-1:1:this.sub(e).isNegative()?-1:1},or.comp=or.compare,or.negate=function(){return!this.unsigned&&this.eq(ar)?ar:this.not().add(Qn)},or.neg=or.negate,or.add=function(e){Ln(e)||(e=Vn(e));var t=this.high>>>16,n=65535&this.high,r=this.low>>>16,a=65535&this.low,o=e.high>>>16,i=65535&e.high,s=e.low>>>16,u=0,l=0,c=0,h=0;return c+=(h+=a+(65535&e.low))>>>16,l+=(c+=r+s)>>>16,u+=(l+=n+i)>>>16,u+=t+o,Un((c&=65535)<<16|(h&=65535),(u&=65535)<<16|(l&=65535),this.unsigned)},or.subtract=function(e){return Ln(e)||(e=Vn(e)),this.add(e.neg())},or.sub=or.subtract,or.multiply=function(e){if(this.isZero())return Xn;if(Ln(e)||(e=Vn(e)),Pn)return Un(Pn.mul(this.low,this.high,e.low,e.high),Pn.get_high(),this.unsigned);if(e.isZero())return Xn;if(this.eq(ar))return e.isOdd()?ar:Xn;if(e.eq(ar))return this.isOdd()?ar:Xn;if(this.isNegative())return e.isNegative()?this.neg().mul(e.neg()):this.neg().mul(e).neg();if(e.isNegative())return this.mul(e.neg()).neg();if(this.lt(Yn)&&e.lt(Yn))return Wn(this.toNumber()*e.toNumber(),this.unsigned);var t=this.high>>>16,n=65535&this.high,r=this.low>>>16,a=65535&this.low,o=e.high>>>16,i=65535&e.high,s=e.low>>>16,u=65535&e.low,l=0,c=0,h=0,f=0;return h+=(f+=a*u)>>>16,c+=(h+=r*u)>>>16,h&=65535,c+=(h+=a*s)>>>16,l+=(c+=n*u)>>>16,c&=65535,l+=(c+=r*s)>>>16,c&=65535,l+=(c+=a*i)>>>16,l+=t*u+n*s+r*i+a*o,Un((h&=65535)<<16|(f&=65535),(l&=65535)<<16|(c&=65535),this.unsigned)},or.mul=or.multiply,or.divide=function(e){if(Ln(e)||(e=Vn(e)),e.isZero())throw Error("division by zero");var t,n,r;if(Pn)return this.unsigned||-2147483648!==this.high||-1!==e.low||-1!==e.high?Un((this.unsigned?Pn.div_u:Pn.div_s)(this.low,this.high,e.low,e.high),Pn.get_high(),this.unsigned):this;if(this.isZero())return this.unsigned?$n:Xn;if(this.unsigned){if(e.unsigned||(e=e.toUnsigned()),e.gt(this))return $n;if(e.gt(this.shru(1)))return er;r=$n}else{if(this.eq(ar))return e.eq(Qn)||e.eq(tr)?ar:e.eq(ar)?Qn:(t=this.shr(1).div(e).shl(1)).eq(Xn)?e.isNegative()?Qn:tr:(n=this.sub(e.mul(t)),r=t.add(n.div(e)));if(e.eq(ar))return this.unsigned?$n:Xn;if(this.isNegative())return e.isNegative()?this.neg().div(e.neg()):this.neg().div(e).neg();if(e.isNegative())return this.div(e.neg()).neg();r=Xn}for(n=this;n.gte(e);){t=Math.max(1,Math.floor(n.toNumber()/e.toNumber()));for(var a=Math.ceil(Math.log(t)/Math.LN2),o=a<=48?1:Gn(2,a-48),i=Wn(t),s=i.mul(e);s.isNegative()||s.gt(n);)s=(i=Wn(t-=o,this.unsigned)).mul(e);i.isZero()&&(i=Qn),r=r.add(i),n=n.sub(s)}return r},or.div=or.divide,or.modulo=function(e){return Ln(e)||(e=Vn(e)),Pn?Un((this.unsigned?Pn.rem_u:Pn.rem_s)(this.low,this.high,e.low,e.high),Pn.get_high(),this.unsigned):this.sub(this.div(e).mul(e))},or.mod=or.modulo,or.rem=or.modulo,or.not=function(){return Un(~this.low,~this.high,this.unsigned)},or.and=function(e){return Ln(e)||(e=Vn(e)),Un(this.low&e.low,this.high&e.high,this.unsigned)},or.or=function(e){return Ln(e)||(e=Vn(e)),Un(this.low|e.low,this.high|e.high,this.unsigned)},or.xor=function(e){return Ln(e)||(e=Vn(e)),Un(this.low^e.low,this.high^e.high,this.unsigned)},or.shiftLeft=function(e){return Ln(e)&&(e=e.toInt()),0==(e&=63)?this:e<32?Un(this.low<<e,this.high<<e|this.low>>>32-e,this.unsigned):Un(0,this.low<<e-32,this.unsigned)},or.shl=or.shiftLeft,or.shiftRight=function(e){return Ln(e)&&(e=e.toInt()),0==(e&=63)?this:e<32?Un(this.low>>>e|this.high<<32-e,this.high>>e,this.unsigned):Un(this.high>>e-32,this.high>=0?0:-1,this.unsigned)},or.shr=or.shiftRight,or.shiftRightUnsigned=function(e){if(Ln(e)&&(e=e.toInt()),0===(e&=63))return this;var t=this.high;return e<32?Un(this.low>>>e|t<<32-e,t>>>e,this.unsigned):Un(32===e?t:t>>>e-32,0,this.unsigned)},or.shru=or.shiftRightUnsigned,or.shr_u=or.shiftRightUnsigned,or.toSigned=function(){return this.unsigned?Un(this.low,this.high,!1):this},or.toUnsigned=function(){return this.unsigned?this:Un(this.low,this.high,!0)},or.toBytes=function(e){return e?this.toBytesLE():this.toBytesBE()},or.toBytesLE=function(){var e=this.high,t=this.low;return[255&t,t>>>8&255,t>>>16&255,t>>>24,255&e,e>>>8&255,e>>>16&255,e>>>24]},or.toBytesBE=function(){var e=this.high,t=this.low;return[e>>>24,e>>>16&255,e>>>8&255,255&e,t>>>24,t>>>16&255,t>>>8&255,255&t]},On.fromBytes=function(e,t,n){return n?On.fromBytesLE(e,t):On.fromBytesBE(e,t)},On.fromBytesLE=function(e,t){return new On(e[0]|e[1]<<8|e[2]<<16|e[3]<<24,e[4]|e[5]<<8|e[6]<<16|e[7]<<24,t)},On.fromBytesBE=function(e,t){return new On(e[4]<<24|e[5]<<16|e[6]<<8|e[7],e[0]<<24|e[1]<<16|e[2]<<8|e[3],t)};var ir=Cn||Object.assign(Object.create(null),Cn,{default:Cn});function sr(e){return ir.fromString(e,!0,16)}var ur=sr("c3a5c85c97cb3127"),lr=sr("b492b66fbe98f273"),cr=sr("9ae16a3b2f90404f");function hr(e){return e.xor(e.shru(47))}function fr(e,t,n){var r=e.slice(t,t+n);return ir.fromBytes(Array.from(r),!0,!0)}function dr(e,t){return fr(e,t,8)}function pr(e,t){return fr(e,t,4)}function vr(e,t){return 0===t?e:e.shru(t).or(e.shl(64-t))}function gr(e,t,n){void 0===n&&(n=sr("9ddfea08eb382d69"));var r=e.xor(t).mul(n);r=r.xor(r.shru(47));var a=t.xor(r).mul(n);return a=(a=a.xor(a.shru(47))).mul(n)}function mr(e,t,n,r){return function(e,t,n,r,a,o){a=a.add(e),o=vr(o.add(a).add(r),21);var i=a;return a=(a=a.add(t)).add(n),o=o.add(vr(a,44)),[a.add(r),o.add(i)]}(dr(e,t),dr(e,t+8),dr(e,t+16),dr(e,t+24),n,r)}function yr(e,t){if("string"===t)throw new Error("Cannot convert a string[] to a TypedArray");if(Array.isArray(e)&&(e=w(e)),Q().getBool("DEBUG")&&M(e,t),function(e,t){return e instanceof Float32Array&&"float32"===t||e instanceof Int32Array&&"int32"===t||e instanceof Uint8Array&&"bool"===t}(e,t))return e;if(null==t||"float32"===t||"complex64"===t)return new Float32Array(e);if("int32"===t)return new Int32Array(e);if("bool"===t){for(var n=new Uint8Array(e.length),r=0;r<n.length;++r)0!==Math.round(e[r])&&(n[r]=1);return n}throw new Error("Unknown data type "+t)}function br(){return Q().platform.now()}function wr(e,t){return void 0===t&&(t="utf-8"),t=t||"utf-8",Q().platform.encode(e,t)}function kr(e,t){return void 0===t&&(t="utf-8"),t=t||"utf-8",Q().platform.decode(e,t)}var xr={__proto__:null,createScalarValue:function(e,t){return"string"===t?wr(e):yr([e],t)},toTypedArray:yr,now:br,fetch:function(e,t){return Q().platform.fetch(e,t)},encodeString:wr,decodeString:kr,shuffle:p,shuffleCombo:function(e,t){if(e.length!==t.length)throw new Error("Array sizes must match to be shuffled together First array length was "+e.length+"Second array length was "+t.length);for(var n=e.length,r=0;n>0;)r=Math.random()*n|0,g(e,--n,r),g(t,n,r)},clamp:v,nearestLargerEven:function(e){return e%2==0?e:e+1},swap:g,sum:function(e){for(var t=0,n=0;n<e.length;n++)t+=e[n];return t},randUniform:function(e,t){var n=Math.random();return t*n+(1-n)*e},distSquared:function(e,t){for(var n=0,r=0;r<e.length;r++){var a=Number(e[r])-Number(t[r]);n+=a*a}return n},assert:m,assertShapesMatch:y,assertNonNull:b,flatten:w,sizeFromShape:k,isScalarShape:function(e){return 0===e.length},arraysEqual:x,isInt:E,tanh:function(e){if(null!=Math.tanh)return Math.tanh(e);if(e===1/0)return 1;if(e===-1/0)return-1;var t=Math.exp(2*e);return(t-1)/(t+1)},sizeToSquarishShape:function(e){var t=Math.ceil(Math.sqrt(e));return[t,Math.ceil(e/t)]},createShuffledIndices:function(e){for(var t=new Uint32Array(e),n=0;n<e;++n)t[n]=n;return p(t),t},rightPad:S,repeatedTry:function(e,t,n){return void 0===t&&(t=function(e){return 0}),new Promise((function(r,a){var o=0,i=function(){if(e())r();else{o++;var s=t(o);null!=n&&o>=n?a():setTimeout(i,s)}};i()}))},inferFromImplicitShape:function(e,t){for(var n=1,r=-1,a=0;a<e.length;++a)if(e[a]>=0)n*=e[a];else if(-1===e[a]){if(-1!==r)throw Error("Shapes can only have 1 implicit size. Found -1 at dim "+r+" and dim "+a);r=a}else if(e[a]<0)throw Error("Shapes can not be < 0. Found "+e[a]+" at dim "+a);if(-1===r){if(t>0&&t!==n)throw Error("Size("+t+") must match the product of shape "+e);return e}if(0===n)throw Error("Cannot infer the missing size in ["+e+"] when there are 0 elements");if(t%n!=0)throw Error("The implicit shape can't be a fractional number. Got "+t+" / "+n);var o=e.slice();return o[r]=t/n,o},parseAxisParam:A,squeezeShape:_,getTypedArrayFromDType:N,getArrayFromDType:I,checkConversionForErrors:M,isValidDtype:T,hasEncodingLoss:function(e,t){return"complex64"!==t&&(("float32"!==t||"complex64"===e)&&(("int32"!==t||"float32"===e||"complex64"===e)&&("bool"!==t||"bool"!==e)))},isTypedArray:D,bytesPerElement:R,bytesFromStringArray:F,isString:B,isBoolean:C,isNumber:P,inferDtype:O,isFunction:L,nearestDivisor:z,computeStrides:K,toNestedArray:W,makeOnesTypedArray:U,makeZerosTypedArray:G,makeZerosNestedTypedArray:function(e,t){var n=e.reduce((function(e,t){return e*t}),1);if(null==t||"float32"===t)return W(e,new Float32Array(n));if("int32"===t)return W(e,new Int32Array(n));if("bool"===t)return W(e,new Uint8Array(n));throw new Error("Unknown data type "+t)},assertNonNegativeIntegerDimensions:H,locToIndex:function(e,t,n){if(0===t)return 0;if(1===t)return e[0];for(var r=e[e.length-1],a=0;a<e.length-1;++a)r+=n[a]*e[a];return r},indexToLoc:function(e,t,n){if(0===t)return[];if(1===t)return[e];for(var r=new Array(t),a=0;a<r.length-1;++a)r[a]=Math.floor(e/n[a]),e-=r[a]*n[a];return r[r.length-1]=e,r},isPromise:V,hexToLong:sr,fingerPrint64:function(e,t){var n,r;void 0===t&&(t=e.length);var a=ir.fromNumber(81,!0);if(t<=32)return t<=16?function(e,t){if(void 0===t&&(t=e.length),t>=8){var n=cr.add(2*t),r=dr(e,0).add(cr);return gr(vr(a=dr(e,t-8),37).mul(n).add(r),vr(r,25).add(a).mul(n),n)}if(t>=4)return n=cr.add(2*t),gr((r=pr(e,0)).shl(3).add(t),pr(e,t-4),n);if(t>0){var a,o=(r=e[0])+((a=e[t>>1])<<8),i=t+(e[t-1]<<2);return hr(cr.mul(o).xor(ur.mul(i))).mul(cr)}return cr}(e,t):function(e,t){void 0===t&&(t=e.length);var n=cr.add(2*t),r=dr(e,0).mul(lr),a=dr(e,8),o=dr(e,t-8).mul(n),i=dr(e,t-16).mul(cr);return gr(vr(r.add(a),43).add(vr(o,30)).add(i),r.add(vr(a.add(cr),18)).add(o),n)}(e,t);if(t<=64)return function(e,t){void 0===t&&(t=e.length);var n=cr.add(2*t),r=dr(e,0).mul(cr),a=dr(e,8),o=dr(e,t-8).mul(n),i=dr(e,t-16).mul(cr),s=vr(r.add(a),43).add(vr(o,30)).add(i),u=gr(s,r.add(vr(a.add(cr),18)).add(o),n),l=dr(e,16).mul(n),c=dr(e,24),h=s.add(dr(e,t-32)).mul(n),f=u.add(dr(e,t-24)).mul(n);return gr(vr(l.add(c),43).add(vr(h,30)).add(f),l.add(vr(c.add(r),18)).add(h),n)}(e,t);var o=a,i=a.mul(lr).add(113),s=hr(i.mul(cr).add(113)).mul(cr),u=[ir.UZERO,ir.UZERO],c=[ir.UZERO,ir.UZERO];o=o.mul(cr).add(dr(e,0));var h=0,f=64*(t-1>>6),d=f+(t-1&63)-63;do{o=vr(o.add(i).add(u[0]).add(dr(e,h+8)),37).mul(lr),i=vr(i.add(u[1]).add(dr(e,h+48)),42).mul(lr),o=o.xor(c[1]),i=i.add(u[0]).add(dr(e,h+40)),s=vr(s.add(c[0]),33).mul(lr),u=mr(e,h,u[1].mul(lr),o.add(c[0])),c=mr(e,h+32,s.add(c[1]),i.add(dr(e,h+16))),s=(n=l([o,s],2))[0],o=n[1],h+=64}while(h!==f);var p=lr.add(s.and(255).shl(1));return h=d,c[0]=c[0].add(t-1&63),u[0]=u[0].add(c[0]),c[0]=c[0].add(u[0]),o=vr(o.add(i).add(u[0]).add(dr(e,h+8)),37).mul(p),i=vr(i.add(u[1]).add(dr(e,h+48)),42).mul(p),o=o.xor(c[1].mul(9)),i=i.add(u[0].mul(9).add(dr(e,h+40))),s=vr(s.add(c[0]),33).mul(p),u=mr(e,h,u[1].mul(p),o.add(c[0])),c=mr(e,h+32,s.add(c[1]),i.add(dr(e,h+16))),s=(r=l([o,s],2))[0],o=r[1],gr(gr(u[0],c[0],p).add(hr(i).mul(ur)).add(s),gr(u[1],c[1],p).add(o),p)}},Er=function(){function e(e,t){this.backendTimer=e,this.logger=t,null==t&&(this.logger=new Sr)}return e.prototype.profileKernel=function(e,t,n){var r,a,o,i,s=function(){o=n()},l=br();if(this.backendTimer.timerAvailable())i=this.backendTimer.time(s);else{s();try{for(var c=u(o),h=c.next();!h.done;h=c.next()){h.value.dataSync()}}catch(e){r={error:e}}finally{try{h&&!h.done&&(a=c.return)&&a.call(c)}finally{if(r)throw r.error}}i=Promise.resolve({kernelMs:br()-l})}if(Q().getBool("CHECK_COMPUTATION_FOR_ERRORS"))for(var f=function(t){var n=o[t];n.data().then((function(t){!function(e,t,n){if("float32"!==t)return!1;for(var r=0;r<e.length;r++){var a=e[r];if(isNaN(a)||!isFinite(a))return console.warn("Found "+a+" in the result of '"+n+"'"),!0}}(t,n.dtype,e)}))},d=0;d<o.length;d++)f(d);return{kernelName:e,outputs:o,inputs:t,timeMs:i.then((function(e){return e.kernelMs})),extraInfo:i.then((function(e){return null!=e.getExtraProfileInfo?e.getExtraProfileInfo():""}))}},e.prototype.logKernelProfile=function(e){var t=this,n=e.kernelName,r=e.outputs,a=e.timeMs,o=e.inputs,i=e.extraInfo;r.forEach((function(e){Promise.all([e.data(),a,i]).then((function(r){t.logger.logKernelProfile(n,e,r[0],r[1],o,r[2])}))}))},e}();var Sr=function(){function e(){}return e.prototype.logKernelProfile=function(e,t,n,r,a,o){var i="number"==typeof r?S(r+"ms",9):r.error,s=S(e,25),u=t.rank,l=t.size,c=S(t.shape.toString(),14),h="";for(var f in a){var d=a[f];if(null!=d){var p=d.shape||t.shape,v=p.length;h+=f+": "+v+"D "+(v>0?p:"")+" "}}console.log("%c"+s+"\t%c"+i+"\t%c"+u+"D "+c+"\t%c"+l+"\t%c"+h+"\t%c"+o,"font-weight:bold","color:red","color:blue","color: orange","color: green","color: steelblue")},e}();function Ar(e,t,n,r){var a=K(t),o=function(e,t,n,r){var a=k(t),o=r[r.length-1],i=new Array(o).fill(0),s=t.length,u="complex64"===n?Mr(e):e;if(s>1)for(var l=0;l<a/o;l++)for(var c=l*o,h=0;h<o;h++)i[h]=Math.max(i[h],_r(u[c+h],0,n).length);return i}(e,t,n,a),i=t.length,s=Ir(e,t,n,a,o),u=["Tensor"];return r&&(u.push("  dtype: "+n),u.push("  rank: "+i),u.push("  shape: ["+t+"]"),u.push("  values:")),u.push(s.map((function(e){return"    "+e})).join("\n")),u.join("\n")}function _r(e,t,n){return S(Array.isArray(e)?parseFloat(e[0].toFixed(7))+" + "+parseFloat(e[1].toFixed(7))+"j":B(e)?"'"+e+"'":"bool"===n?Nr(e):parseFloat(e.toFixed(7)).toString(),t)}function Nr(e){return 0===e?"false":"true"}function Ir(e,t,n,r,a,o){void 0===o&&(o=!0);var i="complex64"===n?2:1,s=t[0],u=t.length;if(0===u)return"complex64"===n?[_r(Mr(e)[0],0,n)]:"bool"===n?[Nr(e[0])]:[e[0].toString()];if(1===u){if(s>20){var l=3*i,h=Array.from(e.slice(0,l)),f=Array.from(e.slice((s-3)*i,s*i));return"complex64"===n&&(h=Mr(h),f=Mr(f)),["["+h.map((function(e,t){return _r(e,a[t],n)})).join(", ")+", ..., "+f.map((function(e,t){return _r(e,a[s-3+t],n)})).join(", ")+"]"]}return["["+("complex64"===n?Mr(e):Array.from(e)).map((function(e,t){return _r(e,a[t],n)})).join(", ")+"]"]}var d=t.slice(1),p=r.slice(1),v=r[0]*i,g=[];if(s>20){for(var m=0;m<3;m++){var y=(b=m*v)+v;g.push.apply(g,c(Ir(e.slice(b,y),d,n,p,a,!1)))}g.push("...");for(m=s-3;m<s;m++){y=(b=m*v)+v;g.push.apply(g,c(Ir(e.slice(b,y),d,n,p,a,m===s-1)))}}else for(m=0;m<s;m++){var b;y=(b=m*v)+v;g.push.apply(g,c(Ir(e.slice(b,y),d,n,p,a,m===s-1)))}var w=2===u?",":"";g[0]="["+g[0]+w;for(m=1;m<g.length-1;m++)g[m]=" "+g[m]+w;var k=",\n";for(m=2;m<u;m++)k+="\n";return g[g.length-1]=" "+g[g.length-1]+"]"+(o?"":k),g}function Mr(e){for(var t=[],n=0;n<e.length;n+=2)t.push([e[n],e[n+1]]);return t}var Tr=function(){function e(e,t,n){var r=this;if(this.dtype=t,this.shape=e.slice(),this.size=k(e),null!=n){var a=n.length;m(a===this.size,(function(){return"Length of values '"+a+"' does not match the size inferred by the shape '"+r.size+"'."}))}if("complex64"===t)throw new Error("complex64 dtype TensorBuffers are not supported. Please create a TensorBuffer for the real and imaginary parts separately and call tf.complex(real, imag).");this.values=n||I(t,this.size),this.strides=K(e)}return e.prototype.set=function(e){for(var t=this,n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];0===n.length&&(n=[0]),m(n.length===this.rank,(function(){return"The number of provided coordinates ("+n.length+") must match the rank ("+t.rank+")"}));var a=this.locToIndex(n);this.values[a]=e},e.prototype.get=function(){for(var e,t,n=[],r=0;r<arguments.length;r++)n[r]=arguments[r];0===n.length&&(n=[0]);var a=0;try{for(var o=u(n),i=o.next();!i.done;i=o.next()){var s=i.value;if(s<0||s>=this.shape[a]){var l="Requested out of range element at "+n+".   Buffer shape="+this.shape;throw new Error(l)}a++}}catch(t){e={error:t}}finally{try{i&&!i.done&&(t=o.return)&&t.call(o)}finally{if(e)throw e.error}}for(var c=n[n.length-1],h=0;h<n.length-1;++h)c+=this.strides[h]*n[h];return this.values[c]},e.prototype.locToIndex=function(e){if(0===this.rank)return 0;if(1===this.rank)return e[0];for(var t=e[e.length-1],n=0;n<e.length-1;++n)t+=this.strides[n]*e[n];return t},e.prototype.indexToLoc=function(e){if(0===this.rank)return[];if(1===this.rank)return[e];for(var t=new Array(this.shape.length),n=0;n<t.length-1;++n)t[n]=Math.floor(e/this.strides[n]),e-=t[n]*this.strides[n];return t[t.length-1]=e,t},Object.defineProperty(e.prototype,"rank",{get:function(){return this.shape.length},enumerable:!0,configurable:!0}),e.prototype.toTensor=function(){return Dr().makeTensor(this.values,this.shape,this.dtype)},e}(),Dr=null,Rr=null;var Fr=function(){function e(e,t,n,r){this.kept=!1,this.isDisposedInternal=!1,this.shape=e.slice(),this.dtype=t||"float32",this.size=k(e),this.strides=K(e),this.dataId=n,this.id=r,this.rankType=this.rank<5?this.rank.toString():"higher"}return Object.defineProperty(e.prototype,"rank",{get:function(){return this.shape.length},enumerable:!0,configurable:!0}),e.prototype.buffer=function(){return i(this,void 0,void 0,(function(){var e;return s(this,(function(t){switch(t.label){case 0:return[4,this.data()];case 1:return e=t.sent(),[2,Rr.buffer(this.shape,this.dtype,e)]}}))}))},e.prototype.bufferSync=function(){return Rr.buffer(this.shape,this.dtype,this.dataSync())},e.prototype.array=function(){return i(this,void 0,void 0,(function(){var e;return s(this,(function(t){switch(t.label){case 0:return[4,this.data()];case 1:return e=t.sent(),[2,W(this.shape,e,"complex64"===this.dtype)]}}))}))},e.prototype.arraySync=function(){return W(this.shape,this.dataSync(),"complex64"===this.dtype)},e.prototype.data=function(){return i(this,void 0,void 0,(function(){var e,t;return s(this,(function(n){switch(n.label){case 0:return this.throwIfDisposed(),e=Dr().read(this.dataId),"string"!==this.dtype?[3,2]:[4,e];case 1:t=n.sent();try{return[2,t.map((function(e){return kr(e)}))]}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}n.label=2;case 2:return[2,e]}}))}))},e.prototype.dataSync=function(){this.throwIfDisposed();var e=Dr().readSync(this.dataId);if("string"===this.dtype)try{return e.map((function(e){return kr(e)}))}catch(e){throw new Error("Failed to decode the string bytes into utf-8. To get the original bytes, call tensor.bytes().")}return e},e.prototype.bytes=function(){return i(this,void 0,void 0,(function(){var e;return s(this,(function(t){switch(t.label){case 0:return this.throwIfDisposed(),[4,Dr().read(this.dataId)];case 1:return e=t.sent(),"string"===this.dtype?[2,e]:[2,new Uint8Array(e.buffer)]}}))}))},e.prototype.dispose=function(){this.isDisposed||(Dr().disposeTensor(this),this.isDisposedInternal=!0)},Object.defineProperty(e.prototype,"isDisposed",{get:function(){return this.isDisposedInternal},enumerable:!0,configurable:!0}),e.prototype.throwIfDisposed=function(){if(this.isDisposed)throw new Error("Tensor is disposed.")},e.prototype.print=function(e){return void 0===e&&(e=!1),Rr.print(this,e)},e.prototype.clone=function(){return this.throwIfDisposed(),Rr.clone(this)},e.prototype.toString=function(e){return void 0===e&&(e=!1),Ar(this.dataSync(),this.shape,this.dtype,e)},e.prototype.cast=function(e){return this.throwIfDisposed(),Rr.cast(this,e)},e.prototype.variable=function(e,t,n){return void 0===e&&(e=!0),this.throwIfDisposed(),Dr().makeVariable(this,e,t,n)},e}();Object.defineProperty(Fr,Symbol.hasInstance,{value:function(e){return!!e&&null!=e.data&&null!=e.dataSync&&null!=e.throwIfDisposed}}),te("Tensor",(function(){return Fr}));var Br,Cr,Pr,Or,Lr,zr=function(e){function t(t,n,r,a){var o=e.call(this,t.shape,t.dtype,t.dataId,a)||this;return o.trainable=n,o.name=r,o}return o(t,e),t.prototype.assign=function(e){if(e.dtype!==this.dtype)throw new Error("dtype of the new value ("+e.dtype+") and previous value ("+this.dtype+") must match");if(!x(e.shape,this.shape))throw new Error("shape of the new value ("+e.shape+") and previous value ("+this.shape+") must match");Dr().disposeTensor(this),this.dataId=e.dataId,Dr().incRef(this,null)},t.prototype.dispose=function(){Dr().disposeVariable(this),this.isDisposedInternal=!0},t}(Fr);Object.defineProperty(zr,Symbol.hasInstance,{value:function(e){return e instanceof Fr&&null!=e.assign&&e.assign instanceof Function}}),e.Rank=void 0,(Br=e.Rank||(e.Rank={})).R0="R0",Br.R1="R1",Br.R2="R2",Br.R3="R3",Br.R4="R4",Br.R5="R5",Br.R6="R6",function(e){e.float32="float32",e.int32="int32",e.bool="int32",e.complex64="complex64"}(Cr||(Cr={})),function(e){e.float32="float32",e.int32="int32",e.bool="bool",e.complex64="complex64"}(Pr||(Pr={})),function(e){e.float32="float32",e.int32="float32",e.bool="float32",e.complex64="complex64"}(Or||(Or={})),function(e){e.float32="complex64",e.int32="complex64",e.bool="complex64",e.complex64="complex64"}(Lr||(Lr={}));var Kr={float32:Or,int32:Cr,bool:Pr,complex64:Lr};function qr(e,t){if("string"===e||"string"===t){if("string"===e&&"string"===t)return"string";throw new Error("Can not upcast "+e+" with "+t)}return Kr[e][t]}function Wr(e,t){if(e.dtype===t.dtype)return[e,t];var n=qr(e.dtype,t.dtype);return[e.cast(n),t.cast(n)]}function Ur(e,t){m(e.dtype===t.dtype,(function(){return"The dtypes of the first("+e.dtype+") and second("+t.dtype+") input must match"}))}function Gr(e){var t=[];return Hr(e,t,new Set),t}function Hr(e,t,n){if(null!=e)if(e instanceof Fr)t.push(e);else if(r=e,Array.isArray(r)||"object"==typeof r){var r,a=e;for(var o in a){var i=a[o];n.has(i)||(n.add(i),Hr(i,t,n))}}}var Vr={__proto__:null,makeTypesMatch:Wr,assertTypesMatch:Ur,isTensorInList:function(e,t){return t.some((function(t){return t.id===e.id}))},getTensorsInContainer:Gr};function jr(e){return null!=e.kernelName}var Jr=function(){function e(){this.registeredVariables={},this.nextTapeNodeId=0,this.numBytes=0,this.numTensors=0,this.numStringTensors=0,this.numDataBuffers=0,this.gradientDepth=0,this.kernelDepth=0,this.scopeStack=[],this.numDataMovesStack=[],this.nextScopeId=0,this.tensorInfo=new WeakMap,this.profiling=!1,this.activeProfile={newBytes:0,newTensors:0,peakBytes:0,kernels:[],result:null,get kernelNames(){return Array.from(new Set(this.kernels.map((function(e){return e.name}))))}}}return e.prototype.dispose=function(){for(var e in this.registeredVariables)this.registeredVariables[e].dispose()},e}(),Zr=function(){function e(e){this.ENV=e,this.registry={},this.registryFactory={},this.pendingBackendInitId=0,this.state=new Jr}return e.prototype.ready=function(){return i(this,void 0,void 0,(function(){var e,t,n;return s(this,(function(r){switch(r.label){case 0:if(null!=this.pendingBackendInit)return[2,this.pendingBackendInit.then((function(){}))];if(null!=this.backendInstance)return[2];e=this.getSortedBackends(),t=0,r.label=1;case 1:return t<e.length?(n=e[t],[4,this.initializeBackend(n).success]):[3,5];case 2:return r.sent()?[4,this.setBackend(n)]:[3,4];case 3:return r.sent(),[2];case 4:return t++,[3,1];case 5:throw new Error("Could not initialize any backends, all backend initializations failed.")}}))}))},Object.defineProperty(e.prototype,"backend",{get:function(){if(null!=this.pendingBackendInit)throw new Error("Backend '"+this.backendName+"' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods");if(null==this.backendInstance){var e=this.initializeBackendsAndReturnBest(),t=e.name;if(e.asyncInit)throw new Error("The highest priority backend '"+t+"' has not yet been initialized. Make sure to await tf.ready() or await tf.setBackend() before calling other methods");this.setBackend(t)}return this.backendInstance},enumerable:!0,configurable:!0}),e.prototype.backendNames=function(){return Object.keys(this.registryFactory)},e.prototype.findBackend=function(e){if(!(e in this.registry)){if(!(e in this.registryFactory))return null;if(this.initializeBackend(e).asyncInit)return null}return this.registry[e]},e.prototype.findBackendFactory=function(e){return e in this.registryFactory?this.registryFactory[e].factory:null},e.prototype.registerBackend=function(e,t,n){return void 0===n&&(n=1),e in this.registryFactory?(j(e+" backend was already registered. Reusing existing backend factory."),!1):(this.registryFactory[e]={factory:t,priority:n},!0)},e.prototype.setBackend=function(e){return i(this,void 0,void 0,(function(){var t,n,r;return s(this,(function(a){switch(a.label){case 0:if(null==this.registryFactory[e])throw new Error("Backend name '"+e+"' not found in registry");return this.backendName=e,null!=this.registry[e]?[3,4]:(this.backendInstance=null,t=this.initializeBackend(e),n=t.success,t.asyncInit?[4,n]:[3,2]);case 1:return r=a.sent(),[3,3];case 2:r=n,a.label=3;case 3:if(!r)return[2,!1];a.label=4;case 4:return this.backendInstance=this.registry[e],this.setupRegisteredKernels(),this.profiler=new Er(this.backendInstance),[2,!0]}}))}))},e.prototype.setupRegisteredKernels=function(){var e=this;Rn(this.backendName).forEach((function(t){null!=t.setupFunc&&t.setupFunc(e.backendInstance)}))},e.prototype.disposeRegisteredKernels=function(e){var t=this;Rn(e).forEach((function(n){null!=n.disposeFunc&&n.disposeFunc(t.registry[e])}))},e.prototype.initializeBackend=function(e){var t=this,n=this.registryFactory[e];if(null==n)throw new Error("Cannot initialize backend "+e+", no registration found.");try{var r=n.factory();if(!r||r instanceof f||"function"!=typeof r.then)return this.registry[e]=r,{success:!0,asyncInit:!1};var a=++this.pendingBackendInitId,o=r.then((function(n){return!(a<t.pendingBackendInitId)&&(t.registry[e]=n,t.pendingBackendInit=null,!0)})).catch((function(n){return a<t.pendingBackendInitId||(t.pendingBackendInit=null,j("Initialization of backend "+e+" failed"),j(n.stack||n.message)),!1}));return this.pendingBackendInit=o,{success:o,asyncInit:!0}}catch(t){return j("Initialization of backend "+e+" failed"),j(t.stack||t.message),{success:!1,asyncInit:!1}}},e.prototype.removeBackend=function(e){if(!(e in this.registryFactory))throw new Error(e+" backend not found in registry");this.backendName===e&&null!=this.pendingBackendInit&&this.pendingBackendInitId++,e in this.registry&&(this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e]),delete this.registryFactory[e],this.backendName===e&&(this.pendingBackendInit=null,this.backendName=null,this.backendInstance=null)},e.prototype.getSortedBackends=function(){var e=this;if(0===Object.keys(this.registryFactory).length)throw new Error("No backend found in registry.");return Object.keys(this.registryFactory).sort((function(t,n){return e.registryFactory[n].priority-e.registryFactory[t].priority}))},e.prototype.initializeBackendsAndReturnBest=function(){for(var e=this.getSortedBackends(),t=0;t<e.length;t++){var n=e[t],r=this.initializeBackend(n),a=r.success,o=r.asyncInit;if(o||a)return{name:n,asyncInit:o}}throw new Error("Could not initialize any backends, all backend initializations failed.")},e.prototype.moveData=function(e,t){var n=this.state.tensorInfo.get(t),r=n.backend,a=this.readSync(t),o=r.refCount(t);r.disposeData(t,!0),n.backend=e,e.move(t,a,n.shape,n.dtype,o),this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack[this.state.numDataMovesStack.length-1]++},e.prototype.tidy=function(e,t){var n,r=this,a=null;if(null==t){if("function"!=typeof e)throw new Error("Please provide a function to tidy()");t=e}else{if("string"!=typeof e&&!(e instanceof String))throw new Error("When calling with two arguments, the first argument to tidy() must be a string");if("function"!=typeof t)throw new Error("When calling with two arguments, the 2nd argument to tidy() must be a function");a=e}return this.scopedRun((function(){return r.startScope(a)}),(function(){return r.endScope(n)}),(function(){return(n=t())instanceof Promise&&console.error("Cannot return a Promise inside of tidy."),n}))},e.prototype.scopedRun=function(e,t,n){e();try{var r=n();return t(),r}catch(e){throw t(),e}},e.prototype.nextTensorId=function(){return e.nextTensorId++},e.prototype.nextVariableId=function(){return e.nextVariableId++},e.prototype.clone=function(e){var t=$r.runKernel(et,{x:e}),n={x:e};return this.addTapeNode(this.state.activeScope.name,n,[t],(function(e){return{x:function(){var t={x:e},n={dtype:"float32"};return $r.runKernel(be,t,n)}}}),[],{}),t},e.prototype.runKernel=function(e,t,n){if(null==this.backendName&&this.backend,!(null!=Tn(e,this.backendName)))throw new Error("Kernel '"+e+"' not registered for backend '"+this.backendName+"'");return this.runKernelFunc({kernelName:e,inputs:t,attrs:n})},e.prototype.shouldCheckForMemLeaks=function(){return this.ENV.getBool("IS_TEST")},e.prototype.checkKernelForMemLeak=function(e,t,n){var r=this.backend.numDataIds(),a=0;n.forEach((function(e){a+="complex64"===e.dtype?3:1}));var o=this.state.numDataMovesStack[this.state.numDataMovesStack.length-1],i=r-t-a-o;if(i>0)throw new Error("Backend '"+this.backendName+"' has an internal memory leak ("+i+" data ids) after running '"+e+"'")},e.prototype.runKernelFunc=function(e){var t,n,r,a=this,o=[],i=this.isTapeOn(),s=this.state.numBytes,u=this.state.numTensors;this.shouldCheckForMemLeaks()&&this.state.numDataMovesStack.push(0),null==this.backendName&&this.backend;var l=jr(e)?e.kernelName:null!=this.state.activeScope?this.state.activeScope.name:"";if(jr(e)){var c=e.kernelName,h=e.inputs,f=e.attrs;null==this.backendName&&this.backend;var d=Tn(c,this.backendName);m(null!=d,(function(){return"Cannot find registered kernel '"+c+"' for backend '"+a.backendName+"'"})),n=function(){var e=a.backend.numDataIds();r=d.kernelFunc({inputs:h,attrs:f,backend:a.backend});var t=Array.isArray(r)?r:[r];a.shouldCheckForMemLeaks()&&a.checkKernelForMemLeak(c,e,t);var n=t.map((function(e){if(null!=e.rank)return e;var t=e.dataId,n=e.shape,r=e.dtype;return a.makeTensorFromDataId(t,n,r)}));if(i){var s=a.getTensorsForGradient(c,h,n);o=a.saveTensorsForBackwardMode(s)}return n}}else{var p=e.forwardFunc,v=function(e){i&&(o=e.map((function(e){return a.keep(a.clone(e))})))};n=function(){var e=a.backend.numDataIds();r=a.tidy((function(){return p(a.backend,v)}));var t=Array.isArray(r)?r:[r];return a.shouldCheckForMemLeaks()&&a.checkKernelForMemLeak(l,e,t),t}}var g,y=e.inputs,b=e.attrs,w=jr(e)?null:e.backwardsFunc;return this.scopedRun((function(){return a.state.kernelDepth++}),(function(){return a.state.kernelDepth--}),(function(){a.ENV.getBool("DEBUG")||a.state.profiling?(g=a.profiler.profileKernel(l,y,(function(){return n()})),a.ENV.getBool("DEBUG")&&a.profiler.logKernelProfile(g),t=g.outputs):t=n()})),i&&this.addTapeNode(l,y,t,w,o,b),this.state.profiling&&this.state.activeProfile.kernels.push({name:l,bytesAdded:this.state.numBytes-s,totalBytesSnapshot:this.state.numBytes,tensorsAdded:this.state.numTensors-u,totalTensorsSnapshot:this.state.numTensors,inputShapes:Object.keys(y).map((function(e){return null!=y[e]?y[e].shape:null})),outputShapes:t.map((function(e){return e.shape})),kernelTimeMs:g.timeMs,extraInfo:g.extraInfo}),Array.isArray(r)?t:t[0]},e.prototype.saveTensorsForBackwardMode=function(e){var t=this;return e.map((function(e){return t.keep(t.clone(e))}))},e.prototype.getTensorsForGradient=function(e,t,n){var r=Dn(e);if(null!=r){var a=r.inputsToSave||[],o=r.outputsToSave||[],i=void 0;r.saveAllInputs?(m(Array.isArray(t),(function(){return"saveAllInputs is true, expected inputs to be an array."})),i=Object.keys(t).map((function(e){return t[e]}))):i=a.map((function(e){return t[e]}));var s=n.filter((function(e,t){return o[t]}));return i.concat(s)}return[]},e.prototype.makeTensor=function(e,t,n,r){if(null==e)throw new Error("Values passed to engine.makeTensor() are null");n=n||"float32",r=r||this.backend;var a=e;"string"===n&&B(e[0])&&(a=e.map((function(e){return wr(e)})));var o=r.write(a,t,n),i=new Fr(t,n,o,this.nextTensorId());if(this.trackTensor(i,r),"string"===n){var s=this.state.tensorInfo.get(o),u=F(a);this.state.numBytes+=u-s.bytes,s.bytes=u}return i},e.prototype.makeTensorFromDataId=function(e,t,n,r){var a=new Fr(t,n=n||"float32",e,this.nextTensorId());return this.trackTensor(a,r),a},e.prototype.makeVariable=function(e,t,n,r){void 0===t&&(t=!0),n=n||this.nextVariableId().toString(),null!=r&&r!==e.dtype&&(e=e.cast(r));var a=new zr(e,t,n,this.nextTensorId());if(null!=this.state.registeredVariables[a.name])throw new Error("Variable with name "+a.name+" was already registered");return this.state.registeredVariables[a.name]=a,this.incRef(a,this.backend),a},e.prototype.trackTensor=function(e,t){this.state.numTensors++,"string"===e.dtype&&this.state.numStringTensors++;var n=0;"complex64"!==e.dtype&&"string"!==e.dtype&&(n=e.size*R(e.dtype)),this.state.numBytes+=n,this.state.tensorInfo.has(e.dataId)||(this.state.numDataBuffers++,this.state.tensorInfo.set(e.dataId,{backend:t||this.backend,dtype:e.dtype,shape:e.shape,bytes:n})),e instanceof zr||this.track(e)},e.prototype.incRef=function(e,t){this.trackTensor(e,t),this.backend.incRef(e.dataId)},e.prototype.removeDataId=function(e,t){this.state.tensorInfo.has(e)&&this.state.tensorInfo.get(e).backend===t&&(this.state.tensorInfo.delete(e),this.state.numDataBuffers--)},e.prototype.disposeTensor=function(e){if(this.state.tensorInfo.has(e.dataId)){var t=this.state.tensorInfo.get(e.dataId);if(this.state.numTensors--,"string"===e.dtype&&(this.state.numStringTensors--,this.state.numBytes-=t.bytes),"complex64"!==e.dtype&&"string"!==e.dtype){var n=e.size*R(e.dtype);this.state.numBytes-=n}t.backend.disposeData(e.dataId)&&this.removeDataId(e.dataId,t.backend)}},e.prototype.disposeVariables=function(){for(var e in this.state.registeredVariables){var t=this.state.registeredVariables[e];this.disposeVariable(t)}},e.prototype.disposeVariable=function(e){this.disposeTensor(e),null!=this.state.registeredVariables[e.name]&&delete this.state.registeredVariables[e.name]},e.prototype.memory=function(){var e=this.backend.memory();return e.numTensors=this.state.numTensors,e.numDataBuffers=this.state.numDataBuffers,e.numBytes=this.state.numBytes,this.state.numStringTensors>0&&(e.unreliable=!0,null==e.reasons&&(e.reasons=[]),e.reasons.push("Memory usage by string tensors is approximate (2 bytes per character)")),e},e.prototype.profile=function(e){return i(this,void 0,void 0,(function(){var t,n,r,a,o,i,l,h,f,d,p;return s(this,(function(s){switch(s.label){case 0:return this.state.profiling=!0,t=this.state.numBytes,n=this.state.numTensors,this.state.activeProfile.kernels=[],r=this.state.activeProfile,[4,e()];case 1:r.result=s.sent(),this.state.profiling=!1,this.state.activeProfile.peakBytes=Math.max.apply(Math,c(this.state.activeProfile.kernels.map((function(e){return e.totalBytesSnapshot})))),this.state.activeProfile.newBytes=this.state.numBytes-t,this.state.activeProfile.newTensors=this.state.numTensors-n,s.label=2;case 2:s.trys.push([2,8,9,10]),a=u(this.state.activeProfile.kernels),o=a.next(),s.label=3;case 3:return o.done?[3,7]:(i=o.value,l=i,[4,i.kernelTimeMs]);case 4:return l.kernelTimeMs=s.sent(),h=i,[4,i.extraInfo];case 5:h.extraInfo=s.sent(),s.label=6;case 6:return o=a.next(),[3,3];case 7:return[3,10];case 8:return f=s.sent(),d={error:f},[3,10];case 9:try{o&&!o.done&&(p=a.return)&&p.call(a)}finally{if(d)throw d.error}return[7];case 10:return[2,this.state.activeProfile]}}))}))},e.prototype.isTapeOn=function(){return this.state.gradientDepth>0&&0===this.state.kernelDepth},e.prototype.addTapeNode=function(e,t,n,r,a,o){var i=this,s={id:this.state.nextTapeNodeId++,kernelName:e,inputs:t,outputs:n,saved:a},u=Dn(e);null!=u&&(r=u.gradFunc),null!=r&&(s.gradient=function(e){return e=e.map((function(e,t){if(null==e){var r=n[t],a=G(r.size,r.dtype);return i.makeTensor(a,r.shape,r.dtype)}return e})),r(e.length>1?e:e[0],a,o)}),this.state.activeTape.push(s)},e.prototype.keep=function(e){return e.kept=!0,e},e.prototype.startTape=function(){0===this.state.gradientDepth&&(this.state.activeTape=[]),this.state.gradientDepth++},e.prototype.endTape=function(){this.state.gradientDepth--},e.prototype.startScope=function(e){var t={track:[],name:"unnamed scope",id:this.state.nextScopeId++};e&&(t.name=e),this.state.scopeStack.push(t),this.state.activeScope=t},e.prototype.endScope=function(e){for(var t=this,n=Gr(e),r=new Set(n.map((function(e){return e.id}))),a=0;a<this.state.activeScope.track.length;a++){var o=this.state.activeScope.track[a];o.kept||r.has(o.id)||o.dispose()}var i=this.state.scopeStack.pop();this.state.activeScope=0===this.state.scopeStack.length?null:this.state.scopeStack[this.state.scopeStack.length-1],n.forEach((function(e){e.kept||e.scopeId!==i.id||t.track(e)}))},e.prototype.gradients=function(e,t,n,r){var a=this;if(void 0===r&&(r=!1),m(t.length>0,(function(){return"gradients() received an empty list of xs."})),null!=n&&"float32"!==n.dtype)throw new Error("dy must have 'float32' dtype, but has '"+n.dtype+"'");var o=this.scopedRun((function(){return a.startTape()}),(function(){return a.endTape()}),(function(){return a.tidy("forward",e)}));m(o instanceof Fr,(function(){return"The result y returned by f() must be a tensor."}));var i=function(e,t,n){for(var r={},a={},o=0;o<t.length;o++)r[t[o].id]=!0;for(o=0;o<e.length;o++){var i=(p=e[o]).inputs;for(var s in i){for(var u=i[s],l=!1,c=0;c<t.length;c++)if(r[u.id]){p.outputs.forEach((function(e){return r[e.id]=!0})),l=!0,a[p.id]=!0;break}if(l)break}}var h={};h[n.id]=!0;var f={};for(o=e.length-1;o>=0;o--)for(i=(p=e[o]).inputs,c=0;c<p.outputs.length;c++)if(h[p.outputs[c].id]){for(var s in i)h[i[s].id]=!0,f[p.id]=!0;break}var d=[];for(o=0;o<e.length;o++){var p;if(a[(p=e[o]).id]&&f[p.id]){var v={};for(var s in p.inputs){var g=p.inputs[s];r[g.id]&&(v[s]=g)}var m=Object.assign({},p);m.inputs=v,m.outputs=p.outputs,d.push(m)}}return d}(this.state.activeTape,t,o);if(!r&&0===i.length&&t.length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that the f you passed encloses all operations that lead from x to y.");return this.tidy("backward",(function(){var e,r,s={};s[o.id]=null==n?(e=o.shape,r=U(k(e),"float32"),$r.makeTensor(r,e,"float32")):n,function(e,t,n,r){for(var a=function(a){var o=t[a],i=[];if(o.outputs.forEach((function(t){var n=e[t.id];null!=n?i.push(n):i.push(null)})),null==o.gradient)throw new Error("Cannot compute gradient: gradient function not found for "+o.kernelName+".");var s=o.gradient(i),u=function(t){if(!(t in s))throw new Error("Cannot backprop through input "+t+". Available gradients found: "+Object.keys(s)+".");var a=n((function(){return s[t]()}));if("float32"!==a.dtype)throw new Error("Error in gradient for op "+o.kernelName+". The gradient of input "+t+" must have 'float32' dtype, but has '"+a.dtype+"'");var i=o.inputs[t];if(!x(a.shape,i.shape))throw new Error("Error in gradient for op "+o.kernelName+". The gradient of input '"+t+"' has shape '"+a.shape+"', which does not match the shape of the input '"+i.shape+"'");if(null==e[i.id])e[i.id]=a;else{var u=e[i.id];e[i.id]=r(u,a),u.dispose()}};for(var l in o.inputs)u(l)},o=t.length-1;o>=0;o--)a(o)}(s,i,(function(e){return a.tidy(e)}),Qr);var l=t.map((function(e){return s[e.id]}));return 0===a.state.gradientDepth&&(a.state.activeTape.forEach((function(e){var t,n;try{for(var r=u(e.saved),a=r.next();!a.done;a=r.next()){a.value.dispose()}}catch(e){t={error:e}}finally{try{a&&!a.done&&(n=r.return)&&n.call(r)}finally{if(t)throw t.error}}})),a.state.activeTape=null),{value:o,grads:l}}))},e.prototype.customGrad=function(e){var t=this;return m(L(e),(function(){return"The f passed in customGrad(f) must be a function."})),function(){for(var n,r=[],a=0;a<arguments.length;a++)r[a]=arguments[a];m(r.every((function(e){return e instanceof Fr})),(function(){return"The args passed in customGrad(f)(x1, x2,...) must all be tensors"}));var o={};r.forEach((function(e,t){o[t]=e}));var i=function(t,a){return m((n=e.apply(void 0,c(r,[a]))).value instanceof Fr,(function(){return"The function f passed in customGrad(f) must return an object where `obj.value` is a tensor"})),m(L(n.gradFunc),(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function."})),n.value},s=function(e,t){var a=n.gradFunc(e,t),o=Array.isArray(a)?a:[a];m(o.length===r.length,(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns the same number of tensors as inputs passed to f(...)."})),m(o.every((function(e){return e instanceof Fr})),(function(){return"The function f passed in customGrad(f) must return an object where `obj.gradFunc` is a function that returns a list of only tensors."}));var i={};return o.forEach((function(e,t){i[t]=function(){return e}})),i};return t.runKernelFunc({forwardFunc:i,backwardsFunc:s,inputs:o})}},e.prototype.readSync=function(e){return this.state.tensorInfo.get(e).backend.readSync(e)},e.prototype.read=function(e){return this.state.tensorInfo.get(e).backend.read(e)},e.prototype.time=function(e){return i(this,void 0,void 0,(function(){var t,n;return s(this,(function(r){switch(r.label){case 0:return t=br(),[4,this.backend.time(e)];case 1:return(n=r.sent()).wallMs=br()-t,[2,n]}}))}))},e.prototype.track=function(e){return null!=this.state.activeScope&&(e.scopeId=this.state.activeScope.id,this.state.activeScope.track.push(e)),e},Object.defineProperty(e.prototype,"registeredVariables",{get:function(){return this.state.registeredVariables},enumerable:!0,configurable:!0}),e.prototype.reset=function(){for(var e in this.pendingBackendInitId++,this.state.dispose(),this.ENV.reset(),this.state=new Jr,this.registry)this.disposeRegisteredKernels(e),this.registry[e].dispose(),delete this.registry[e];this.backendName=null,this.backendInstance=null,this.pendingBackendInit=null},e}();function Yr(){var t=ee();if(null==t._tfengine){var n=new Y(t);t._tfengine=new Zr(n)}return function(t){e.ENV=t}(t._tfengine.ENV),Dr=function(){return t._tfengine},t._tfengine}Zr.nextTensorId=0,Zr.nextVariableId=0;var Xr,$r=Yr();function Qr(e,t){var n={a:e,b:t};return $r.runKernel(ae,n)}function ea(){return"undefined"!=typeof window&&null!=window.document||"undefined"!=typeof WorkerGlobalScope}var ta={__proto__:null,mockIsMobile:function(e){Xr=e},isMobile:function(e){if(void 0!==Xr)return Xr;if(e||"undefined"!=typeof navigator&&null!=navigator){if(e||(e=navigator),"ReactNative"===e.product)return!0;var t=e.userAgent||e.vendor||("undefined"!=typeof window?window.opera:"");if(!t){var n=e;return n.userAgentData&&n.userAgentData.mobile}return/(android|bb\d+|meego).+mobile|avantgo|bada\/|blackberry|blazer|compal|elaine|fennec|hiptop|iemobile|ip(hone|od)|iris|kindle|lge |maemo|midp|mmp|mobile.+firefox|netfront|opera m(ob|in)i|palm( os)?|phone|p(ixi|re)\/|plucker|pocket|psp|series(4|6)0|symbian|treo|up\.(browser|link)|vodafone|wap|windows ce|xda|xiino/i.test(t)||/1207|6310|6590|3gso|4thp|50[1-6]i|770s|802s|a wa|abac|ac(er|oo|s\-)|ai(ko|rn)|al(av|ca|co)|amoi|an(ex|ny|yw)|aptu|ar(ch|go)|as(te|us)|attw|au(di|\-m|r |s )|avan|be(ck|ll|nq)|bi(lb|rd)|bl(ac|az)|br(e|v)w|bumb|bw\-(n|u)|c55\/|capi|ccwa|cdm\-|cell|chtm|cldc|cmd\-|co(mp|nd)|craw|da(it|ll|ng)|dbte|dc\-s|devi|dica|dmob|do(c|p)o|ds(12|\-d)|el(49|ai)|em(l2|ul)|er(ic|k0)|esl8|ez([4-7]0|os|wa|ze)|fetc|fly(\-|_)|g1 u|g560|gene|gf\-5|g\-mo|go(\.w|od)|gr(ad|un)|haie|hcit|hd\-(m|p|t)|hei\-|hi(pt|ta)|hp( i|ip)|hs\-c|ht(c(\-| |_|a|g|p|s|t)|tp)|hu(aw|tc)|i\-(20|go|ma)|i230|iac( |\-|\/)|ibro|idea|ig01|ikom|im1k|inno|ipaq|iris|ja(t|v)a|jbro|jemu|jigs|kddi|keji|kgt( |\/)|klon|kpt |kwc\-|kyo(c|k)|le(no|xi)|lg( g|\/(k|l|u)|50|54|\-[a-w])|libw|lynx|m1\-w|m3ga|m50\/|ma(te|ui|xo)|mc(01|21|ca)|m\-cr|me(rc|ri)|mi(o8|oa|ts)|mmef|mo(01|02|bi|de|do|t(\-| |o|v)|zz)|mt(50|p1|v )|mwbp|mywa|n10[0-2]|n20[2-3]|n30(0|2)|n50(0|2|5)|n7(0(0|1)|10)|ne((c|m)\-|on|tf|wf|wg|wt)|nok(6|i)|nzph|o2im|op(ti|wv)|oran|owg1|p800|pan(a|d|t)|pdxg|pg(13|\-([1-8]|c))|phil|pire|pl(ay|uc)|pn\-2|po(ck|rt|se)|prox|psio|pt\-g|qa\-a|qc(07|12|21|32|60|\-[2-7]|i\-)|qtek|r380|r600|raks|rim9|ro(ve|zo)|s55\/|sa(ge|ma|mm|ms|ny|va)|sc(01|h\-|oo|p\-)|sdk\/|se(c(\-|0|1)|47|mc|nd|ri)|sgh\-|shar|sie(\-|m)|sk\-0|sl(45|id)|sm(al|ar|b3|it|t5)|so(ft|ny)|sp(01|h\-|v\-|v )|sy(01|mb)|t2(18|50)|t6(00|10|18)|ta(gt|lk)|tcl\-|tdg\-|tel(i|m)|tim\-|t\-mo|to(pl|sh)|ts(70|m\-|m3|m5)|tx\-9|up(\.b|g1|si)|utst|v400|v750|veri|vi(rg|te)|vk(40|5[0-3]|\-v)|vm40|voda|vulc|vx(52|53|60|61|70|80|81|83|85|98)|w3c(\-| )|webc|whit|wi(g |nc|nw)|wmlb|wonu|x700|yas\-|your|zeto|zte\-/i.test(t.substr(0,4))}return!1},isBrowser:ea},na=Q();function ra(e,t){var n=e;if(D(e))return"string"===t?[]:[e.length];if(!Array.isArray(e))return[];for(var r=[];Array.isArray(n)||D(n)&&"string"!==t;)r.push(n.length),n=n[0];return Array.isArray(e)&&Q().getBool("TENSORLIKE_CHECK_SHAPE_CONSISTENCY")&&aa(e,r,[]),r}function aa(e,t,n){if(n=n||[],Array.isArray(e)||D(e)){m(t.length>0,(function(){return"Element arr["+n.join("][")+"] should be a primitive, but is an array of "+e.length+" elements"})),m(e.length===t[0],(function(){return"Element arr["+n.join("][")+"] should have "+t[0]+" elements, but has "+e.length+" elements"}));for(var r=t.slice(1),a=0;a<e.length;++a)aa(e[a],r,n.concat(a))}else m(0===t.length,(function(){return"Element arr["+n.join("][")+"] is a primitive, but should be an array/TypedArray of "+t[0]+" elements"}))}function oa(e,t,n,r){if("string_or_numeric"!==e){if(null==e)throw new Error("Expected dtype cannot be null.");if("numeric"!==e&&e!==t||"numeric"===e&&"string"===t)throw new Error("Argument '"+n+"' passed to '"+r+"' must be "+e+" tensor, but got "+t+" tensor")}}function ia(e,t,n,r){if(void 0===r&&(r="numeric"),e instanceof Fr)return oa(r,e.dtype,t,n),e;var a=O(e);if("string"!==a&&["bool","int32","float32"].indexOf(r)>=0&&(a=r),oa(r,a,t,n),null==e||!D(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e){var o=null==e?"null":e.constructor.name;throw new Error("Argument '"+t+"' passed to '"+n+"' must be a Tensor or TensorLike, but got '"+o+"'")}var i=ra(e,a);D(e)||Array.isArray(e)||(e=[e]);var s="string"!==a?yr(e,a):w(e,[],!0);return $r.makeTensor(s,i,a)}function sa(e,t,n,r){if(void 0===r&&(r="numeric"),!Array.isArray(e))throw new Error("Argument "+t+" passed to "+n+" must be a `Tensor[]` or `TensorLike[]`");return e.map((function(e,a){return ia(e,t+"["+a+"]",n,r)}))}na.registerFlag("DEBUG",(function(){return!1}),(function(e){e&&console.warn("Debugging mode is ON. The output of every math call will be downloaded to CPU and checked for NaNs. This significantly impacts performance.")})),na.registerFlag("IS_BROWSER",(function(){return ea()})),na.registerFlag("IS_NODE",(function(){return"undefined"!=typeof process&&"undefined"!=typeof process.versions&&"undefined"!=typeof process.versions.node})),na.registerFlag("IS_CHROME",(function(){return"undefined"!=typeof navigator&&null!=navigator&&null!=navigator.userAgent&&/Chrome/.test(navigator.userAgent)&&/Google Inc/.test(navigator.vendor)})),na.registerFlag("PROD",(function(){return!1})),na.registerFlag("TENSORLIKE_CHECK_SHAPE_CONSISTENCY",(function(){return na.getBool("DEBUG")})),na.registerFlag("DEPRECATION_WARNINGS_ENABLED",(function(){return!0})),na.registerFlag("IS_TEST",(function(){return!1})),na.registerFlag("CHECK_COMPUTATION_FOR_ERRORS",(function(){return!0})),na.registerFlag("WRAP_TO_IMAGEBITMAP",(function(){return!1}));var ua="__op";function la(e){var t=Object.keys(e);if(1!==t.length)throw new Error("Please provide an object with a single key (operation name) mapping to a function. Got an object with "+t.length+" keys.");var n=t[0],r=e[n];n.endsWith("_")&&(n=n.substring(0,n.length-1)),n+=ua;var a=function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];$r.startScope(n);try{var a=r.apply(void 0,c(e));return V(a)&&console.error("Cannot return a Promise inside of tidy."),$r.endScope(a),a}catch(e){throw $r.endScope(null),e}};return Object.defineProperty(a,"name",{value:n,configurable:!0}),a}var ca=la({complex_:function(e,t){var n=ia(e,"real","complex"),r=ia(t,"imag","complex");y(n.shape,r.shape,"real and imag shapes, "+n.shape+" and "+r.shape+", must match in call to tf.complex().");var a={real:n,imag:r};return $r.runKernel(xe,a)}});function ha(e,t,n,r){if(null==r&&(r=O(e)),"complex64"===r)throw new Error("Cannot construct a complex64 tensor directly. Please use tf.complex(real, imag).");if(!D(e)&&!Array.isArray(e)&&"number"!=typeof e&&"boolean"!=typeof e&&"string"!=typeof e)throw new Error("values passed to tensor(values) must be a number/boolean/string or an array of numbers/booleans/strings, or a TypedArray");if(null!=t){H(t);var a=k(t),o=k(n);m(a===o,(function(){return"Based on the provided shape, ["+t+"], the tensor should have "+a+" values but has "+o}));for(var i=0;i<n.length;++i){var s=n[i],u=i!==n.length-1||s!==k(t.slice(i));m(n[i]===t[i]||!u,(function(){return"Error creating a new Tensor. Inferred shape ("+n+") does not match the provided shape ("+t+"). "}))}}return D(e)||Array.isArray(e)||(e=[e]),t=t||n,e="string"!==r?yr(e,r):w(e,[],!0),$r.makeTensor(e,t,r)}function fa(e,t,n){return ha(e,t,ra(e,n),n)}var da={float32:4,float16:2,int32:4,uint16:2,uint8:1,bool:1,complex64:8};function pa(e,t){var n,r,a,o={},i=0;try{for(var s=u(t),l=s.next();!l.done;l=s.next()){var c=l.value,h=c.name,f=c.dtype,d=c.shape,p=k(d),v=void 0;if("quantization"in c){var g=c.quantization;if("uint8"===g.dtype||"uint16"===g.dtype){if(!("min"in g)||!("scale"in g))throw new Error("Weight "+c.name+" with quantization "+g.dtype+" doesn't have corresponding metadata min and scale.")}else{if("float16"!==g.dtype)throw new Error("Weight "+c.name+" has unknown quantization dtype "+g.dtype+". Supported quantization dtypes are: 'uint8', 'uint16', and 'float16'.");if("float32"!==f)throw new Error("Weight "+c.name+" is quantized with "+g.dtype+" which only supports weights of type float32 not "+f+".")}var m=da[g.dtype],y=e.slice(i,i+p*m),b="uint8"===g.dtype?new Uint8Array(y):new Uint16Array(y);if("float32"===f)if("uint8"===g.dtype||"uint16"===g.dtype){v=new Float32Array(b.length);for(var w=0;w<b.length;w++){var x=b[w];v[w]=x*g.scale+g.min}}else{if("float16"!==g.dtype)throw new Error("Unsupported quantization type "+g.dtype+" for weight type float32.");void 0===a&&(a=Ea()),v=a(b)}else{if("int32"!==f)throw new Error("Unsupported dtype in weight '"+h+"': "+f);if("uint8"!==g.dtype&&"uint16"!==g.dtype)throw new Error("Unsupported quantization type "+g.dtype+" for weight type int32.");v=new Int32Array(b.length);for(w=0;w<b.length;w++){x=b[w];v[w]=Math.round(x*g.scale+g.min)}}i+=p*m}else if("string"===f){var E=k(c.shape);v=[];for(w=0;w<E;w++){var S=new Uint32Array(e.slice(i,i+4))[0];i+=4;var A=new Uint8Array(e.slice(i,i+S));v.push(A),i+=S}}else{var _=da[f];y=e.slice(i,i+p*_);if("float32"===f)v=new Float32Array(y);else if("int32"===f)v=new Int32Array(y);else if("bool"===f)v=new Uint8Array(y);else{if("complex64"!==f)throw new Error("Unsupported dtype in weight '"+h+"': "+f);v=new Float32Array(y);var N=new Float32Array(v.length/2),I=new Float32Array(v.length/2);for(w=0;w<N.length;w++)N[w]=v[2*w],I[w]=v[2*w+1];var M=fa(N,d,"float32"),T=fa(I,d,"float32");o[h]=ca(M,T),M.dispose(),T.dispose()}i+=p*_}"complex64"!==f&&(o[h]=fa(v,d,f))}}catch(e){n={error:e}}finally{try{l&&!l.done&&(r=s.return)&&r.call(s)}finally{if(n)throw n.error}}return o}function va(e){if(null===e)throw new Error("Invalid input value: "+JSON.stringify(e));var t=0,n=[];e.forEach((function(e){if(t+=e.byteLength,n.push(e.byteLength===e.buffer.byteLength?e:new e.constructor(e)),!(e instanceof Float32Array||e instanceof Int32Array||e instanceof Uint8Array))throw new Error("Unsupported TypedArray subtype: "+e.constructor.name)}));var r=new Uint8Array(t),a=0;return n.forEach((function(e){r.set(new Uint8Array(e.buffer),a),a+=e.byteLength})),r.buffer}var ga="undefined"!=typeof Buffer&&("undefined"==typeof Blob||"undefined"==typeof atob||"undefined"==typeof btoa);function ma(e){return ga?Buffer.byteLength(e):new Blob([e]).size}function ya(e){if(1===e.length)return e[0];var t=0;e.forEach((function(e){t+=e.byteLength}));var n=new Uint8Array(t),r=0;return e.forEach((function(e){n.set(new Uint8Array(e),r),r+=e.byteLength})),n.buffer}function ba(e){for(e=e.trim();e.endsWith("/");)e=e.slice(0,e.length-1);var t=e.split("/");return t[t.length-1]}function wa(e,t){var n={modelTopology:e.modelTopology,format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy,weightsManifest:t};return null!=e.signature&&(n.signature=e.signature),null!=e.userDefinedMetadata&&(n.userDefinedMetadata=e.userDefinedMetadata),null!=e.modelInitializer&&(n.modelInitializer=e.modelInitializer),null!=e.trainingConfig&&(n.trainingConfig=e.trainingConfig),n}function ka(e,t){return i(this,void 0,void 0,(function(){var n,r,a,o;return s(this,(function(i){switch(i.label){case 0:return n={modelTopology:e.modelTopology,format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy},null!=e.trainingConfig&&(n.trainingConfig=e.trainingConfig),null==e.weightsManifest?[3,2]:[4,t(e.weightsManifest)];case 1:r=l.apply(void 0,[i.sent(),2]),a=r[0],o=r[1],n.weightSpecs=a,n.weightData=o,i.label=2;case 2:return null!=e.signature&&(n.signature=e.signature),null!=e.userDefinedMetadata&&(n.userDefinedMetadata=e.userDefinedMetadata),null!=e.modelInitializer&&(n.modelInitializer=e.modelInitializer),[2,n]}}))}))}function xa(e){if(e.modelTopology instanceof ArrayBuffer)throw new Error("Expected JSON model topology, received ArrayBuffer.");return{dateSaved:new Date,modelTopologyType:"JSON",modelTopologyBytes:null==e.modelTopology?0:ma(JSON.stringify(e.modelTopology)),weightSpecsBytes:null==e.weightSpecs?0:ma(JSON.stringify(e.weightSpecs)),weightDataBytes:null==e.weightData?0:e.weightData.byteLength}}function Ea(){var e=function(){var e=function(e){for(var t=e<<13,n=0;0==(8388608&t);)n-=8388608,t<<=1;return(t&=-8388609)|n+947912704},t=new Uint32Array(2048);t[0]=0;for(var n=1;n<1024;n++)t[n]=e(n);for(n=1024;n<2048;n++)t[n]=939524096+(n-1024<<13);return t}(),t=function(){var e=new Uint32Array(64);e[0]=0,e[31]=1199570944,e[32]=2147483648,e[63]=3347054592;for(var t=1;t<31;t++)e[t]=t<<23;for(t=33;t<63;t++)e[t]=2147483648+(t-32<<23);return e}(),n=function(){for(var e=new Uint32Array(64),t=0;t<64;t++)e[t]=1024;return e[0]=e[32]=0,e}();return function(r){for(var a=new ArrayBuffer(4*r.length),o=new Uint32Array(a),i=0;i<r.length;i++){var s=r[i],u=e[n[s>>10]+(1023&s)]+t[s>>10];o[i]=u}return new Float32Array(a)}}var Sa=function(){function e(){this.saveRouters=[],this.loadRouters=[]}return e.getInstance=function(){return null==e.instance&&(e.instance=new e),e.instance},e.registerSaveRouter=function(t){e.getInstance().saveRouters.push(t)},e.registerLoadRouter=function(t){e.getInstance().loadRouters.push(t)},e.getSaveHandlers=function(t){return e.getHandlers(t,"save")},e.getLoadHandlers=function(t,n){return e.getHandlers(t,"load",n)},e.getHandlers=function(t,n,r){var a=[];return("load"===n?e.getInstance().loadRouters:e.getInstance().saveRouters).forEach((function(e){var n=e(t,r);null!==n&&a.push(n)})),a},e}(),Aa="tensorflowjs",_a="models_store",Na="model_info_store";function Ia(){if(!Q().getBool("IS_BROWSER"))throw new Error("Failed to obtain IndexedDB factory because the current environmentis not a web browser.");var e="undefined"==typeof window?self:window,t=e.indexedDB||e.mozIndexedDB||e.webkitIndexedDB||e.msIndexedDB||e.shimIndexedDB;if(null==t)throw new Error("The current browser does not appear to support IndexedDB.");return t}function Ma(e){var t=e.result;t.createObjectStore(_a,{keyPath:"modelPath"}),t.createObjectStore(Na,{keyPath:"modelPath"})}var Ta=function(){function e(e){if(this.indexedDB=Ia(),null==e||!e)throw new Error("For IndexedDB, modelPath must not be null, undefined or empty.");this.modelPath=e}return e.prototype.save=function(e){return i(this,void 0,void 0,(function(){return s(this,(function(t){if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");return[2,this.databaseAction(this.modelPath,e)]}))}))},e.prototype.load=function(){return i(this,void 0,void 0,(function(){return s(this,(function(e){return[2,this.databaseAction(this.modelPath)]}))}))},e.prototype.databaseAction=function(e,t){var n=this;return new Promise((function(e,r){var a=n.indexedDB.open(Aa,1);a.onupgradeneeded=function(){return Ma(a)},a.onsuccess=function(){var o=a.result;if(null==t){var i=o.transaction(_a,"readonly"),s=i.objectStore(_a).get(n.modelPath);s.onsuccess=function(){if(null==s.result)return o.close(),r(new Error("Cannot find model with path '"+n.modelPath+"' in IndexedDB."));e(s.result.modelArtifacts)},s.onerror=function(e){return o.close(),r(s.error)},i.oncomplete=function(){return o.close()}}else{var u,l=xa(t),c=o.transaction(Na,"readwrite"),h=c.objectStore(Na),f=h.put({modelPath:n.modelPath,modelArtifactsInfo:l});f.onsuccess=function(){var a=(u=o.transaction(_a,"readwrite")).objectStore(_a).put({modelPath:n.modelPath,modelArtifacts:t,modelArtifactsInfo:l});a.onsuccess=function(){return e({modelArtifactsInfo:l})},a.onerror=function(e){var t=(h=c.objectStore(Na)).delete(n.modelPath);t.onsuccess=function(){return o.close(),r(a.error)},t.onerror=function(e){return o.close(),r(a.error)}}},f.onerror=function(e){return o.close(),r(f.error)},c.oncomplete=function(){null==u?o.close():u.oncomplete=function(){return o.close()}}}},a.onerror=function(e){return r(a.error)}}))},e}();Ta.URL_SCHEME="indexeddb://";var Da=function(e){return Q().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(Ta.URL_SCHEME)?(t=e.slice(Ta.URL_SCHEME.length),new Ta(t)):null;var t};Sa.registerSaveRouter(Da),Sa.registerLoadRouter(Da);var Ra=function(){function e(){this.indexedDB=Ia()}return e.prototype.listModels=function(){return i(this,void 0,void 0,(function(){var e=this;return s(this,(function(t){return[2,new Promise((function(t,n){var r=e.indexedDB.open(Aa,1);r.onupgradeneeded=function(){return Ma(r)},r.onsuccess=function(){var e=r.result,a=e.transaction(Na,"readonly"),o=a.objectStore(Na).getAll();o.onsuccess=function(){var e,n,r={};try{for(var a=u(o.result),i=a.next();!i.done;i=a.next()){var s=i.value;r[s.modelPath]=s.modelArtifactsInfo}}catch(t){e={error:t}}finally{try{i&&!i.done&&(n=a.return)&&n.call(a)}finally{if(e)throw e.error}}t(r)},o.onerror=function(t){return e.close(),n(o.error)},a.oncomplete=function(){return e.close()}},r.onerror=function(e){return n(r.error)}}))]}))}))},e.prototype.removeModel=function(e){return i(this,void 0,void 0,(function(){var t=this;return s(this,(function(n){var r;return e=(r=e).startsWith(Ta.URL_SCHEME)?r.slice(Ta.URL_SCHEME.length):r,[2,new Promise((function(n,r){var a=t.indexedDB.open(Aa,1);a.onupgradeneeded=function(){return Ma(a)},a.onsuccess=function(){var t,o=a.result,i=o.transaction(Na,"readwrite"),s=i.objectStore(Na),u=s.get(e);u.onsuccess=function(){if(null==u.result)return o.close(),r(new Error("Cannot find model with path '"+e+"' in IndexedDB."));var a=s.delete(e),i=function(){var a=(t=o.transaction(_a,"readwrite")).objectStore(_a).delete(e);a.onsuccess=function(){return n(u.result.modelArtifactsInfo)},a.onerror=function(e){return r(u.error)}};a.onsuccess=i,a.onerror=function(e){return i(),o.close(),r(u.error)}},u.onerror=function(e){return o.close(),r(u.error)},i.oncomplete=function(){null==t?o.close():t.oncomplete=function(){return o.close()}}},a.onerror=function(e){return r(a.error)}}))]}))}))},e}(),Fa="/",Ba="tensorflowjs_models",Ca="info",Pa="model_topology",Oa="weight_specs",La="weight_data",za="model_metadata";function Ka(e){return{info:[Ba,e,Ca].join(Fa),topology:[Ba,e,Pa].join(Fa),weightSpecs:[Ba,e,Oa].join(Fa),weightData:[Ba,e,La].join(Fa),modelMetadata:[Ba,e,za].join(Fa)}}function qa(e){var t,n;try{for(var r=u(Object.values(e)),a=r.next();!a.done;a=r.next()){var o=a.value;window.localStorage.removeItem(o)}}catch(e){t={error:e}}finally{try{a&&!a.done&&(n=r.return)&&n.call(r)}finally{if(t)throw t.error}}}function Wa(e){var t=e.split(Fa);if(t.length<3)throw new Error("Invalid key format: "+e);return t.slice(1,t.length-1).join(Fa)}var Ua=function(){function e(e){if(!Q().getBool("IS_BROWSER")||"undefined"==typeof window||"undefined"==typeof window.localStorage)throw new Error("The current environment does not support local storage.");if(this.LS=window.localStorage,null==e||!e)throw new Error("For local storage, modelPath must not be null, undefined or empty.");this.modelPath=e,this.keys=Ka(this.modelPath)}return e.prototype.save=function(e){return i(this,void 0,void 0,(function(){var t,n,r,a;return s(this,(function(o){if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserLocalStorage.save() does not support saving model topology in binary formats yet.");t=JSON.stringify(e.modelTopology),n=JSON.stringify(e.weightSpecs),r=xa(e);try{return this.LS.setItem(this.keys.info,JSON.stringify(r)),this.LS.setItem(this.keys.topology,t),this.LS.setItem(this.keys.weightSpecs,n),this.LS.setItem(this.keys.weightData,function(e){if(ga)return Buffer.from(e).toString("base64");for(var t=new Uint8Array(e),n="",r=0,a=t.length;r<a;r++)n+=String.fromCharCode(t[r]);return btoa(n)}(e.weightData)),a={format:e.format,generatedBy:e.generatedBy,convertedBy:e.convertedBy,signature:null!=e.signature?e.signature:void 0,userDefinedMetadata:null!=e.userDefinedMetadata?e.userDefinedMetadata:void 0,modelInitializer:null!=e.modelInitializer?e.modelInitializer:void 0,trainingConfig:null!=e.trainingConfig?e.trainingConfig:void 0},this.LS.setItem(this.keys.modelMetadata,JSON.stringify(a)),[2,{modelArtifactsInfo:r}]}catch(e){throw qa(this.keys),new Error("Failed to save model '"+this.modelPath+"' to local storage: size quota being exceeded is a possible cause of this failure: modelTopologyBytes="+r.modelTopologyBytes+", weightSpecsBytes="+r.weightSpecsBytes+", weightDataBytes="+r.weightDataBytes+".")}return[2]}))}))},e.prototype.load=function(){return i(this,void 0,void 0,(function(){var e,t,n,r,a,o,i;return s(this,(function(s){if(null==(e=JSON.parse(this.LS.getItem(this.keys.info))))throw new Error("In local storage, there is no model with name '"+this.modelPath+"'");if("JSON"!==e.modelTopologyType)throw new Error("BrowserLocalStorage does not support loading non-JSON model topology yet.");if(t={},null==(n=JSON.parse(this.LS.getItem(this.keys.topology))))throw new Error("In local storage, the topology of model '"+this.modelPath+"' is missing.");if(t.modelTopology=n,null==(r=JSON.parse(this.LS.getItem(this.keys.weightSpecs))))throw new Error("In local storage, the weight specs of model '"+this.modelPath+"' are missing.");if(t.weightSpecs=r,null!=(a=this.LS.getItem(this.keys.modelMetadata))&&(o=JSON.parse(a),t.format=o.format,t.generatedBy=o.generatedBy,t.convertedBy=o.convertedBy,null!=o.signature&&(t.signature=o.signature),null!=o.userDefinedMetadata&&(t.userDefinedMetadata=o.userDefinedMetadata),null!=o.modelInitializer&&(t.modelInitializer=o.modelInitializer),null!=o.trainingConfig&&(t.trainingConfig=o.trainingConfig)),null==(i=this.LS.getItem(this.keys.weightData)))throw new Error("In local storage, the binary weight values of model '"+this.modelPath+"' are missing.");return t.weightData=function(e){if(ga){var t=Buffer.from(e,"base64");return t.buffer.slice(t.byteOffset,t.byteOffset+t.byteLength)}for(var n=atob(e),r=new Uint8Array(n.length),a=0;a<n.length;++a)r.set([n.charCodeAt(a)],a);return r.buffer}(i),[2,t]}))}))},e}();Ua.URL_SCHEME="localstorage://";var Ga=function(e){return Q().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(Ua.URL_SCHEME)?(t=e.slice(Ua.URL_SCHEME.length),new Ua(t)):null;var t};Sa.registerSaveRouter(Ga),Sa.registerLoadRouter(Ga);var Ha=function(){function e(){m(Q().getBool("IS_BROWSER"),(function(){return"Current environment is not a web browser"})),m("undefined"==typeof window||"undefined"!=typeof window.localStorage,(function(){return"Current browser does not appear to support localStorage"})),this.LS=window.localStorage}return e.prototype.listModels=function(){return i(this,void 0,void 0,(function(){var e,t,n,r,a,o;return s(this,(function(i){for(e={},t=Ba+Fa,n=Fa+Ca,r=0;r<this.LS.length;++r)(a=this.LS.key(r)).startsWith(t)&&a.endsWith(n)&&(o=Wa(a),e[o]=JSON.parse(this.LS.getItem(a)));return[2,e]}))}))},e.prototype.removeModel=function(e){return i(this,void 0,void 0,(function(){var t,n;return s(this,(function(r){var a;if(e=(a=e).startsWith(Ua.URL_SCHEME)?a.slice(Ua.URL_SCHEME.length):a,t=Ka(e),null==this.LS.getItem(t.info))throw new Error("Cannot find model at path '"+e+"'");return n=JSON.parse(this.LS.getItem(t.info)),qa(t),[2,n]}))}))},e}(),Va="://",ja=function(){function e(){this.managers={}}return e.getInstance=function(){return null==e.instance&&(e.instance=new e),e.instance},e.registerManager=function(t,n){m(null!=t,(function(){return"scheme must not be undefined or null."})),t.endsWith(Va)&&(t=t.slice(0,t.indexOf(Va))),m(t.length>0,(function(){return"scheme must not be an empty string."}));var r=e.getInstance();m(null==r.managers[t],(function(){return"A model store manager is already registered for scheme '"+t+"'."})),r.managers[t]=n},e.getManager=function(e){var t=this.getInstance().managers[e];if(null==t)throw new Error("Cannot find model manager for scheme '"+e+"'");return t},e.getSchemes=function(){return Object.keys(this.getInstance().managers)},e}();function Ja(e){if(-1===e.indexOf(Va))throw new Error("The url string provided does not contain a scheme. Supported schemes are: "+ja.getSchemes().join(","));return{scheme:e.split(Va)[0],path:e.split(Va)[1]}}function Za(e,t,n){return void 0===n&&(n=!1),i(this,void 0,void 0,(function(){var r,a,o,i,u,l,c,h,f;return s(this,(function(s){switch(s.label){case 0:return m(e!==t,(function(){return"Old path and new path are the same: '"+e+"'"})),m((r=Sa.getLoadHandlers(e)).length>0,(function(){return"Copying failed because no load handler is found for source URL "+e+"."})),m(r.length<2,(function(){return"Copying failed because more than one ("+r.length+") load handlers for source URL "+e+"."})),a=r[0],m((o=Sa.getSaveHandlers(t)).length>0,(function(){return"Copying failed because no save handler is found for destination URL "+t+"."})),m(o.length<2,(function(){return"Copying failed because more than one ("+r.length+") save handlers for destination URL "+t+"."})),i=o[0],u=Ja(e).scheme,l=Ja(e).path,c=u===Ja(e).scheme,[4,a.load()];case 1:return h=s.sent(),n&&c?[4,ja.getManager(u).removeModel(l)]:[3,3];case 2:s.sent(),s.label=3;case 3:return[4,i.save(h)];case 4:return f=s.sent(),!n||c?[3,6]:[4,ja.getManager(u).removeModel(l)];case 5:s.sent(),s.label=6;case 6:return[2,f.modelArtifactsInfo]}}))}))}var Ya=function(){function e(){}return e.prototype.fetch=function(e,t){return fetch(e,t)},e.prototype.now=function(){return performance.now()},e.prototype.encode=function(e,t){if("utf-8"!==t&&"utf8"!==t)throw new Error("Browser's encoder only supports utf-8, but got "+t);return null==this.textEncoder&&(this.textEncoder=new TextEncoder),this.textEncoder.encode(e)},e.prototype.decode=function(e,t){return new TextDecoder(t).decode(e)},e}();if(Q().get("IS_BROWSER")){Q().setPlatform("browser",new Ya);try{ja.registerManager(Ua.URL_SCHEME,new Ha)}catch(e){}try{ja.registerManager(Ta.URL_SCHEME,new Ra)}catch(e){}}var Xa,$a=function(){return require("node-fetch")},Qa=function(){function e(){this.util=require("util"),this.textEncoder=new this.util.TextEncoder}return e.prototype.fetch=function(e,t){return null!=Q().global.fetch?Q().global.fetch(e,t):(null==Xa&&(Xa=$a()),Xa(e,t))},e.prototype.now=function(){var e=process.hrtime();return 1e3*e[0]+e[1]/1e6},e.prototype.encode=function(e,t){if("utf-8"!==t&&"utf8"!==t)throw new Error("Node built-in encoder only supports utf-8, but got "+t);return this.textEncoder.encode(e)},e.prototype.decode=function(e,t){return 0===e.length?"":new this.util.TextDecoder(t).decode(e)},e}();function eo(e,t,n){return void 0===t&&(t="float32"),t=t||"float32",H(e),new Tr(e,t,n)}Q().get("IS_NODE")&&Q().setPlatform("node",new Qa);var to=la({cast_:function(e,t){var n=ia(e,"x","cast");if(!T(t))throw new Error("Failed to cast to unknown dtype "+t);if("string"===t&&"string"!==n.dtype||"string"!==t&&"string"===n.dtype)throw new Error("Only strings can be casted to strings");var r={x:n},a={dtype:t};return $r.runKernel(be,r,a)}});var no=la({clone_:function(e){var t={x:ia(e,"x","clone","string_or_numeric")};return $r.runKernel(et,t)}});function ro(e,t){void 0===t&&(t=!1),console.log(e.toString(t))}Yr(),Rr={buffer:eo,cast:to,clone:no,print:ro};function ao(e){return new Promise((function(e){return setTimeout(e)})).then(e)}var oo=function(){function e(t){if(!Q().getBool("IS_BROWSER"))throw new Error("browserDownloads() cannot proceed because the current environment is not a browser.");t.startsWith(e.URL_SCHEME)&&(t=t.slice(e.URL_SCHEME.length)),null!=t&&0!==t.length||(t="model"),this.modelJsonFileName=t+".json",this.weightDataFileName=t+".weights.bin"}return e.prototype.save=function(e){return i(this,void 0,void 0,(function(){var t,n,r,a,o,i;return s(this,(function(s){switch(s.label){case 0:if("undefined"==typeof document)throw new Error("Browser downloads are not supported in this environment since `document` is not present");if(t=window.URL.createObjectURL(new Blob([e.weightData],{type:"application/octet-stream"})),!(e.modelTopology instanceof ArrayBuffer))return[3,1];throw new Error("BrowserDownloads.save() does not support saving model topology in binary formats yet.");case 1:return n=[{paths:["./"+this.weightDataFileName],weights:e.weightSpecs}],r=wa(e,n),a=window.URL.createObjectURL(new Blob([JSON.stringify(r)],{type:"application/json"})),(o=null==this.modelJsonAnchor?document.createElement("a"):this.modelJsonAnchor).download=this.modelJsonFileName,o.href=a,[4,ao((function(){return o.dispatchEvent(new MouseEvent("click"))}))];case 2:return s.sent(),null==e.weightData?[3,4]:((i=null==this.weightDataAnchor?document.createElement("a"):this.weightDataAnchor).download=this.weightDataFileName,i.href=t,[4,ao((function(){return i.dispatchEvent(new MouseEvent("click"))}))]);case 3:s.sent(),s.label=4;case 4:return[2,{modelArtifactsInfo:xa(e)}]}}))}))},e}();oo.URL_SCHEME="downloads://";var io=function(){function e(e){if(null==e||e.length<1)throw new Error("When calling browserFiles, at least 1 file is required, but received "+e);this.jsonFile=e[0],this.weightsFiles=e.slice(1)}return e.prototype.load=function(){return i(this,void 0,void 0,(function(){var e=this;return s(this,(function(t){return[2,new Promise((function(t,n){var r=new FileReader;r.onload=function(r){var a=JSON.parse(r.target.result),o=a.modelTopology;if(null!=o)if(null!=a.weightsManifest)if(0!==e.weightsFiles.length){var i=ka(a,(function(t){return e.loadWeights(t)}));t(i)}else t({modelTopology:o});else n(new Error("weightManifest field is missing from file "+e.jsonFile.name));else n(new Error("modelTopology field is missing from file "+e.jsonFile.name))},r.onerror=function(t){return n("Failed to read model topology and weights manifest JSON from file '"+e.jsonFile.name+"'. BrowserFiles supports loading Keras-style tf.Model artifacts only.")},r.readAsText(e.jsonFile)}))]}))}))},e.prototype.loadWeights=function(e){var t,n,r=this,a=[],o=[];try{for(var i=u(e),s=i.next();!s.done;s=i.next()){var l=s.value;a.push.apply(a,c(l.weights)),o.push.apply(o,c(l.paths))}}catch(e){t={error:e}}finally{try{s&&!s.done&&(n=i.return)&&n.call(i)}finally{if(t)throw t.error}}var h=this.checkManifestAndWeightFiles(e),f=o.map((function(e){return r.loadWeightsFile(e,h[e])}));return Promise.all(f).then((function(e){return[a,ya(e)]}))},e.prototype.loadWeightsFile=function(e,t){return new Promise((function(n,r){var a=new FileReader;a.onload=function(e){var t=e.target.result;n(t)},a.onerror=function(t){return r("Failed to weights data from file of path '"+e+"'.")},a.readAsArrayBuffer(t)}))},e.prototype.checkManifestAndWeightFiles=function(e){var t,n,r=this,a=[],o=this.weightsFiles.map((function(e){return ba(e.name)})),i={};try{for(var s=u(e),l=s.next();!l.done;l=s.next()){l.value.paths.forEach((function(e){var t=ba(e);if(-1!==a.indexOf(t))throw new Error("Duplicate file basename found in weights manifest: '"+t+"'");if(a.push(t),-1===o.indexOf(t))throw new Error("Weight file with basename '"+t+"' is not provided.");i[e]=r.weightsFiles[o.indexOf(t)]}))}}catch(e){t={error:e}}finally{try{l&&!l.done&&(n=s.return)&&n.call(s)}finally{if(t)throw t.error}}if(a.length!==this.weightsFiles.length)throw new Error("Mismatch in the number of files in weights manifest ("+a.length+") and the number of weight files provided ("+this.weightsFiles.length+").");return i},e}();function so(e,t,n,r){!function(e){m(null!=e&&Array.isArray(e)&&e.length>0,(function(){return"promises must be a none empty array"}))}(e),function(e,t){m(e>=0&&e<=1,(function(){return"Progress fraction must be in range [0, 1], but got startFraction "+e})),m(t>=0&&t<=1,(function(){return"Progress fraction must be in range [0, 1], but got endFraction "+t})),m(t>=e,(function(){return"startFraction must be no more than endFraction, but got startFraction "+e+" and endFraction "+t}))}(n=null==n?0:n,r=null==r?1:r);var a=0;return Promise.all(e.map((function(o){return o.then((function(o){var i=n+ ++a/e.length*(r-n);return t(i),o})),o})))}function uo(e,t){return i(this,void 0,void 0,(function(){var n,r,a,o,i,u,l,c,h;return s(this,(function(s){switch(s.label){case 0:return null==t&&(t={}),n=null==t.fetchFunc?Q().platform.fetch:t.fetchFunc,r=e.map((function(e){return n(e,t.requestInit,{isBinary:!0})})),a=0,o=.5,null!=t.onProgress?[3,2]:[4,Promise.all(r)];case 1:return i=s.sent(),[3,4];case 2:return[4,so(r,t.onProgress,a,o)];case 3:i=s.sent(),s.label=4;case 4:return u=i.map((function(e){return e.arrayBuffer()})),l=.5,c=1,null!=t.onProgress?[3,6]:[4,Promise.all(u)];case 5:return h=s.sent(),[3,8];case 6:return[4,so(u,t.onProgress,l,c)];case 7:h=s.sent(),s.label=8;case 8:return[2,h]}}))}))}function lo(e){var t=this;return function(n,r,a){return void 0===r&&(r=""),i(t,void 0,void 0,(function(){var t,o,i,u,l,c,h,f,d,p;return s(this,(function(s){switch(s.label){case 0:if(t=n.map((function(){return!1})),o={},i=null!=a?a.map((function(){return!1})):[],u=[],n.forEach((function(e,n){var r=0;e.weights.forEach((function(e){var s="quantization"in e?e.quantization.dtype:e.dtype,l=da[s]*k(e.shape),c=function(){t[n]=!0,null==o[n]&&(o[n]=[]),o[n].push({manifestEntry:e,groupOffset:r,sizeBytes:l})};null!=a?a.forEach((function(t,n){t===e.name&&(c(),i[n]=!0)})):c(),u.push(e.name),r+=l}))})),!i.every((function(e){return e})))throw l=a.filter((function(e,t){return!i[t]})),new Error("Could not find weights in manifest with names: "+l.join(", ")+". \nManifest JSON has weights with names: "+u.join(", ")+".");return c=t.reduce((function(e,t,n){return t&&e.push(n),e}),[]),h=[],c.forEach((function(e){n[e].paths.forEach((function(e){var t=r+(r.endsWith("/")?"":"/")+e;h.push(t)}))})),[4,e(h)];case 1:return f=s.sent(),d={},p=0,c.forEach((function(e){for(var t=n[e].paths.length,r=0,a=0;a<t;a++)r+=f[p+a].byteLength;for(var i=new ArrayBuffer(r),s=new Uint8Array(i),u=0,l=0;l<t;l++){var c=new Uint8Array(f[p+l]);s.set(c,u),u+=c.byteLength}o[e].forEach((function(e){var t=pa(i.slice(e.groupOffset,e.groupOffset+e.sizeBytes),[e.manifestEntry]);for(var n in t)d[n]=t[n]})),p+=t})),[2,d]}}))}))}}Sa.registerSaveRouter((function(e){return Q().getBool("IS_BROWSER")&&!Array.isArray(e)&&e.startsWith(oo.URL_SCHEME)?function(e){void 0===e&&(e="model");return new oo(e)}(e.slice(oo.URL_SCHEME.length)):null}));var co=function(){function e(e,t){if(this.DEFAULT_METHOD="POST",null==t&&(t={}),this.weightPathPrefix=t.weightPathPrefix,this.onProgress=t.onProgress,this.weightUrlConverter=t.weightUrlConverter,null!=t.fetchFunc?(m("function"==typeof t.fetchFunc,(function(){return"Must pass a function that matches the signature of `fetch` (see https://developer.mozilla.org/en-US/docs/Web/API/Fetch_API)"})),this.fetch=t.fetchFunc):this.fetch=Q().platform.fetch,m(null!=e&&e.length>0,(function(){return"URL path for http must not be null, undefined or empty."})),Array.isArray(e)&&m(2===e.length,(function(){return"URL paths for http must have a length of 2, (actual length is "+e.length+")."})),this.path=e,null!=t.requestInit&&null!=t.requestInit.body)throw new Error("requestInit is expected to have no pre-existing body, but has one.");this.requestInit=t.requestInit||{}}return e.prototype.save=function(e){return i(this,void 0,void 0,(function(){var t,n,r,a;return s(this,(function(o){switch(o.label){case 0:if(e.modelTopology instanceof ArrayBuffer)throw new Error("BrowserHTTPRequest.save() does not support saving model topology in binary formats yet.");return(t=Object.assign({method:this.DEFAULT_METHOD},this.requestInit)).body=new FormData,n=[{paths:["./model.weights.bin"],weights:e.weightSpecs}],r=wa(e,n),t.body.append("model.json",new Blob([JSON.stringify(r)],{type:"application/json"}),"model.json"),null!=e.weightData&&t.body.append("model.weights.bin",new Blob([e.weightData],{type:"application/octet-stream"}),"model.weights.bin"),[4,this.fetch(this.path,t)];case 1:if((a=o.sent()).ok)return[2,{modelArtifactsInfo:xa(e),responses:[a]}];throw new Error("BrowserHTTPRequest.save() failed due to HTTP response status "+a.status+".")}}))}))},e.prototype.load=function(){return i(this,void 0,void 0,(function(){var e,t,n,r,a,o=this;return s(this,(function(i){switch(i.label){case 0:return[4,this.fetch(this.path,this.requestInit)];case 1:if(!(e=i.sent()).ok)throw new Error("Request to "+this.path+" failed with status code "+e.status+". Please verify this URL points to the model JSON of the model to load.");i.label=2;case 2:return i.trys.push([2,4,,5]),[4,e.json()];case 3:return t=i.sent(),[3,5];case 4:throw i.sent(),n="Failed to parse model JSON of response from "+this.path+".",this.path.endsWith(".pb")?n+=" Your path contains a .pb file extension. Support for .pb models have been removed in TensorFlow.js 1.0 in favor of .json models. You can re-convert your Python TensorFlow model using the TensorFlow.js 1.0 conversion scripts or you can convert your.pb models with the 'pb2json'NPM script in the tensorflow/tfjs-converter repository.":n+=" Please make sure the server is serving valid JSON for this request.",new Error(n);case 5:if(r=t.modelTopology,a=t.weightsManifest,null==r&&null==a)throw new Error("The JSON from HTTP path "+this.path+" contains neither model topology or manifest for weights.");return[2,ka(t,(function(e){return o.loadWeights(e)}))]}}))}))},e.prototype.loadWeights=function(e){return i(this,void 0,void 0,(function(){var t,n,r,a,o,i,h,f,d,p,v,g,m,y,b,w,k,x,E,S,A,_,N,I,M,T,D;return s(this,(function(s){switch(s.label){case 0:t=Array.isArray(this.path)?this.path[1]:this.path,n=l(function(e){var t=e.lastIndexOf("/"),n=e.lastIndexOf("?"),r=e.substring(0,t),a=n>t?e.substring(n):"";return[r+"/",a]}(t),2),r=n[0],a=n[1],o=this.weightPathPrefix||r,i=[];try{for(h=u(e),f=h.next();!f.done;f=h.next())d=f.value,i.push.apply(i,c(d.weights))}catch(e){_={error:e}}finally{try{f&&!f.done&&(N=h.return)&&N.call(h)}finally{if(_)throw _.error}}p=[],v=[];try{for(g=u(e),m=g.next();!m.done;m=g.next()){y=m.value;try{for(T=void 0,b=u(y.paths),w=b.next();!w.done;w=b.next())k=w.value,null!=this.weightUrlConverter?v.push(this.weightUrlConverter(k)):p.push(o+k+a)}catch(e){T={error:e}}finally{try{w&&!w.done&&(D=b.return)&&D.call(b)}finally{if(T)throw T.error}}}}catch(e){I={error:e}}finally{try{m&&!m.done&&(M=g.return)&&M.call(g)}finally{if(I)throw I.error}}return this.weightUrlConverter?(E=(x=p.push).apply,S=[p],[4,Promise.all(v)]):[3,2];case 1:E.apply(x,S.concat([c.apply(void 0,[s.sent()])])),s.label=2;case 2:return[4,uo(p,{requestInit:this.requestInit,fetchFunc:this.fetch,onProgress:this.onProgress})];case 3:return A=s.sent(),[2,[i,ya(A)]]}}))}))},e}();function ho(e){return null!=e.match(co.URL_SCHEME_REGEX)}co.URL_SCHEME_REGEX=/^https?:\/\//;var fo=function(e,t){if("undefined"==typeof fetch&&(null==t||null==t.fetchFunc))return null;return(Array.isArray(e)?e.every((function(e){return ho(e)})):ho(e))?po(e,t):null};function po(e,t){return new co(e,t)}Sa.registerSaveRouter(fo),Sa.registerLoadRouter(fo);var vo=function(){function e(e){this.modelArtifacts=e}return e.prototype.load=function(){return i(this,void 0,void 0,(function(){return s(this,(function(e){return[2,this.modelArtifacts]}))}))},e}(),go=function(){function e(e){this.saveHandler=e}return e.prototype.save=function(e){return i(this,void 0,void 0,(function(){return s(this,(function(t){return[2,this.saveHandler(e)]}))}))},e}();var mo={__proto__:null,browserFiles:function(e){return new io(e)},browserHTTPRequest:function(e,t){return po(e,t)},concatenateArrayBuffers:ya,decodeWeights:pa,encodeWeights:function(e,t){return i(this,void 0,void 0,(function(){var n,r,a,o,u,l=this;return s(this,(function(c){switch(c.label){case 0:for(n=[],r=[],a=Array.isArray(e)?e.map((function(e){return e.name})):Object.keys(e),o=function(o){var u=a[o],c=Array.isArray(e)?e[o].tensor:e[u];if("float32"!==c.dtype&&"int32"!==c.dtype&&"bool"!==c.dtype&&"string"!==c.dtype&&"complex64"!==c.dtype)throw new Error("Unsupported dtype in weight '"+u+"': "+c.dtype);var h={name:u,shape:c.shape,dtype:c.dtype};if("string"===c.dtype){var f=new Promise((function(e){return i(l,void 0,void 0,(function(){var t,n,r,a,o,i,u;return s(this,(function(s){switch(s.label){case 0:return[4,c.bytes()];case 1:for(t=s.sent(),n=t.reduce((function(e,t){return e+t.length}),0)+4*t.length,r=new Uint8Array(n),a=0,o=0;o<t.length;o++)i=t[o],u=new Uint8Array(new Uint32Array([i.length]).buffer),r.set(u,a),a+=4,r.set(i,a),a+=i.length;return e(r),[2]}}))}))}));r.push(f)}else r.push(c.data());null!=t&&(h.group=t),n.push(h)},u=0;u<a.length;++u)o(u);return[4,Promise.all(r)];case 1:return[2,{data:va(c.sent()),specs:n}]}}))}))},fromMemory:function(e,t,n,r){if(1===arguments.length){var a=null!=e.modelTopology||null!=e.weightSpecs;return a?new vo(e):(console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new vo({modelTopology:e}))}return console.warn("Please call tf.io.fromMemory() with only one argument. The argument should be of type ModelArtifacts. The multi-argument signature of tf.io.fromMemory() has been deprecated and will be removed in a future release."),new vo({modelTopology:e,weightSpecs:t,weightData:n,trainingConfig:r})},getLoadHandlers:function(e,t){return Sa.getLoadHandlers(e,t)},getModelArtifactsForJSON:ka,getModelArtifactsInfoForJSON:xa,getSaveHandlers:function(e){return Sa.getSaveHandlers(e)},http:po,isHTTPScheme:ho,loadWeights:function(e,t,n,r){return void 0===t&&(t=""),i(this,void 0,void 0,(function(){return s(this,(function(a){return[2,lo((function(e){return uo(e,{requestInit:r})}))(e,t,n)]}))}))},registerLoadRouter:function(e){return Sa.registerLoadRouter(e)},registerSaveRouter:function(e){return Sa.registerSaveRouter(e)},weightsLoaderFactory:lo,withSaveHandler:function(e){return new go(e)},copyModel:function(e,t){return i(this,void 0,void 0,(function(){return s(this,(function(n){return!1,[2,Za(e,t,false)]}))}))},listModels:function(){return i(this,void 0,void 0,(function(){var e,t,n,r,a,o,i,l,c,h;return s(this,(function(s){switch(s.label){case 0:e=ja.getSchemes(),t={},s.label=1;case 1:s.trys.push([1,6,7,8]),n=u(e),r=n.next(),s.label=2;case 2:return r.done?[3,5]:(a=r.value,[4,ja.getManager(a).listModels()]);case 3:for(i in o=s.sent())t[a+Va+i]=o[i];s.label=4;case 4:return r=n.next(),[3,2];case 5:return[3,8];case 6:return l=s.sent(),c={error:l},[3,8];case 7:try{r&&!r.done&&(h=n.return)&&h.call(n)}finally{if(c)throw c.error}return[7];case 8:return[2,t]}}))}))},moveModel:function(e,t){return i(this,void 0,void 0,(function(){return s(this,(function(n){return!0,[2,Za(e,t,true)]}))}))},removeModel:function(e){return i(this,void 0,void 0,(function(){var t;return s(this,(function(n){return t=Ja(e),[2,ja.getManager(t.scheme).removeModel(t.path)]}))}))}};var yo=la({matMul_:function(e,t,n,r){var a;void 0===n&&(n=!1),void 0===r&&(r=!1);var o=ia(e,"a","matMul"),i=ia(t,"b","matMul"),s={a:o=(a=l(Wr(o,i),2))[0],b:i=a[1]},u={transposeA:n,transposeB:r};return $r.runKernel(ve,s,u)}});var bo=la({oneHot_:function(e,t,n,r){if(void 0===n&&(n=1),void 0===r&&(r=0),t<2)throw new Error("Error in oneHot: depth must be >=2, but it is "+t);var a={indices:ia(e,"indices","oneHot","int32")},o={depth:t,onValue:n,offValue:r};return $r.runKernel(It,a,o)}});var wo=la({transpose_:function(e,t){var n=ia(e,"x","transpose");if(null==t&&(t=n.shape.map((function(e,t){return t})).reverse()),m(n.rank===t.length,(function(){return"Error in transpose: rank of input "+n.rank+" must match length of perm "+t+"."})),t.forEach((function(e){m(e>=0&&e<n.rank,(function(){return"All entries in 'perm' must be between 0 and "+(n.rank-1)+" but got "+t}))})),n.rank<=1)return n.clone();var r={x:n},a={perm:t};return $r.runKernel(mn,r,a)}});var ko,xo={__proto__:null,confusionMatrix:la({confusionMatrix_:function(e,t,n){var r=ia(e,"labels","confusionMatrix"),a=ia(t,"predictions","confusionMatrix");m(null==n||n>0&&Number.isInteger(n),(function(){return"If provided, numClasses must be a positive integer, but got "+n})),m(1===r.rank,(function(){return"Expected the rank of labels to be 1, but got "+r.rank})),m(1===a.rank,(function(){return"Expected the rank of predictions to be 1, but got "+a.rank})),m(r.shape[0]===a.shape[0],(function(){return"Mismatch in the number of examples: "+r.shape[0]+" vs. "+a.shape[0]+". Labels and predictions should have the same number of elements."})),m(n>0&&Number.isInteger(n),(function(){return"numClasses is required to be a positive integer, but got "+n}));var o=bo(to(r,"int32"),n),i=bo(to(a,"int32"),n),s=wo(o),u=yo(s,i);return to(u,"int32")}})};function Eo(e,t,n){if(b(e),null!=t&&3!==t.length)throw new Error("tensor3d() requires shape to have three numbers");var r=ra(e,n);if(3!==r.length&&1!==r.length)throw new Error("tensor3d() requires values to be number[][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor3d() requires shape to be provided when `values` are a flat array");return ha(e,t,r,n)}function So(e,t){if(void 0===t&&(t=3),t>4)throw new Error("Cannot construct Tensor with more than 4 channels from pixels.");if(null==e)throw new Error("pixels passed to tf.browser.fromPixels() can not be null");var n=!1,r=!1,a=!1,o=!1,i=!1,s=!1;if(e.data instanceof Uint8Array)n=!0;else if("undefined"!=typeof ImageData&&e instanceof ImageData)r=!0;else if("undefined"!=typeof HTMLVideoElement&&e instanceof HTMLVideoElement)a=!0;else if("undefined"!=typeof HTMLImageElement&&e instanceof HTMLImageElement)o=!0;else if(null!=e.getContext)i=!0;else{if(!("undefined"!=typeof ImageBitmap&&e instanceof ImageBitmap))throw new Error("pixels passed to tf.browser.fromPixels() must be either an HTMLVideoElement, HTMLImageElement, HTMLCanvasElement, ImageData in browser, or OffscreenCanvas, ImageData in webworker or {data: Uint32Array, width: number, height: number}, but was "+e.constructor.name);s=!0}if(a){if(a&&e.readyState<2)throw new Error("The video element has not loaded data yet. Please wait for `loadeddata` event on the <video> element.")}if(null!=Tn(En,$r.backendName)){var u={pixels:e},c={numChannels:t};return $r.runKernel(En,u,c)}var h,f,d=l(a?[e.videoWidth,e.videoHeight]:[e.width,e.height],2),p=d[0],v=d[1];if(i?h=e.getContext("2d").getImageData(0,0,p,v).data:r||n?h=e.data:(o||a||s)&&(null==ko&&(ko=document.createElement("canvas").getContext("2d")),ko.canvas.width=p,ko.canvas.height=v,ko.drawImage(e,0,0,p,v),h=ko.getImageData(0,0,p,v).data),4===t)f=new Int32Array(h);else{var g=p*v;f=new Int32Array(g*t);for(var m=0;m<g;m++)for(var y=0;y<t;++y)f[m*t+y]=h[4*m+y]}return Eo(f,[v,p,t],"int32")}function Ao(e){return"undefined"!=typeof window&&"undefined"!=typeof ImageBitmap&&window.hasOwnProperty("createImageBitmap")&&!(e instanceof ImageBitmap)&&function(e){return null!=e&&0!==e.width&&0!==e.height}(e)&&!function(e){return null!=e&&e.data instanceof Uint8Array}(e)}var _o={__proto__:null,fromPixelsAsync:function(e,t){return void 0===t&&(t=3),i(this,void 0,void 0,(function(){var n,r;return s(this,(function(a){switch(a.label){case 0:if(n=null,!Q().getBool("WRAP_TO_IMAGEBITMAP")||!Ao(e))return[3,5];r=void 0,a.label=1;case 1:return a.trys.push([1,3,,4]),[4,createImageBitmap(e,{premultiplyAlpha:"none"})];case 2:return r=a.sent(),[3,4];case 3:return a.sent(),r=null,[3,4];case 4:return n=null!=r&&r.width===e.width&&r.height===e.height?r:e,[3,6];case 5:n=e,a.label=6;case 6:return[2,So(n,t)]}}))}))},toPixels:function(e,t){return i(this,void 0,void 0,(function(){var n,r,a,o,i,u,c,h,f,d,p,v,g,m,y,b;return s(this,(function(s){switch(s.label){case 0:if(n=ia(e,"img","toPixels"),e instanceof Fr||(n=to(r=n,"int32"),r.dispose()),2!==n.rank&&3!==n.rank)throw new Error("toPixels only supports rank 2 or 3 tensors, got rank "+n.rank+".");if(a=l(n.shape.slice(0,2),2),o=a[0],i=a[1],(u=2===n.rank?1:n.shape[2])>4||2===u)throw new Error("toPixels only supports depth of size 1, 3 or 4 but got "+u);if("float32"!==n.dtype&&"int32"!==n.dtype)throw new Error("Unsupported type for toPixels: "+n.dtype+". Please use float32 or int32 tensors.");return[4,n.data()];case 1:for(c=s.sent(),h="float32"===n.dtype?255:1,f=new Uint8ClampedArray(i*o*4),d=0;d<o*i;++d){for(p=[0,0,0,255],v=0;v<u;v++){if(g=c[d*u+v],"float32"===n.dtype){if(g<0||g>1)throw new Error("Tensor values for a float32 Tensor must be in the range [0 - 1] but encountered "+g+".")}else if("int32"===n.dtype&&(g<0||g>255))throw new Error("Tensor values for a int32 Tensor must be in the range [0 - 255] but encountered "+g+".");1===u?(p[0]=g*h,p[1]=g*h,p[2]=g*h):p[v]=g*h}f[(m=4*d)+0]=Math.round(p[0]),f[m+1]=Math.round(p[1]),f[m+2]=Math.round(p[2]),f[m+3]=Math.round(p[3])}return null!=t&&(t.width=i,t.height=o,y=t.getContext("2d"),b=new ImageData(f,i,o),y.putImageData(b,0,0)),n!==e&&n.dispose(),[2,f]}}))}))},fromPixels:la({fromPixels_:So})};function No(e,t){var n=e.shape.length,r=t.shape.length;if(n<1)throw new Error("tf.gatherND() expects the input to be rank 1 or higher, but the rank was "+n+".");if(r<1)throw new Error("tf.gatherND() expects the indices to be rank 1 or higher, but the rank was "+r+".");if("int32"!==t.dtype)throw new Error("tf.gatherND() expects the indices to be int32 type, but the dtype was "+t.dtype+".");if(t.shape[r-1]>n)throw new Error("index innermost dimension length must be <= tensor rank; saw: "+t.shape[r-1]+" vs. "+n);if(0===k(e.shape))throw new Error("Requested more than 0 entries, but input is empty. Input shape: "+e.shape+".");for(var a=t.shape,o=a[a.length-1],i=1,s=0;s<a.length-1;++s)i*=a[s];var u=e.shape,l=a.slice();l.pop();var h=1;for(s=o;s<n;++s)h*=u[s],l.push(u[s]);var f=c(K(e.shape).map((function(e){return e/h})),[1]).slice(0,o);return[l,i,h,f]}var Io={__proto__:null,prepareAndValidate:No};function Mo(e,t,n){var r=t.rank>1?t.shape[t.rank-1]:1,a=t.rank>1?t.rank-1:1,o="Must have updates.shape = indices.shape[:batchDim] + shape[sliceDim:], got updates.shape: "+n.shape+", indices.shape: "+t.shape+", shape: "+e+", sliceDim: "+r+", and batchDim: "+a+".";if(n.rank<a)throw new Error(o+" update.rank < "+a+". ");if(e.length<r+(n.rank-a))throw new Error(o+" Output shape length < "+(r+(n.rank-a)));if(n.rank!==a+e.length-r)throw new Error(o+" update.rank != "+(a+e.length-r));for(var i=0;i<a;++i)if(n.shape[i]!==t.shape[i])throw new Error(o+" updates.shape["+i+"] ("+n.shape[i]+") != indices.shape["+i+"] ("+t.shape[i]+").");for(i=0;i<n.rank-a;++i)if(n.shape[i+a]!==e[i+r])throw new Error(o+" updates.shape["+(i+a)+"] ("+n.shape[i+a]+") != shape["+(i+a)+"] ("+e[i+a]+")")}function To(e,t,n){if(t.rank<1)throw new Error("tf.scatterND() expects the indices to be rank 1 or higher, but the rank was "+t.rank+".");if(e.rank<1)throw new Error("tf.scatterND() expects the updates to be rank 1 or higher, but the rank was "+e.rank+".");if("int32"!==t.dtype)throw new Error("The dtype of 'indices' should be int32, but got dtype: "+t.dtype);if(n.length<1)throw new Error("Output rank must be greater or equal to 1, but got shape: "+n);if(0===n.length){if(0===t.size)throw new Error("Indices specified for empty output. indices shape: "+t.shape);if(0===e.size)throw new Error("Updates specified for empty output. updates shape: "+e.shape)}Mo(n,t,e)}function Do(e,t,n){for(var r=t.shape.length,a=r>1?t.shape[r-1]:1,o=n.length,i=1,s=a;s<o;++s)i*=n[s];var u=a<1?1:a;return{sliceRank:a,numUpdates:k(t.shape)/u,sliceSize:i,strides:c(K(n.slice(0,a)),[1]),outputSize:k(n)}}var Ro={__proto__:null,validateUpdateShape:Mo,validateInput:To,calculateShapes:Do};function Fo(e){for(var t=[],n=0;e>0;)1&e&&t.push(n),e/=2,n++;return t}function Bo(e,t,n){for(var r=[],a=0;a<e.length;a++)r[a]=Math.ceil((t[a]-e[a])/n[a]);return r}function Co(e,t,n,r){for(var a=c(e),o=a.length;o<r.length;o++)a.push(1);for(o=0;o<n;o++)0===o?a[t]=1:(a.splice(t,0,1),a.pop());return a}function Po(e,t,n){return n<=e?n:n-(t-1)}function Oo(e,t){for(var n=[],r=0;r<e;r++)n.push(t+r);return n}function Lo(e,t,n,r,a,o,i,s,u){var l=e.length,c=new Array(l),h=new Array(l),f=new Array(l);if(t.length&&n>0){var d=t[0],p=n+1;c=zo(i,d,p,r,e),h=Ko(s,d,p,a,e),f=Co(o,d,p,e)}else for(var v=0;v<l;v++)c[v]=Wo(i,r,o,e,v,u),h[v]=Uo(s,a,o,e,v,u),f[v]=qo(o,v,u);return{begin:c,end:h,strides:f}}function zo(e,t,n,r,a){for(var o=c(a),i=Oo(n,t),s=0;s<o.length;s++)if(i.indexOf(s)>-1)o[s]=0;else{var u=Po(t,n,s),l=r[u];e&1<<u&&(l=0),o[s]=l}return o}function Ko(e,t,n,r,a){for(var o=c(a),i=Oo(n,t),s=0;s<o.length;s++)if(i.indexOf(s)>-1)o[s]=Number.MAX_SAFE_INTEGER;else{var u=Po(t,n,s),l=r[u];e&1<<u&&(l=Number.MAX_SAFE_INTEGER),o[s]=l}for(var h=0;h<o.length;h++){var f=a[h];o[h]<0&&(o[h]+=f),o[h]=v(0,o[h],a[h])}return o}function qo(e,t,n){var r=e[t];return(n&1<<t||null==r)&&(r=1),r}function Wo(e,t,n,r,a,o){var i=t[a],s=n[a]||1;(e&1<<a||o&1<<a||null==i)&&(i=s>0?Number.MIN_SAFE_INTEGER:Number.MAX_SAFE_INTEGER);var u=r[a];return i<0&&(i+=u),i=v(0,i,u-1)}function Uo(e,t,n,r,a,o){var i=t[a],s=n[a]||1;(e&1<<a||o&1<<a||null==i)&&(i=s>0?Number.MAX_SAFE_INTEGER:Number.MIN_SAFE_INTEGER);var u=r[a];return i<0&&(i+=u),i=s>0?v(0,i,u):v(-1,i,u-1)}var Go={__proto__:null,assertParamsValid:function(e,t,n){var r=e.shape.length;m(r===t.length,(function(){return"Error in slice"+r+"D: Length of begin "+t+" must match the rank of the array ("+r+")."})),m(r===n.length,(function(){return"Error in slice"+r+"D: Length of size "+n+" must match the rank of the array ("+r+")."}));for(var a=function(a){m(t[a]+n[a]<=e.shape[a],(function(){return"Error in slice"+r+"D: begin["+a+"] + size["+a+"] ("+(t[a]+n[a])+") would overflow input.shape["+a+"] ("+e.shape[a]+")"}))},o=0;o<r;++o)a(o)},maskToAxes:Fo,computeOutShape:Bo,stridesWithElidedDims:Co,getNormalizedAxes:Lo,startIndicesWithElidedDims:zo,stopIndicesWithElidedDims:Ko,stridesForAxis:qo,startForAxis:Wo,stopForAxis:Uo,isSliceContinous:function(e,t,n){for(var r=n.length,a=0;a<n.length;a++)if(n[a]>1){r=a;break}for(a=r+1;a<n.length;a++)if(t[a]>0||n[a]!==e[a])return!1;return!0},computeFlatOffset:function(e,t){for(var n=e.length>0?e[e.length-1]:1,r=0;r<e.length-1;r++)n+=e[r]*t[r];return n},parseSliceParams:function(e,t,n){var r,a,o=e.shape.length;return(r="number"==typeof t?c([t],new Array(o-1).fill(0)):t.length<o?t.concat(new Array(o-t.length).fill(0)):t.slice()).forEach((function(e){m(-1!==e,(function(){return"slice() does not support negative begin indexing."}))})),a=(a=null==n?new Array(o).fill(-1):"number"==typeof n?c([n],new Array(o-1).fill(-1)):n.length<o?n.concat(new Array(o-n.length).fill(-1)):n).map((function(t,n){return t>=0?t:(m(-1===t,(function(){return"Negative size values should be exactly -1 but got "+t+" for the slice() size at index "+n+"."})),e.shape[n]-r[n])})),[r,a]},sliceInfo:function(e,t,n,r,a,o,i,s,u){var l=t.slice(),c=n.slice(),h=r;null==r&&(h=new Array(l.length));var f=Fo(i);if(f.length>1)throw new Error("Multiple ellipses in slice is not allowed.");if(0!==i&&0!==s)throw new Error("Using both ellipsisMask and newAxisMask is not yet supported.");if(0!==i&&0!==u)throw new Error("Using both ellipsisMask and shrinkAxisMask is not yet supported.");var d=e.length-l.length,p=Fo(s),v=e.slice();p.forEach((function(e){l[e]=0,c[e]=1,v.splice(e,0,1)}));var g=Lo(v,f,d,l,c,h,a,o,i),m=g.begin,y=g.end,b=g.strides;l=m,c=y,h=b;var w=Fo(u);w.forEach((function(e){c[e]=l[e]+1,h[e]=1}));var k=Bo(l,c,h),x=k.filter((function(e,t){return-1===w.indexOf(t)}));return{nonStrided:h.every((function(e){return 1===e})),$begin:l,$end:c,$strides:h,size:k,newShape:v,outShape:x}}},Ho=function(){function e(){}return e.prototype.getClassName=function(){return this.constructor.className},e.fromConfig=function(e,t){return new e(t)},e}(),Vo=function(){function e(){this.classNameMap={}}return e.getMap=function(){return null==e.instance&&(e.instance=new e),e.instance},e.register=function(t){e.getMap().classNameMap[t.className]=[t,t.fromConfig]},e}();function jo(e){m(null!=e.className,(function(){return"Class being registered does not have the static className property defined."})),m("string"==typeof e.className,(function(){return"className is required to be a string, but got type "+typeof e.className})),m(e.className.length>0,(function(){return"Class being registered has an empty-string as its className, which is disallowed."})),Vo.register(e)}var Jo={__proto__:null,Serializable:Ho,SerializationMap:Vo,registerClass:jo};function Zo(){return 32===$r.backend.floatPrecision()?.001:.1}function Yo(e,t,n){var r=!0;if((D(e)||D(t))&&(r=!1),D(e)&&D(t)&&(r=!0),r){var a=e.constructor.name,o=t.constructor.name;if(a!==o)throw new Error("Arrays are of different type. Actual: "+a+". Expected: "+o)}if(Array.isArray(e)&&Array.isArray(t)){var i=ra(e),s=ra(t);if(!x(i,s))throw new Error("Arrays have different shapes. Actual: ["+i+"]. Expected: ["+s+"]")}var u=D(e)?e:w(e),l=D(t)?t:w(t);if(u.length!==l.length)throw new Error("Arrays have different lengths actual: "+u.length+" vs expected: "+l.length+".\nActual:   "+u+".\nExpected: "+l+".");for(var c=0;c<l.length;++c){var h=u[c],f=l[c];if(!n(h,f))throw new Error("Arrays differ: actual["+c+"] = "+h+", expected["+c+"] = "+f+".\nActual:   "+u+".\nExpected: "+l+".")}}function Xo(e,t,n){return!isFinite(e)&&!isFinite(t)||!(isNaN(e)||isNaN(t)||Math.abs(e-t)>n)}var $o={__proto__:null,TEST_EPSILON_FLOAT16:.1,expectArraysClose:function(e,t,n){return null==n&&(n=Zo()),Yo(e,t,(function(e,t){return Xo(e,t,n)}))},testEpsilon:Zo,expectPromiseToFail:function(e,t){e().then((function(){return t.fail()}),(function(){return t()}))},expectArraysEqual:function(e,t){var n="string"==typeof t||"number"==typeof t||"boolean"==typeof t?[t]:t;return B(e)||B(e[0])||B(t)||B(t[0])?Yo(e,n,(function(e,t){return e==t})):Yo(e,t,(function(e,t){return Xo(e,t,0)}))},expectNumbersClose:function(e,t,n){if(null==n&&(n=Zo()),!Xo(e,t,n))throw new Error("Numbers differ: actual === "+e+", expected === "+t)},expectValuesInRange:function(e,t,n){for(var r=0;r<e.length;r++)if(e[r]<t||e[r]>n)throw new Error("Value out of range:"+e[r]+" low: "+t+", high: "+n)},expectArrayBuffersEqual:function(e,t){expect(new Float32Array(e)).toEqual(new Float32Array(t))},encodeStrings:function e(t){for(var n=0;n<t.length;n++){var r=t[n];Array.isArray(r)?e(r):t[n]=wr(r)}return t}};function Qo(e,t){return $r.tidy(e,t)}function ei(e){Gr(e).forEach((function(e){return e.dispose()}))}function ti(e){return $r.keep(e)}var ni=la({add_:function(e,t){var n,r=ia(e,"a","add"),a=ia(t,"b","add"),o={a:r=(n=l(Wr(r,a),2))[0],b:a=n[1]};return $r.runKernel(ae,o)}});var ri=la({floorDiv_:function(e,t){var n,r=ia(e,"a","floorDiv"),a=ia(t,"b","floorDiv"),o={a:r=(n=l(Wr(r,a),2))[0],b:a=n[1]};return $r.runKernel(Je,o)}});var ai=la({div_:function(e,t){var n,r=ia(e,"a","div"),a=ia(t,"b","div");if(r=(n=l(Wr(r,a),2))[0],a=n[1],"int32"===r.dtype&&"int32"===a.dtype)return ri(r,a);var o={a:r,b:a};return $r.runKernel(Ke,o,{})}});var oi=la({mul_:function(e,t){var n,r=ia(e,"a","mul"),a=ia(t,"b","mul"),o={a:r=(n=l(Wr(r,a),2))[0],b:a=n[1]};return $r.runKernel(xt,o)}});var ii=la({abs_:function(e){var t=ia(e,"x","abs");if("complex64"===t.dtype){var n={x:t};return $r.runKernel(Ee,n)}return n={x:t},$r.runKernel("Abs",n)}});var si=la({acos_:function(e){var t={x:ia(e,"x","acos")};return $r.runKernel(ne,t)}});var ui=la({acosh_:function(e){var t={x:ia(e,"x","acosh")};return $r.runKernel(re,t)}});var li=la({addN_:function(e){m(Array.isArray(e),(function(){return"The argument passed to tf.addN() must be a list of tensors"})),m(e.length>=1,(function(){return"Must pass at least one tensor to tf.addN(), but got "+e.length}));var t=e.map((function(e,t){return ia(e,"tensors"+t,"addN")})),n=t[0];t.forEach((function(e){if(e.dtype!==n.dtype)throw new Error("All tensors passed to tf.addN() must have the same dtype")})),t.forEach((function(e){if(!x(e.shape,n.shape))throw new Error("All tensors passed to tf.addN() must have the same shape")}));var r=t;return $r.runKernel(oe,r)}});var ci=la({all_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r={x:ia(e,"x","all","bool")},a={axis:t,keepDims:n};return $r.runKernel("All",r,a)}});var hi=la({any_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r={x:ia(e,"x","any","bool")},a={axis:t,keepDims:n};return $r.runKernel("Any",r,a)}});var fi=la({argMax_:function(e,t){void 0===t&&(t=0);var n={x:ia(e,"x","argMax")},r={axis:t};return $r.runKernel(ie,n,r)}});var di=la({argMin_:function(e,t){void 0===t&&(t=0);var n={x:ia(e,"x","argMin")},r={axis:t};return $r.runKernel(se,n,r)}});var pi=la({asin_:function(e){var t={x:ia(e,"x","asin")};return $r.runKernel(ue,t)}});var vi=la({asinh_:function(e){var t={x:ia(e,"x","asinh")};return $r.runKernel(le,t)}});var gi=la({atan_:function(e){var t={x:ia(e,"x","atan")};return $r.runKernel(ce,t)}});var mi=la({atan2_:function(e,t){var n,r=ia(e,"a","atan2"),a=ia(t,"b","atan2"),o={a:r=(n=l(Wr(r,a),2))[0],b:a=n[1]};return $r.runKernel(fe,o)}});var yi=la({atanh_:function(e){var t={x:ia(e,"x","atanh")};return $r.runKernel(he,t)}});function bi(e,t,n,r,a,o,i){void 0===i&&(i="channelsLast");var s,u=l(Ei(t),2),c=u[0],h=u[1];if("channelsLast"===i)s=[c,h,e[3],e[3]];else{if("channelsFirst"!==i)throw new Error("Unknown dataFormat "+i);s=[c,h,e[1],e[1]]}return wi(e,s,n,r,a,o,!1,i)}function wi(e,t,n,r,a,o,i,s){var u,c;void 0===i&&(i=!1),void 0===s&&(s="channelsLast");var h=l([-1,-1,-1,-1],4),f=h[0],d=h[1],p=h[2],v=h[3];if("channelsLast"===s)f=(u=l(e,4))[0],d=u[1],p=u[2],v=u[3];else{if("channelsFirst"!==s)throw new Error("Unknown dataFormat "+s);f=(c=l(e,4))[0],v=c[1],d=c[2],p=c[3]}var g,m=l(t,4),y=m[0],b=m[1],w=m[3],k=l(Ei(n),2),x=k[0],E=k[1],S=l(Ei(r),2),A=S[0],_=S[1],N=Ai(y,A),I=Ai(b,_),M=function(e,t,n,r,a,o,i,s,u){var l,c,h;if("number"==typeof e){l={top:e,bottom:e,left:e,right:e,type:0===e?"VALID":"NUMBER"};var f=function(e,t,n,r,a){null==r&&(r=xi(e,t,n));var o=e[0],i=e[1],s=_i((o-t+2*r)/n+1,a),u=_i((i-t+2*r)/n+1,a);return[s,u]}([t,n],o,r,e,s);c=f[0],h=f[1]}else if("same"===e){c=Math.ceil(t/r),h=Math.ceil(n/a);var d=Math.max(0,(c-1)*r+o-t),p=Math.max(0,(h-1)*a+i-n);l={top:v=Math.floor(d/2),bottom:g=d-v,left:m=Math.floor(p/2),right:y=p-m,type:"SAME"}}else if("valid"===e)l={top:0,bottom:0,left:0,right:0,type:"VALID"},c=Math.ceil((t-o+1)/r),h=Math.ceil((n-i+1)/a);else{if("object"!=typeof e)throw Error("Unknown padding parameter: "+e);var v,g,m,y;l={top:v="channelsLast"===u?e[1][0]:e[2][0],bottom:g="channelsLast"===u?e[1][1]:e[2][1],left:m="channelsLast"===u?e[2][0]:e[3][0],right:y="channelsLast"===u?e[2][1]:e[3][1],type:0===v&&0===g&&0===m&&0===y?"VALID":"EXPLICIT"},c=_i((t-o+v+g)/r+1,s),h=_i((n-i+m+y)/a+1,s)}return{padInfo:l,outHeight:c,outWidth:h}}(a,d,p,x,E,N,I,o,s),T=M.padInfo,D=M.outHeight,R=M.outWidth,F=i?w*v:w;return"channelsFirst"===s?g=[f,F,D,R]:"channelsLast"===s&&(g=[f,D,R,F]),{batchSize:f,dataFormat:s,inHeight:d,inWidth:p,inChannels:v,outHeight:D,outWidth:R,outChannels:F,padInfo:T,strideHeight:x,strideWidth:E,filterHeight:y,filterWidth:b,effectiveFilterHeight:N,effectiveFilterWidth:I,dilationHeight:A,dilationWidth:_,inShape:e,outShape:g,filterShape:t}}function ki(e,t,n,r,a,o,i,s){var u,c;void 0===o&&(o=!1),void 0===i&&(i="channelsLast");var h=l([-1,-1,-1,-1,-1],5),f=h[0],d=h[1],p=h[2],v=h[3],g=h[4];if("channelsLast"===i)f=(u=l(e,5))[0],d=u[1],p=u[2],v=u[3],g=u[4];else{if("channelsFirst"!==i)throw new Error("Unknown dataFormat "+i);f=(c=l(e,5))[0],g=c[1],d=c[2],p=c[3],v=c[4]}var m,y=l(t,5),b=y[0],w=y[1],k=y[2],x=y[4],E=l(Si(n),3),S=E[0],A=E[1],_=E[2],N=l(Si(r),3),I=N[0],M=N[1],T=N[2],D=Ai(b,I),R=Ai(w,M),F=Ai(k,T),B=function(e,t,n,r,a,o,i,s,u,l,c){var h,f,d,p;if("number"==typeof e){h={top:e,bottom:e,left:e,right:e,front:e,back:e,type:0===e?"VALID":"NUMBER"};var v=function(e,t,n,r,a,o){null==a&&(a=xi(e,t,r));var i=e[0],s=e[1],u=e[2],l=_i((i-t+2*a)/r+1,o),c=_i((s-t+2*a)/r+1,o),h=_i((u-t+2*a)/r+1,o);return[l,c,h,n]}([t,n,r,1],s,1,a,e,c);f=v[0],d=v[1],p=v[2]}else if("same"===e){var g=((f=Math.ceil(t/a))-1)*a+s-t,m=((d=Math.ceil(n/o))-1)*o+u-n,y=((p=Math.ceil(r/i))-1)*i+l-r,b=Math.floor(g/2),w=g-b,k=Math.floor(m/2),x=m-k,E=Math.floor(y/2);h={top:k,bottom:x,left:E,right:y-E,front:b,back:w,type:"SAME"}}else{if("valid"!==e)throw Error("Unknown padding parameter: "+e);h={top:0,bottom:0,left:0,right:0,front:0,back:0,type:"VALID"},f=Math.ceil((t-s+1)/a),d=Math.ceil((n-u+1)/o),p=Math.ceil((r-l+1)/i)}return{padInfo:h,outDepth:f,outHeight:d,outWidth:p}}(a,d,p,v,S,A,_,D,R,F,s),C=B.padInfo,P=B.outDepth,O=B.outHeight,L=B.outWidth,z=o?x*g:x;return"channelsFirst"===i?m=[f,z,P,O,L]:"channelsLast"===i&&(m=[f,P,O,L,z]),{batchSize:f,dataFormat:i,inDepth:d,inHeight:p,inWidth:v,inChannels:g,outDepth:P,outHeight:O,outWidth:L,outChannels:z,padInfo:C,strideDepth:S,strideHeight:A,strideWidth:_,filterDepth:b,filterHeight:w,filterWidth:k,effectiveFilterDepth:D,effectiveFilterHeight:R,effectiveFilterWidth:F,dilationDepth:I,dilationHeight:M,dilationWidth:T,inShape:e,outShape:m,filterShape:t}}function xi(e,t,n,r){void 0===r&&(r=1);var a=Ai(t,r);return Math.floor((e[0]*(n-1)-n+a)/2)}function Ei(e){return"number"==typeof e?[e,e,e]:2===e.length?[e[0],e[1],1]:e}function Si(e){return"number"==typeof e?[e,e,e]:e}function Ai(e,t){return t<=1?e:e+(e-1)*(t-1)}function _i(e,t){if(!t)return Math.trunc(e);switch(t){case"round":return Math.round(e);case"ceil":return Math.ceil(e);case"floor":return Math.floor(e);default:throw new Error("Unknown roundingMode "+t)}}function Ni(e){var t=l(Ei(e),3),n=t[0],r=t[1],a=t[2];return 1===n&&1===r&&1===a}function Ii(e,t){return Ni(e)||Ni(t)}function Mi(e){if("NHWC"===e)return"channelsLast";if("NCHW"===e)return"channelsFirst";throw new Error("Unknown dataFormat "+e)}var Ti=la({reshape_:function(e,t){var n={x:ia(e,"x","reshape","string_or_numeric")},r={shape:t};return $r.runKernel(Ot,n,r)}});var Di=la({avgPool_:function(e,t,n,r,a){var o=ia(e,"x","avgPool","float32");m(Ii(n,1),(function(){return"Error in avgPool: Either strides or dilations must be 1. Got strides "+n+" and dilations '1'"}));var i=o,s=!1;3===o.rank&&(s=!0,i=Ti(o,[1,o.shape[0],o.shape[1],o.shape[2]])),m(4===i.rank,(function(){return"Error in avgPool: x must be rank 4 but got rank "+i.rank+"."})),null!=a&&m(E(r),(function(){return"Error in avgPool: pad must be an integer when using, dimRoundingMode "+a+" but got pad "+r+"."}));var u={x:i},l={filterSize:t,strides:n,pad:r,dimRoundingMode:a},c=$r.runKernel(de,u,l);return c=to(c,o.dtype),s?Ti(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});var Ri=la({avgPool3d_:function(e,t,n,r,a,o){void 0===o&&(o="NDHWC");var i=ia(e,"x","avgPool3d","float32"),s=i,u=!1;4===i.rank&&(u=!0,s=Ti(i,[1,i.shape[0],i.shape[1],i.shape[2],i.shape[3]])),m(5===s.rank,(function(){return"Error in avgPool3d: x must be rank 5 but got rank "+s.rank+"."})),m("NDHWC"===o,(function(){return"Error in avgPool3d: Only NDHWC is currently supported, but got dataFormat of "+o})),null!=a&&m(E(r),(function(){return"Error in avgPool3d: pad must be an integer when using, dimRoundingMode "+a+" but got pad "+r+"."}));var l={x:s},c={filterSize:t,strides:n,pad:r,dimRoundingMode:a,dataFormat:o},h=$r.runKernel(pe,l,c);return h=to(h,s.dtype),u?Ti(h,[h.shape[1],h.shape[2],h.shape[3],h.shape[4]]):h}});var Fi=la({concat_:function(e,t){void 0===t&&(t=0),m(e.length>=1,(function(){return"Pass at least one tensor to concat"}));var n=sa(e,"tensors","concat","string_or_numeric");if("complex64"===n[0].dtype&&n.forEach((function(e){if("complex64"!==e.dtype)throw new Error("Cannot concatenate complex64 tensors with a tensor\n          with dtype "+e.dtype+". ")})),1===n.length)return no(n[0]);var r=n,a={axis:t};return $r.runKernel(Se,r,a)}});var Bi=la({sigmoid_:function(e){var t={x:ia(e,"x","sigmoid","float32")};return $r.runKernel(Yt,t)}});var Ci=la({slice_:function(e,t,n){var r=ia(e,"x","slice","string_or_numeric");if(0===r.rank)throw new Error("Slicing scalar is not possible");var a={x:r},o={begin:t,size:n};return $r.runKernel(jt,a,o)}});var Pi=la({tanh_:function(e){var t={x:ia(e,"x","tanh","float32")};return $r.runKernel(dn,t)}});var Oi=la({basicLSTMCell_:function(e,t,n,r,a,o){var i=ia(e,"forgetBias","basicLSTMCell"),s=ia(t,"lstmKernel","basicLSTMCell"),u=ia(n,"lstmBias","basicLSTMCell"),l=ia(r,"data","basicLSTMCell"),c=ia(a,"c","basicLSTMCell"),h=ia(o,"h","basicLSTMCell"),f=Fi([l,h],1),d=yo(f,s),p=ni(d,u),v=p.shape[0],g=p.shape[1]/4,m=[v,g],y=Ci(p,[0,0],m),b=Ci(p,[0,g],m),w=Ci(p,[0,2*g],m),k=Ci(p,[0,3*g],m),x=ni(oi(Bi(y),Pi(b)),oi(c,Bi(ni(i,w))));return[x,oi(Pi(x),Bi(k))]}});var Li=la({batchToSpaceND_:function(e,t,n){var r=ia(e,"x","batchToSpaceND"),a=t.reduce((function(e,t){return e*t}));m(r.rank>=1+t.length,(function(){return"input rank is "+r.rank+" but should be > than blockShape.length "+t.length})),m(n.length===t.length,(function(){return"crops.length is "+n.length+" but should be equal to blockShape.length  "+t.length})),m(r.shape[0]%a==0,(function(){return"input tensor batch is "+r.shape[0]+" but is not divisible by the product of the elements of blockShape "+t.join(" * ")+" === "+a}));var o={x:r},i={blockShape:t,crops:n};return $r.runKernel(ge,o,i)}});var zi=la({batchNorm_:function(e,t,n,r,a,o){null==o&&(o=.001);var i,s,u=ia(e,"x","batchNorm"),l=ia(t,"mean","batchNorm"),c=ia(n,"variance","batchNorm");null!=a&&(i=ia(a,"scale","batchNorm")),null!=r&&(s=ia(r,"offset","batchNorm")),m(l.rank===c.rank,(function(){return"Batch normalization gradient requires mean and variance to have equal ranks."})),m(null==s||l.rank===s.rank,(function(){return"Batch normalization gradient requires mean and offset to have equal ranks."})),m(null==i||l.rank===i.rank,(function(){return"Batch normalization gradient requires mean and scale to have equal ranks."}));var h={x:function(e){return 0===e.rank||1===e.rank?Ti(e,[1,1,1,e.size]):2===e.rank?Ti(e,[1,1,e.shape[0],e.shape[1]]):3===e.rank?Ti(e,[1,e.shape[0],e.shape[1],e.shape[2]]):e}(u),scale:i,offset:s,mean:l,variance:c},f={varianceEpsilon:o},d=$r.runKernel(Ze,h,f);return Ti(d,u.shape)}});var Ki=la({batchNorm2d_:function(e,t,n,r,a,o){var i,s,u=ia(e,"x","batchNorm"),l=ia(t,"mean","batchNorm"),c=ia(n,"variance","batchNorm");return null!=a&&(i=ia(a,"scale","batchNorm")),null!=r&&(s=ia(r,"offset","batchNorm")),m(2===u.rank,(function(){return"Error in batchNorm2D: x must be rank 2 but got rank "+u.rank+"."})),m(2===l.rank||1===l.rank,(function(){return"Error in batchNorm2D: mean must be rank 2 or rank 1 but got rank "+l.rank+"."})),m(2===c.rank||1===c.rank,(function(){return"Error in batchNorm2D: variance must be rank 2 or rank 1 but got rank "+c.rank+"."})),null!=i&&m(2===i.rank||1===i.rank,(function(){return"Error in batchNorm2D: scale must be rank 2 or rank 1 but got rank "+i.rank+"."})),null!=s&&m(2===s.rank||1===s.rank,(function(){return"Error in batchNorm2D: offset must be rank 2 or rank 1 but got rank "+s.rank+"."})),zi(u,l,c,s,i,o)}});var qi=la({batchNorm3d_:function(e,t,n,r,a,o){var i,s,u=ia(e,"x","batchNorm"),l=ia(t,"mean","batchNorm"),c=ia(n,"variance","batchNorm");return null!=a&&(i=ia(a,"scale","batchNorm")),null!=r&&(s=ia(r,"offset","batchNorm")),m(3===u.rank,(function(){return"Error in batchNorm3D: x must be rank 3 but got rank "+u.rank+"."})),m(3===l.rank||1===l.rank,(function(){return"Error in batchNorm3D: mean must be rank 3 or rank 1 but got rank "+l.rank+"."})),m(3===c.rank||1===c.rank,(function(){return"Error in batchNorm3D: variance must be rank 3 or rank 1 but got rank "+c.rank+"."})),null!=i&&m(3===i.rank||1===i.rank,(function(){return"Error in batchNorm3D: scale must be rank 3 or rank 1 but got rank "+i.rank+"."})),null!=s&&m(3===s.rank||1===s.rank,(function(){return"Error in batchNorm3D: offset must be rank 3 or rank 1 but got rank "+s.rank+"."})),zi(u,l,c,s,i,o)}});var Wi=la({batchNorm4d_:function(e,t,n,r,a,o){var i,s,u=ia(e,"x","batchNorm"),l=ia(t,"mean","batchNorm"),c=ia(n,"variance","batchNorm");return null!=a&&(i=ia(a,"scale","batchNorm")),null!=r&&(s=ia(r,"offset","batchNorm")),m(4===u.rank,(function(){return"Error in batchNorm4D: x must be rank 4 but got rank "+u.rank+"."})),m(4===l.rank||1===l.rank,(function(){return"Error in batchNorm4D: mean must be rank 4 or rank 1 but got rank "+l.rank+"."})),m(4===c.rank||1===c.rank,(function(){return"Error in batchNorm4D: variance must be rank 4 or rank 1 but got rank "+c.rank+"."})),null!=i&&m(4===i.rank||1===i.rank,(function(){return"Error in batchNorm4D: scale must be rank 4 or rank 1 but got rank "+i.rank+"."})),null!=s&&m(4===s.rank||1===s.rank,(function(){return"Error in batchNorm4D: offset must be rank 4 or rank 1 but got rank "+s.rank+"."})),zi(u,l,c,s,i,o)}});var Ui=la({bincount_:function(e,t,n){var r=ia(e,"x","bincount"),a=ia(t,"weights","bincount");m("int32"===r.dtype,(function(){return"Error in bincount: input dtype must be int32, but got "+r.dtype})),m(n>=0,(function(){return"size must be non-negative, but got "+n+"."})),m(a.size===r.size||0===a.size,(function(){return"Error in bincount: weights must have the same size as input or0-length, but got input shape: "+r.shape+", weights shape: "+a.shape+"."}));var o={x:r,weights:a},i={size:n};return $r.runKernel(me,o,i)}});var Gi=la({broadcastArgs_:function(e,t){var n=ia(e,"s0","broadcastArgs","int32"),r=ia(t,"s1","broadcastArgs","int32");if(1!==n.rank)throw new Error("broadcastArgs(): first input must be a vector (rank=1). Has rank "+n.rank);if(1!==r.rank)throw new Error("broadcastArgs(): second input must be a vector (rank=1). Has rank "+r.rank);var a={s0:n,s1:r};return $r.runKernel(ye,a)}});var Hi=la({broadcastTo_:function(e,t){var n=ia(e,"broadcastTo","x"),r=n.shape;if(t.some((function(e){return!(e>0)||e%1!=0})))throw new Error("broadcastTo(): Invalid broadcast shape ["+t+"].");if(t.length<n.rank)throw new Error("broadcastTo(): shape.length="+t.length+" < input.rank="+n.rank+".");if(t.length>n.rank){for(var a=n.shape.slice();a.length<t.length;)a.unshift(1);n=Ti(n,a)}for(var o=n.shape,i=Array.from(t),s=t.length-1;s>=0;s--)if(o[s]===t[s])i[s]=1;else if(1!==n.shape[s])throw new Error("broadcastTo(): ["+r+"] cannot be broadcast to ["+t+"].");if(0===i.map((function(e,t){return e>1?t:-1})).filter((function(e){return e>=0})).length)return no(n);var u={x:n},l={reps:i};return $r.runKernel(pn,u,l)}});var Vi=la({ceil_:function(e){var t={x:ia(e,"x","ceil","float32")};return $r.runKernel(we,t)}});var ji=la({clipByValue_:function(e,t,n){var r=ia(e,"x","clipByValue");m(t<=n,(function(){return"Error in clip: min ("+t+") must be less than or equal to max ("+n+")."}));var a={x:r},o={clipValueMin:t,clipValueMax:n};return $r.runKernel(ke,a,o)}});var Ji=la({concat1d_:function(e){return Fi(e,0)}});var Zi=la({concat2d_:function(e,t){return Fi(e,t)}});var Yi=la({concat3d_:function(e,t){return Fi(e,t)}});var Xi=la({concat4d_:function(e,t){return Fi(e,t)}});var $i=la({conv2d_:function(e,t,n,r,a,o,i){void 0===a&&(a="NHWC"),void 0===o&&(o=[1,1]);var s=ia(e,"x","conv2d","float32"),u=ia(t,"filter","conv2d","float32"),l=s,c=!1;3===s.rank&&(c=!0,l=Ti(s,[1,s.shape[0],s.shape[1],s.shape[2]])),m(4===l.rank,(function(){return"Error in conv2d: input must be rank 4, but got rank "+l.rank+"."})),m(4===u.rank,(function(){return"Error in conv2d: filter must be rank 4, but got rank "+u.rank+"."})),null!=i&&m(E(r),(function(){return"Error in conv2d: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+r+"."}));var h="NHWC"===a?l.shape[3]:l.shape[1];m(h===u.shape[2],(function(){return"Error in conv2d: depth of input ("+h+") must match input depth for filter "+u.shape[2]+"."})),m(Ii(n,o),(function(){return"Error in conv2D: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+o+"'"}));var f={x:l,filter:u},d={strides:n,pad:r,dataFormat:a,dilations:o,dimRoundingMode:i},p=$r.runKernel(Ae,f,d);return c?Ti(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});var Qi=la({conv1d_:function(e,t,n,r,a,o,i){void 0===a&&(a="NWC"),void 0===o&&(o=1);var s=ia(e,"x","conv1d"),u=ia(t,"filter","conv1d"),l=s,c=!1;2===s.rank&&(c=!0,l=Ti(s,[1,s.shape[0],s.shape[1]])),m(3===l.rank,(function(){return"Error in conv1d: input must be rank 3, but got rank "+l.rank+"."})),m(3===u.rank,(function(){return"Error in conv1d: filter must be rank 3, but got rank "+u.rank+"."})),null!=i&&m(E(r),(function(){return"Error in conv1d: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+r+"."})),m(l.shape[2]===u.shape[1],(function(){return"Error in conv1d: depth of input ("+l.shape[2]+") must match input depth for filter "+u.shape[1]+"."})),m(Ii(n,o),(function(){return"Error in conv1D: Either stride or dilation must be 1. Got stride "+n+" and dilation '"+o+"'"})),m("NWC"===a,(function(){return"Error in conv1d: got dataFormat of "+a+" but only NWC is currently supported."}));var h=Ti(u,[1,u.shape[0],u.shape[1],u.shape[2]]),f=Ti(l,[l.shape[0],1,l.shape[1],l.shape[2]]),d=$i(f,h,[1,n],r,"NHWC",[1,o],i);return Ti(d,c?[d.shape[2],d.shape[3]]:[d.shape[0],d.shape[2],d.shape[3]])}});var es=la({conv2DBackpropInput_:function(e,t,n,r,a,o,i){void 0===o&&(o="NHWC"),m(e.length===t.rank,(function(){return"Length of inShape ("+e.length+") and rank of dy ("+t.rank+") must match"}));var s=e,u=t,l=!1;3===t.rank&&(l=!0,u=Ti(t,[1,t.shape[0],t.shape[1],t.shape[2]]),s=[1,e[0],e[1],e[2]]),m(4===s.length,(function(){return"Error in conv2dDerInput: inShape must be length 4, but got length "+s.length+"."})),m(4===u.rank,(function(){return"Error in conv2dDerInput: dy must be rank 4, but got rank "+u.rank})),m(4===n.rank,(function(){return"Error in conv2dDerInput: filter must be rank 4, but got rank "+n.rank}));var c="NHWC"===o?s[3]:s[1],h="NHWC"===o?u.shape[3]:u.shape[1];m(c===n.shape[2],(function(){return"Error in conv2dDerInput: depth of input ("+c+") must match input depth for filter "+n.shape[2]+"."})),m(h===n.shape[3],(function(){return"Error in conv2dDerInput: depth of output ("+h+") must match output depth for filter "+n.shape[3]+"."})),null!=i&&m(E(a),(function(){return"Error in conv2dDerInput: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+a+"."}));var f={dy:u,filter:n},d={strides:r,pad:a,dataFormat:o,dimRoundingMode:i,inputShape:s},p=$r.runKernel(Ne,f,d);return l?Ti(p,[p.shape[1],p.shape[2],p.shape[3]]):p}});var ts=la({conv2dTranspose_:function(e,t,n,r,a,o){var i=ia(e,"x","conv2dTranspose"),s=ia(t,"filter","conv2dTranspose");return es(n,i,s,r,a,"NHWC",o)}});var ns=la({conv3d_:function(e,t,n,r,a,o){void 0===a&&(a="NDHWC"),void 0===o&&(o=[1,1,1]);var i=ia(e,"x","conv3d"),s=ia(t,"filter","conv3d"),u=i,l=!1;4===i.rank&&(l=!0,u=Ti(i,[1,i.shape[0],i.shape[1],i.shape[2],i.shape[3]])),m(5===u.rank,(function(){return"Error in conv3d: input must be rank 5, but got rank "+u.rank+"."})),m(5===s.rank,(function(){return"Error in conv3d: filter must be rank 5, but got rank "+s.rank+"."})),m(u.shape[4]===s.shape[3],(function(){return"Error in conv3d: depth of input ("+u.shape[4]+") must match input depth for filter "+s.shape[3]+"."})),m(Ii(n,o),(function(){return"Error in conv3D: Either strides or dilations must be 1. Got strides "+n+" and dilations '"+o+"'"})),m("NDHWC"===a,(function(){return"Error in conv3d: got dataFormat of "+a+" but only NDHWC is currently supported."}));var c={x:u,filter:s},h={strides:n,pad:r,dataFormat:a,dilations:o},f=$r.runKernel(Ie,c,h);return l?Ti(f,[f.shape[1],f.shape[2],f.shape[3],f.shape[4]]):f}});var rs=la({conv3DBackpropInput_:function(e,t,n,r,a){m(e.length===t.rank,(function(){return"Length of inShape ("+e.length+") and rank of dy ("+t.rank+") must match"}));var o=e,i=t,s=!1;4===t.rank&&(s=!0,i=Ti(t,[1,t.shape[0],t.shape[1],t.shape[2],t.shape[3]]),o=[1,e[0],e[1],e[2],e[3]]);var u=o[4],l=i.shape[4];m(5===o.length,(function(){return"Error in conv3dDerInput: inShape must be length 5, but got length "+o.length+"."})),m(5===i.rank,(function(){return"Error in conv3dDerInput: dy must be rank 5, but got rank "+i.rank})),m(5===n.rank,(function(){return"Error in conv3dDerInput: filter must be rank 5, but got rank "+n.rank})),m(u===n.shape[3],(function(){return"Error in conv3dDerInput: depth of input ("+u+") must match input depth for filter "+n.shape[3]+"."})),m(l===n.shape[4],(function(){return"Error in conv3dDerInput: depth of output ("+l+") must match output depth for filter "+n.shape[4]+"."}));var c={dy:i,filter:n},h={pad:a,strides:r,inputShape:o},f=$r.runKernel(Me,c,h);return s?Ti(f,[f.shape[1],f.shape[2],f.shape[3],f.shape[4]]):f}});var as=la({conv3dTranspose_:function(e,t,n,r,a){var o=ia(e,"x","conv3dTranspose"),i=ia(t,"filter","conv3dTranspose");return rs(n,o,i,r,a)}});var os=la({cos_:function(e){var t={x:ia(e,"x","cos","float32")};return $r.runKernel("Cos",t)}});var is=la({cosh_:function(e){var t={x:ia(e,"x","cosh","float32")};return $r.runKernel(Te,t)}});var ss=la({cumsum_:function(e,t,n,r){void 0===t&&(t=0),void 0===n&&(n=!1),void 0===r&&(r=!1);var a={x:ia(e,"x","cumsum")},o={axis:t,exclusive:n,reverse:r};return $r.runKernel(De,a,o)}});var us=la({denseBincount_:function(e,t,n,r){void 0===r&&(r=!1);var a=ia(e,"x","denseBincount"),o=ia(t,"weights","denseBincount");m("int32"===a.dtype,(function(){return"Error in denseBincount: input dtype must be int32, but got "+a.dtype})),m(a.rank<=2,(function(){return"Error in denseBincount: input must be at most rank 2, but got rank "+a.rank+"."})),m(n>=0,(function(){return"size must be non-negative, but got "+n+"."})),m(o.size===a.size||0===o.size,(function(){return"Error in denseBincount: weights must have the same shape as x or 0-length, but got x shape: "+a.shape+", weights shape: "+o.shape+"."}));var i={x:a,weights:o},s={size:n,binaryOutput:r};return $r.runKernel(Fe,i,s)}});var ls=la({depthToSpace_:function(e,t,n){void 0===n&&(n="NHWC");var r=ia(e,"x","depthToSpace","float32"),a="NHWC"===n?r.shape[1]:r.shape[2],o="NHWC"===n?r.shape[2]:r.shape[3],i="NHWC"===n?r.shape[3]:r.shape[1];m(t>1,(function(){return"blockSize should be > 1 for depthToSpace, but was: "+t})),m(a*t>=0,(function(){return"Negative dimension size caused by overflow when multiplying\n    "+a+" and "+t+"  for depthToSpace with input shape\n    "+r.shape})),m(o*t>=0,(function(){return"Negative dimension size caused by overflow when multiplying\n    "+o+" and "+t+" for depthToSpace with input shape\n        "+r.shape})),m(i%(t*t)==0,(function(){return"Dimension size must be evenly divisible by "+t*t+" but is "+i+" for depthToSpace with input shape "+r.shape}));var s={x:r},u={blockSize:t,dataFormat:n};return $r.runKernel(Be,s,u)}});var cs=la({depthwiseConv2d_:function(e,t,n,r,a,o,i){void 0===a&&(a="NHWC"),void 0===o&&(o=[1,1]);var s=ia(e,"x","depthwiseConv2d","float32"),u=ia(t,"filter","depthwiseConv2d","float32"),l=s,c=!1;3===s.rank&&(c=!0,l=Ti(s,[1,s.shape[0],s.shape[1],s.shape[2]])),m(4===l.rank,(function(){return"Error in depthwiseConv2d: input must be rank 4, but got rank "+l.rank+"."})),m(4===u.rank,(function(){return"Error in depthwiseConv2d: filter must be rank 4, but got rank "+u.rank+"."})),m(l.shape[3]===u.shape[2],(function(){return"Error in depthwiseConv2d: number of input channels ("+l.shape[3]+") must match the inChannels dimension in filter "+u.shape[2]+"."})),null!=i&&m(E(r),(function(){return"Error in depthwiseConv2d: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+r+"."}));var h={x:l,filter:u},f={strides:n,pad:r,dataFormat:a,dilations:o,dimRoundingMode:i},d=$r.runKernel(Ce,h,f);return c?Ti(d,[d.shape[1],d.shape[2],d.shape[3]]):d}});var hs=la({diag_:function(e){var t={x:ia(e,"x","diag")};return $r.runKernel(Le,t)}});var fs=la({dilation2d_:function(e,t,n,r,a,o){void 0===a&&(a=[1,1]),void 0===o&&(o="NHWC");var i=ia(e,"x","dilation2d"),s=ia(t,"filter","dilation2d");m(3===i.rank||4===i.rank,(function(){return"Error in dilation2d: input must be rank 3 or 4, but got rank "+i.rank+"."})),m(3===s.rank,(function(){return"Error in dilation2d: filter must be rank 3, but got rank "+s.rank+"."})),m("NHWC"===o,(function(){return"Error in dilation2d: Only NHWC is currently supported, but got dataFormat of "+o}));var u=i,l=!1;3===i.rank&&(u=Ti(i,[1,i.shape[0],i.shape[1],i.shape[2]]),l=!0);var c={x:u,filter:s},h={strides:n,pad:r,dilations:a},f=$r.runKernel(ze,c,h);return l?Ti(f,[f.shape[1],f.shape[2],f.shape[3]]):f}});function ds(e,t){for(var n=[],r=0;r<t.length;r++){var a=e[e.length-r-1],o=t.length-r-1,i=t[o];(null==a||1===a&&i>1)&&n.unshift(o)}return n}function ps(e,t){for(var n=[],r=Math.max(e.length,t.length),a=0;a<r;a++){var o=e[e.length-a-1];null==o&&(o=1);var i=t[t.length-a-1];if(null==i&&(i=1),1===o)n.unshift(i);else if(1===i)n.unshift(o);else{if(o!==i)throw Error("Operands could not be broadcast together with shapes "+e+" and "+t+".");n.unshift(o)}}return n}var vs=la({equal_:function(e,t){var n,r=ia(e,"a","equal","string_or_numeric"),a=ia(t,"b","equal","string_or_numeric");r=(n=l(Wr(r,a),2))[0],a=n[1],ps(r.shape,a.shape);var o={a:r,b:a};return $r.runKernel(We,o)}});var gs=la({where_:function(e,t,n){var r=ia(t,"a","where"),a=ia(n,"b","where"),o=ia(e,"condition","where","bool"),i=ps(ps(o.shape,r.shape),a.shape),s={condition:Hi(o,i),t:Hi(r,i),e:Hi(a,i)};return $r.runKernel(Ht,s)}});var ms=la({zerosLike_:function(e){var t={x:ia(e,"x","zerosLike")};return $r.runKernel(kn,t)}});var ys=la({divNoNan_:function(e,t){var n,r=ia(e,"a","div"),a=ia(t,"b","div");r=(n=l(Wr(r,a),2))[0],a=n[1];var o=ai(r,a),i=ms(o),s=vs(a,i);return gs(s,i,o)}});var bs=la({dot_:function(e,t){var n=ia(e,"t1","dot"),r=ia(t,"t2","dot");m(!(1!==n.rank&&2!==n.rank||1!==r.rank&&2!==r.rank),(function(){return"Error in dot: inputs must all be rank 1 or 2, but got ranks "+n.rank+" and "+r.rank+"."}));var a=1===n.rank?n.size:n.shape[1],o=1===r.rank?r.size:r.shape[0];if(m(a===o,(function(){return"Error in dot: inner dimensions of inputs must match, but got "+a+" and "+o+"."})),1===n.rank&&1===r.rank){var i=Ti(n,[1,-1]),s=Ti(r,[-1,1]),u=yo(i,s);return Ti(u,[])}if(1===n.rank&&2===r.rank){i=Ti(n,[1,-1]),s=Ti(r,[r.shape[0],r.shape[1]]),u=yo(i,s);return Ti(u,[u.size])}if(2===n.rank&&1===r.rank){s=Ti(r,[-1,1]),u=yo(n,s);return Ti(u,[u.size])}return s=Ti(r,[r.shape[0],r.shape[1]]),u=yo(n,s)}});var ws=la({einsum_:function(e){for(var t=[],n=1;n<arguments.length;n++)t[n-1]=arguments[n];var r=t.map((function(e,t){return ia(e,"tensors"+t,"einsum")})),a={equation:e};return $r.runKernel(qe,r,a)}});var ks=la({elu_:function(e){var t={x:ia(e,"x","elu","float32")};return $r.runKernel("Elu",t)}});var xs=la({erf_:function(e){var t=ia(e,"x","erf");m("int32"===t.dtype||"float32"===t.dtype,(function(){return"Input dtype must be `int32` or `float32`."})),"int32"===t.dtype&&(t=to(t,"float32"));var n={x:t};return $r.runKernel("Erf",n)}});var Es=la({exp_:function(e){var t={x:ia(e,"x","exp")};return $r.runKernel("Exp",t)}});var Ss=la({expandDims_:function(e,t){void 0===t&&(t=0);var n=ia(e,"x","expandDims","string_or_numeric");m(t<=n.rank,(function(){return"Axis must be <= rank of the tensor"}));var r={input:n},a={dim:t};return $r.runKernel(Ue,r,a)}});var As=la({expm1_:function(e){var t={x:ia(e,"x","expm1")};return $r.runKernel(Ge,t)}});var _s=la({tile_:function(e,t){var n=ia(e,"x","tile","string_or_numeric");m(n.rank===t.length,(function(){return"Error in transpose: rank of input "+n.rank+" must match length of reps "+t+"."}));var r={x:n},a={reps:t};return $r.runKernel(pn,r,a)}});var Ns=la({eye_:function(e,t,n,r){void 0===r&&(r="float32"),null==t&&(t=e);for(var a=eo([e,t],r),o=e<=t?e:t,i=0;i<o;++i)a.set(1,i,i);var s=Ti(a.toTensor(),[e,t]);if(null==n)return s;if(1===n.length)return _s(Ss(s,0),[n[0],1,1]);if(2===n.length)return _s(Ss(Ss(s,0),0),[n[0],n[1],1,1]);if(3===n.length)return _s(Ss(Ss(Ss(s,0),0),0),[n[0],n[1],n[2],1,1]);throw new Error("eye() currently supports only 1D and 2D batchShapes, but received "+n.length+"D.")}});function Is(e,t,n){var r={shape:e,value:t,dtype:n};return $r.runKernel(He,{},r)}var Ms=la({floor_:function(e){var t={x:ia(e,"x","floor","float32")};return $r.runKernel(je,t)}});var Ts=la({gather_:function(e,t,n,r){void 0===n&&(n=0),void 0===r&&(r=0);var a={x:ia(e,"x","gather"),indices:ia(t,"indices","gather","int32")},o={axis:n,batchDims:r};return $r.runKernel(Ye,a,o)}});var Ds=la({greater_:function(e,t){var n,r=ia(e,"a","greater","string_or_numeric"),a=ia(t,"b","greater","string_or_numeric");r=(n=l(Wr(r,a),2))[0],a=n[1],ps(r.shape,a.shape);var o={a:r,b:a};return $r.runKernel($e,o)}});var Rs=la({greaterEqual_:function(e,t){var n,r=ia(e,"a","greaterEqual","string_or_numeric"),a=ia(t,"b","greaterEqual","string_or_numeric");r=(n=l(Wr(r,a),2))[0],a=n[1],ps(r.shape,a.shape);var o={a:r,b:a};return $r.runKernel(Qe,o)}});var Fs=la({imag_:function(e){var t={input:ia(e,"input","imag")};return $r.runKernel(nt,t)}});var Bs=la({isFinite_:function(e){var t={x:ia(e,"x","isFinite")};return $r.runKernel(rt,t)}});var Cs=la({isInf_:function(e){var t={x:ia(e,"x","isInf")};return $r.runKernel(at,t)}});var Ps=la({isNaN_:function(e){var t={x:ia(e,"x","isNaN")};return $r.runKernel(ot,t)}});var Os=la({leakyRelu_:function(e,t){void 0===t&&(t=.2);var n={x:ia(e,"x","leakyRelu")},r={alpha:t};return $r.runKernel(it,n,r)}});var Ls=la({less_:function(e,t){var n,r=ia(e,"a","less","string_or_numeric"),a=ia(t,"b","less","string_or_numeric");r=(n=l(Wr(r,a),2))[0],a=n[1],ps(r.shape,a.shape);var o={a:r,b:a};return $r.runKernel(st,o)}});var zs=la({lessEqual_:function(e,t){var n,r=ia(e,"a","lessEqual","string_or_numeric"),a=ia(t,"b","lessEqual","string_or_numeric");r=(n=l(Wr(r,a),2))[0],a=n[1],ps(r.shape,a.shape);var o={a:r,b:a};return $r.runKernel(ut,o)}});var Ks=la({localResponseNormalization_:function(e,t,n,r,a){void 0===t&&(t=5),void 0===n&&(n=1),void 0===r&&(r=1),void 0===a&&(a=.5);var o=ia(e,"x","localResponseNormalization");m(4===o.rank||3===o.rank,(function(){return"Error in localResponseNormalization: x must be rank 3 or 4 but got\n               rank "+o.rank+"."})),m(E(t),(function(){return"Error in localResponseNormalization: depthRadius must be an integer but got depthRadius "+t+"."}));var i=o,s=!1;3===o.rank&&(s=!0,i=Ti(o,[1,o.shape[0],o.shape[1],o.shape[2]]));var u={x:i},l={depthRadius:t,bias:n,alpha:r,beta:a},c=$r.runKernel("LRN",u,l);return s?Ti(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});var qs=la({log_:function(e){var t={x:ia(e,"x","log","float32")};return $r.runKernel("Log",t)}});var Ws=la({log1p_:function(e){var t={x:ia(e,"x","log1p")};return $r.runKernel(ct,t)}});function Us(e,t){m(L(e),(function(){return"The f passed in variableGrads(f) must be a function"})),m(null==t||Array.isArray(t)&&t.every((function(e){return e instanceof zr})),(function(){return"The varList passed in variableGrads(f, varList) must be an array of variables"}));var n=null!=t;if(!n)for(var r in t=[],$r.registeredVariables)t.push($r.registeredVariables[r]);var a=n?t.filter((function(e){return!e.trainable})):null,o=t.length;m((t=t.filter((function(e){return e.trainable}))).length>0,(function(){return"variableGrads() expects at least one of the input variables to be trainable, but none of the "+o+" variables is trainable."}));var i=$r.gradients(e,t,null,!0),s=i.value,u=i.grads;m(u.some((function(e){return null!=e})),(function(){return"Cannot find a connection between any variable and the result of the loss function y=f(x). Please make sure the operations that use variables are inside the function f passed to minimize()."})),m(0===s.rank,(function(){return"The f passed in variableGrads(f) must return a scalar, but it returned a rank-"+s.rank+" tensor"}));var l={};return t.forEach((function(e,t){null!=u[t]&&(l[e.name]=u[t])})),null!=a&&a.forEach((function(e){return l[e.name]=null})),{value:s,grads:l}}function Gs(e){return $r.customGrad(e)}function Hs(e){if(e.filter((function(e){return null==e})).length>0)throw new Error("Cannot compute gradient of y=f(x) with respect to x. Make sure that\n    the f you passed encloses all operations that lead from x to y.")}var Vs=la({neg_:function(e){var t={x:ia(e,"x","neg")};return $r.runKernel("Neg",t)}});var js=la({softplus_:function(e){var t={x:ia(e,"x","softplus")};return $r.runKernel(Xt,t)}});var Js=la({logSigmoid_:function(e){var t=ia(e,"x","logSigmoid");return Gs((function(e){return{value:Vs(js(Vs(e))),gradFunc:function(t){return oi(t,Bi(Vs(e)))}}}))(t)}});var Zs=la({max_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r={x:ia(e,"x","max")},a={reductionIndices:t,keepDims:n};return $r.runKernel("Max",r,a)}});var Ys=la({sub_:function(e,t){var n,r=ia(e,"a","sub"),a=ia(t,"b","sub"),o={a:r=(n=l(Wr(r,a),2))[0],b:a=n[1]};return $r.runKernel("Sub",o)}});var Xs=la({sum_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r=ia(e,"x","sum");"bool"===r.dtype&&(r=to(r,"int32"));var a={x:r},o={axis:t,keepDims:n};return $r.runKernel("Sum",a,o)}});var $s=la({logSoftmax_:function(e,t){void 0===t&&(t=-1);var n=ia(e,"logits","logSoftmax");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error("Log Softmax along a non-last dimension is not yet supported. Logits was rank "+n.rank+" and axis was "+t);return Gs((function(e,n){var r=Zs(e,t,!0),a=Ys(e,r),o=Ys(to(a,"float32"),qs(Xs(Es(a),t,!0)));n([o]);return{value:o,gradFunc:function(e,n){var r=l(n,1)[0],a=Es(r);return Ys(e,oi(Xs(e,t,!0),a))}}}))(n)}});function Qs(e,t){for(var n=0;n<e.length;++n)if(e[e.length-n-1]!==t-1-n)return!1;return!0}function eu(e,t,n){for(var r=e.length+t.length,a=[],o=0,i=0,s=0;s<r;s++)-1===n.indexOf(s)?a.push(e[o++]):a.push(t[i++]);return a}function tu(e,t){return eu(e,t.map((function(e){return 1})),t)}var nu=la({logSumExp_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r=ia(e,"x","logSumExp"),a=A(t,r.shape),o=Zs(r,a,!0),i=Ys(r,o),s=Es(i),u=Xs(s,a),l=qs(u),c=ni(Ti(o,l.shape),l);if(n){var h=tu(c.shape,a);return Ti(c,h)}return c}});var ru=la({logicalAnd_:function(e,t){var n=ia(e,"a","logicalAnd","bool"),r=ia(t,"b","logicalAnd","bool");ps(n.shape,r.shape);var a={a:n,b:r};return $r.runKernel(ht,a)}});var au=la({logicalNot_:function(e){var t={x:ia(e,"x","logicalNot","bool")};return $r.runKernel(ft,t)}});var ou=la({logicalOr_:function(e,t){var n=ia(e,"a","logicalOr","bool"),r=ia(t,"b","logicalOr","bool");ps(n.shape,r.shape);var a={a:n,b:r};return $r.runKernel(dt,a)}});var iu=la({logicalXor_:function(e,t){var n=ia(e,"a","logicalXor","bool"),r=ia(t,"b","logicalXor","bool");return ps(n.shape,r.shape),ru(ou(e,t),au(ru(e,t)))}});var su=la({maxPool_:function(e,t,n,r,a){var o=ia(e,"x","maxPool"),i=o,s=!1;3===o.rank&&(s=!0,i=Ti(o,[1,o.shape[0],o.shape[1],o.shape[2]])),m(4===i.rank,(function(){return"Error in maxPool: input must be rank 4 but got rank "+i.rank+"."})),m(Ii(n,1),(function(){return"Error in maxPool: Either strides or dilations must be 1. Got strides "+n+" and dilations '1'"})),null!=a&&m(E(r),(function(){return"Error in maxPool: pad must be an integer when using, dimRoundingMode "+a+" but got pad "+r+"."}));var u={x:i},l={filterSize:t,strides:n,pad:r,dimRoundingMode:a},c=$r.runKernel(vt,u,l);return s?Ti(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});var uu=la({maxPool3d_:function(e,t,n,r,a,o){void 0===t&&(t=[1,1,1]),void 0===o&&(o="NDHWC");var i=ia(e,"x","maxPool3d"),s=i,u=!1;4===i.rank&&(u=!0,s=Ti(i,[1,i.shape[0],i.shape[1],i.shape[2],i.shape[3]])),m(5===s.rank,(function(){return"Error in maxPool3d: x must be rank 5 but got rank "+s.rank+"."})),m("NDHWC"===o,(function(){return"Error in maxPool3d: Only NDHWC is currently supported, but got dataFormat of "+o})),null!=a&&m(E(r),(function(){return"Error in maxPool3d: pad must be an integer when using, dimRoundingMode "+a+" but got pad "+r+"."}));var l={x:s},c={filterSize:t,strides:n,pad:r,dimRoundingMode:a,dataFormat:o},h=$r.runKernel(gt,l,c);return u?Ti(h,[h.shape[1],h.shape[2],h.shape[3],h.shape[4]]):h}});var lu=la({maxPoolWithArgmax_:function(e,t,n,r,a){void 0===a&&(a=!1);var o={x:ia(e,"x","maxPoolWithArgmax")},i={filterSize:t,strides:n,pad:r,includeBatchInIndex:a},s=$r.runKernel(mt,o,i);return{result:s[0],indexes:s[1]}}});var cu=la({maximum_:function(e,t){var n,r=ia(e,"a","maximum"),a=ia(t,"b","maximum");r=(n=l(Wr(r,a),2))[0],a=n[1],"bool"===r.dtype&&(r=to(r,"int32"),a=to(a,"int32")),ps(r.shape,a.shape);var o={a:r,b:a};return $r.runKernel(pt,o)}});var hu=la({mean_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r={x:ia(e,"x","mean")},a={axis:t,keepDims:n};return $r.runKernel(yt,r,a)}});function fu(e,t){if(void 0===t&&(t="float32"),"complex64"===t){var n=fu(e,"float32"),r=fu(e,"float32");return ca(n,r)}var a=G(k(e),t);return $r.makeTensor(a,e,t)}function du(e,t){if(void 0===t&&(t="float32"),"complex64"===t){var n=du(e,"float32"),r=fu(e,"float32");return ca(n,r)}var a=U(k(e),t);return $r.makeTensor(a,e,t)}var pu=la({min_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r={x:ia(e,"x","min")},a={axis:t,keepDims:n};return $r.runKernel("Min",r,a)}});var vu=la({minimum_:function(e,t){var n,r=ia(e,"a","minimum"),a=ia(t,"b","minimum");r=(n=l(Wr(r,a),2))[0],a=n[1],"bool"===r.dtype&&(r=to(r,"int32"),a=to(a,"int32")),ps(r.shape,a.shape);var o={a:r,b:a};return $r.runKernel(bt,o)}});var gu=la({mirrorPad_:function(e,t,n){m("reflect"===n||"symmetric"===n,(function(){return"Invalid mode. Mode must be either reflect or symmetric. Got "+n+"."}));var r=ia(e,"x","mirrorPad");if(0===r.rank)throw new Error("mirrorPad(scalar) is not defined. Pass non-scalar to mirrorPad");m(t.length===r.rank,(function(){return"Padding doesn't match input. Must be "+r.rank+". Got "+t.length+"."}));for(var a="reflect"===n?1:0,o=function(e){m(2===t[e].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),m(t[e][0]>=0&&t[e][0]<=r.shape[e]-a&&t[e][1]>=0&&t[e][1]<=r.shape[e]-a,(function(){return"Padding in dimension "+e+" cannot be greater than or equal to "+(r.shape[e]-a)+" or less than 0 for input of shape "+r.shape}))},i=0;i<r.rank;i++)o(i);var s={paddings:t,mode:n},u={x:r};return $r.runKernel(wt,u,s)}});var mu=la({mod_:function(e,t){var n,r=ia(e,"a","mod"),a=ia(t,"b","mod"),o={a:r=(n=l(Wr(r,a),2))[0],b:a=n[1]};return $r.runKernel("Mod",o)}});var yu=la({square_:function(e){var t=ia(e,"x","square");return $r.runKernel("Square",{x:t},{})}});var bu=la({moments_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r=A(t,(e=ia(e,"x","moments")).shape),a=hu(e,r,n),o=a.shape;n||(o=tu(a.shape,r));var i=yu(Ys(to(e,"float32"),Ti(a,o)));return{mean:a,variance:hu(i,r,n)}}});var wu=la({multiRNNCell_:function(e,t,n,r){for(var a=ia(t,"data","multiRNNCell"),o=sa(n,"c","multiRNNCell"),i=sa(r,"h","multiRNNCell"),s=a,u=[],l=0;l<e.length;l++){var c=e[l](s,o[l],i[l]);u.push(c[0]),u.push(c[1]),s=c[1]}var h=[],f=[];for(l=0;l<u.length;l+=2)h.push(u[l]),f.push(u[l+1]);return[h,f]}});var ku=la({multinomial_:function(e,t,n,r){void 0===r&&(r=!1);var a=ia(e,"logits","multinomial"),o=a.size,i=a.rank;if(o<2)throw new Error("Error in multinomial: you need at least 2 outcomes, but got "+o+".");if(i>2)throw new Error("Rank of probabilities must be 1 or 2, but is "+i);n=n||Math.random();var s={logits:1===i?Ti(a,[1,-1]):a},u={numSamples:t,seed:n,normalized:r},l=$r.runKernel(kt,s,u);return 1===i?Ti(l,[l.size]):l}});var xu=la({notEqual_:function(e,t){var n,r=ia(e,"a","notEqual","string_or_numeric"),a=ia(t,"b","notEqual","string_or_numeric");r=(n=l(Wr(r,a),2))[0],a=n[1],ps(r.shape,a.shape);var o={a:r,b:a};return $r.runKernel(Et,o)}});var Eu=la({onesLike_:function(e){var t={x:ia(e,"x","onesLike")};return $r.runKernel(Nt,t)}});var Su=la({outerProduct_:function(e,t){var n=ia(e,"v1","outerProduct"),r=ia(t,"v2","outerProduct");m(1===n.rank&&1===r.rank,(function(){return"Error in outerProduct: inputs must be rank 1, but got ranks "+n.rank+" and "+r.rank+"."}));var a=Ti(n,[-1,1]),o=Ti(r,[1,-1]);return yo(a,o)}});var Au=la({pad_:function(e,t,n){void 0===n&&(n=0);var r=ia(e,"x","pad");if(0===r.rank)throw new Error("pad(scalar) is not defined. Pass non-scalar to pad");var a={paddings:t,constantValue:n},o={x:r};return $r.runKernel(Tt,o,a)}});var _u=la({pad1d_:function(e,t,n){return void 0===n&&(n=0),m(2===t.length,(function(){return"Invalid number of paddings. Must be length of 2."})),Au(e,[t],n)}});var Nu=la({pad2d_:function(e,t,n){return void 0===n&&(n=0),m(2===t.length&&2===t[0].length&&2===t[1].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),Au(e,t,n)}});var Iu=la({pad3d_:function(e,t,n){return void 0===n&&(n=0),m(3===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),Au(e,t,n)}});var Mu=la({pad4d_:function(e,t,n){return void 0===n&&(n=0),m(4===t.length&&2===t[0].length&&2===t[1].length&&2===t[2].length&&2===t[3].length,(function(){return"Invalid number of paddings. Must be length of 2 each."})),Au(e,t,n)}});var Tu=la({spaceToBatchND_:function(e,t,n){var r=ia(e,"x","spaceToBatchND");m(r.rank>=1+t.length,(function(){return"input rank "+r.rank+" should be > than [blockShape] "+t.length})),m(n.length===t.length,(function(){return"paddings.shape[0] "+n.length+" must be equal to [blockShape] "+t.length})),m(r.shape.reduce((function(e,r,a){return a>0&&a<=t.length?e&&(r+n[a-1][0]+n[a-1][1])%t[a-1]==0:e}),!0),(function(){return"input spatial dimensions "+r.shape.slice(1)+" with paddings "+n.toString()+" must be divisible by blockShapes "+t.toString()}));var a={x:r},o={blockShape:t,paddings:n};return $r.runKernel(Qt,a,o)}});var Du=la({pool_:function(e,t,n,r,a,o){null==a&&(a=[1,1]),null==o&&(o=1),0===r&&(r="valid");var i=ia(e,"x","maxPool"),s=i,u=!1;3===i.rank&&(u=!0,s=Ti(i,[1,i.shape[0],i.shape[1],i.shape[2]])),m(Ii(o,a),(function(){return"Error in pool: Either strides or dilations must be 1. Got strides "+o+" and dilations '"+a+"'"}));var c,h=bi(s.shape,t,o,a,r),f=[h.dilationHeight,h.dilationWidth];c="same"===r?function(e,t){var n=e.map((function(e,n){return e+(e-1)*(t[n]-1)})).map((function(e){return e-1})),r=n.map((function(e){return Math.floor(e/2)})),a=n.map((function(e,t){return e-r[t]}));return n.map((function(e,t){return[r[t],a[t]]}))}([h.filterHeight,h.filterWidth],f):[[0,0],[0,0]];var d=1===f[0]&&1===f[1],p=l(function(e,t,n){var r=n.map((function(e){return e[0]})),a=n.map((function(e){return e[1]})),o=e.concat(r,a),i=t.map((function(e,t){return(e-o[t]%e)%e})),s=a.map((function(e,t){return e+i[t]})),u=t.map((function(e,t){return[r[t],s[t]]})),l=t.map((function(e,t){return[0,i[t]]}));return[u,l]}([h.inHeight,h.inWidth],f,c),2),v=p[0],g=p[1],y=d?r:"valid",b=d?s:Tu(s,f,v),w=("avg"===n?function(){return Di(b,t,o,y)}:function(){return su(b,t,o,y)})(),k=d?w:Li(w,f,g);return u?Ti(k,[k.shape[1],k.shape[2],k.shape[3]]):k}});var Ru=la({pow_:function(e,t){var n,r=ia(e,"base","pow"),a=ia(t,"exp","pow"),o={a:r=(n=l(Wr(r,a),2))[0],b:a=n[1]};return $r.runKernel("Pow",o)}});var Fu=la({prelu_:function(e,t){var n={x:ia(e,"x","prelu"),alpha:ia(t,"alpha","prelu")};return $r.runKernel(Dt,n)}});var Bu=la({prod_:function(e,t,n){void 0===t&&(t=null),void 0===n&&(n=!1);var r=ia(e,"x","prod");"bool"===r.dtype&&(r=to(r,"int32"));var a={x:r},o={axis:t,keepDims:n};return $r.runKernel(Rt,a,o)}});var Cu=la({rand_:function(e,t,n){var r=k(e),a=null;if(null==n||"float32"===n)a=new Float32Array(r);else if("int32"===n)a=new Int32Array(r);else{if("bool"!==n)throw new Error("Unknown data type "+n);a=new Uint8Array(r)}for(var o=0;o<r;o++)a[o]=t();return $r.makeTensor(a,e,n)}}),Pu="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function Ou(e){var t={exports:{}};return e(t,t.exports),t.exports}var Lu=Ou((function(e){!function(e,t,n){function r(e){var t,n=this,r=(t=4022871197,function(e){e=String(e);for(var n=0;n<e.length;n++){var r=.02519603282416938*(t+=e.charCodeAt(n));r-=t=r>>>0,t=(r*=t)>>>0,t+=4294967296*(r-=t)}return 2.3283064365386963e-10*(t>>>0)});n.next=function(){var e=2091639*n.s0+2.3283064365386963e-10*n.c;return n.s0=n.s1,n.s1=n.s2,n.s2=e-(n.c=0|e)},n.c=1,n.s0=r(" "),n.s1=r(" "),n.s2=r(" "),n.s0-=r(e),n.s0<0&&(n.s0+=1),n.s1-=r(e),n.s1<0&&(n.s1+=1),n.s2-=r(e),n.s2<0&&(n.s2+=1),r=null}function a(e,t){return t.c=e.c,t.s0=e.s0,t.s1=e.s1,t.s2=e.s2,t}function o(e,t){var n=new r(e),o=t&&t.state,i=n.next;return i.int32=function(){return 4294967296*n.next()|0},i.double=function(){return i()+11102230246251565e-32*(2097152*i()|0)},i.quick=i,o&&("object"==typeof o&&a(o,n),i.state=function(){return a(n,{})}),i}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.alea=o}(0,e,!1)})),zu=Ou((function(e){!function(e,t,n){function r(e){var t=this,n="";t.x=0,t.y=0,t.z=0,t.w=0,t.next=function(){var e=t.x^t.x<<11;return t.x=t.y,t.y=t.z,t.z=t.w,t.w^=t.w>>>19^e^e>>>8},e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),t.next()}function a(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t}function o(e,t){var n=new r(e),o=t&&t.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},i.int32=n.next,i.quick=i,o&&("object"==typeof o&&a(o,n),i.state=function(){return a(n,{})}),i}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xor128=o}(0,e,!1)})),Ku=Ou((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.x^t.x>>>2;return t.x=t.y,t.y=t.z,t.z=t.w,t.w=t.v,(t.d=t.d+362437|0)+(t.v=t.v^t.v<<4^e^e<<1)|0},t.x=0,t.y=0,t.z=0,t.w=0,t.v=0,e===(0|e)?t.x=e:n+=e;for(var r=0;r<n.length+64;r++)t.x^=0|n.charCodeAt(r),r==n.length&&(t.d=t.x<<10^t.x>>>4),t.next()}function a(e,t){return t.x=e.x,t.y=e.y,t.z=e.z,t.w=e.w,t.v=e.v,t.d=e.d,t}function o(e,t){var n=new r(e),o=t&&t.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},i.int32=n.next,i.quick=i,o&&("object"==typeof o&&a(o,n),i.state=function(){return a(n,{})}),i}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xorwow=o}(0,e,!1)})),qu=Ou((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.x,a=t.i;return e=r[a],n=(e^=e>>>7)^e<<24,n^=(e=r[a+1&7])^e>>>10,n^=(e=r[a+3&7])^e>>>3,n^=(e=r[a+4&7])^e<<7,e=r[a+7&7],n^=(e^=e<<13)^e<<9,r[a]=n,t.i=a+1&7,n},function(e,t){var n,r=[];if(t===(0|t))r[0]=t;else for(t=""+t,n=0;n<t.length;++n)r[7&n]=r[7&n]<<15^t.charCodeAt(n)+r[n+1&7]<<13;for(;r.length<8;)r.push(0);for(n=0;n<8&&0===r[n];++n);for(8==n&&(r[7]=-1),e.x=r,e.i=0,n=256;n>0;--n)e.next()}(t,e)}function a(e,t){return t.x=e.x.slice(),t.i=e.i,t}function o(e,t){null==e&&(e=+new Date);var n=new r(e),o=t&&t.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},i.int32=n.next,i.quick=i,o&&(o.x&&a(o,n),i.state=function(){return a(n,{})}),i}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xorshift7=o}(0,e,!1)})),Wu=Ou((function(e){!function(e,t,n){function r(e){var t=this;t.next=function(){var e,n,r=t.w,a=t.X,o=t.i;return t.w=r=r+1640531527|0,n=a[o+34&127],e=a[o=o+1&127],n^=n<<13,e^=e<<17,n^=n>>>15,e^=e>>>12,n=a[o]=n^e,t.i=o,n+(r^r>>>16)|0},function(e,t){var n,r,a,o,i,s=[],u=128;for(t===(0|t)?(r=t,t=null):(t+="\0",r=0,u=Math.max(u,t.length)),a=0,o=-32;o<u;++o)t&&(r^=t.charCodeAt((o+32)%t.length)),0===o&&(i=r),r^=r<<10,r^=r>>>15,r^=r<<4,r^=r>>>13,o>=0&&(i=i+1640531527|0,a=0==(n=s[127&o]^=r+i)?a+1:0);for(a>=128&&(s[127&(t&&t.length||0)]=-1),a=127,o=512;o>0;--o)r=s[a+34&127],n=s[a=a+1&127],r^=r<<13,n^=n<<17,r^=r>>>15,n^=n>>>12,s[a]=r^n;e.w=i,e.X=s,e.i=a}(t,e)}function a(e,t){return t.i=e.i,t.w=e.w,t.X=e.X.slice(),t}function o(e,t){null==e&&(e=+new Date);var n=new r(e),o=t&&t.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},i.int32=n.next,i.quick=i,o&&(o.X&&a(o,n),i.state=function(){return a(n,{})}),i}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.xor4096=o}(0,e,!1)})),Uu=Ou((function(e){!function(e,t,n){function r(e){var t=this,n="";t.next=function(){var e=t.b,n=t.c,r=t.d,a=t.a;return e=e<<25^e>>>7^n,n=n-r|0,r=r<<24^r>>>8^a,a=a-e|0,t.b=e=e<<20^e>>>12^n,t.c=n=n-r|0,t.d=r<<16^n>>>16^a,t.a=a-e|0},t.a=0,t.b=0,t.c=-1640531527,t.d=1367130551,e===Math.floor(e)?(t.a=e/4294967296|0,t.b=0|e):n+=e;for(var r=0;r<n.length+20;r++)t.b^=0|n.charCodeAt(r),t.next()}function a(e,t){return t.a=e.a,t.b=e.b,t.c=e.c,t.d=e.d,t}function o(e,t){var n=new r(e),o=t&&t.state,i=function(){return(n.next()>>>0)/4294967296};return i.double=function(){do{var e=((n.next()>>>11)+(n.next()>>>0)/4294967296)/(1<<21)}while(0===e);return e},i.int32=n.next,i.quick=i,o&&("object"==typeof o&&a(o,n),i.state=function(){return a(n,{})}),i}t&&t.exports?t.exports=o:n&&n.amd?n((function(){return o})):this.tychei=o}(0,e,!1)})),Gu=Ou((function(e){!function(t,n,a){var o,i=256,s=a.pow(i,6),u=a.pow(2,52),l=2*u,c=255;function h(e,r,c){var h=[],m=v(p((r=1==r?{entropy:!0}:r||{}).entropy?[e,g(n)]:null==e?function(){try{var e;return o&&(e=o.randomBytes)?e=e(i):(e=new Uint8Array(i),(t.crypto||t.msCrypto).getRandomValues(e)),g(e)}catch(e){var r=t.navigator,a=r&&r.plugins;return[+new Date,t,a,t.screen,g(n)]}}():e,3),h),y=new f(h),b=function(){for(var e=y.g(6),t=s,n=0;e<u;)e=(e+n)*i,t*=i,n=y.g(1);for(;e>=l;)e/=2,t/=2,n>>>=1;return(e+n)/t};return b.int32=function(){return 0|y.g(4)},b.quick=function(){return y.g(4)/4294967296},b.double=b,v(g(y.S),n),(r.pass||c||function(e,t,n,r){return r&&(r.S&&d(r,y),e.state=function(){return d(y,{})}),n?(a.random=e,t):e})(b,m,"global"in r?r.global:this==a,r.state)}function f(e){var t,n=e.length,r=this,a=0,o=r.i=r.j=0,s=r.S=[];for(n||(e=[n++]);a<i;)s[a]=a++;for(a=0;a<i;a++)s[a]=s[o=c&o+e[a%n]+(t=s[a])],s[o]=t;(r.g=function(e){for(var t,n=0,a=r.i,o=r.j,s=r.S;e--;)t=s[a=c&a+1],n=n*i+s[c&(s[a]=s[o=c&o+t])+(s[o]=t)];return r.i=a,r.j=o,n})(i)}function d(e,t){return t.i=e.i,t.j=e.j,t.S=e.S.slice(),t}function p(e,t){var n,r=[],a=typeof e;if(t&&"object"==a)for(n in e)try{r.push(p(e[n],t-1))}catch(e){}return r.length?r:"string"==a?e:e+"\0"}function v(e,t){for(var n,r=e+"",a=0;a<r.length;)t[c&a]=c&(n^=19*t[c&a])+r.charCodeAt(a++);return g(t)}function g(e){return String.fromCharCode.apply(0,e)}if(v(a.random(),n),e.exports){e.exports=h;try{o=r.default}catch(e){}}else a.seedrandom=h}("undefined"!=typeof self?self:Pu,[],Math)}));Gu.alea=Lu,Gu.xor128=zu,Gu.xorwow=Ku,Gu.xorshift7=qu,Gu.xor4096=Wu,Gu.tychei=Uu;var Hu=Gu,Vu=function(){function e(e,t,n,r,a){this.mean=e,this.stdDev=t,this.dtype=n,this.nextVal=NaN,this.truncated=r,this.truncated&&(this.upper=this.mean+2*this.stdDev,this.lower=this.mean-2*this.stdDev);var o=a||Math.random();this.random=Hu.alea(o.toString())}return e.prototype.nextValue=function(){if(!isNaN(this.nextVal)){var e=this.nextVal;return this.nextVal=NaN,e}for(var t,n,r=!1;!r;){var a=void 0,o=void 0,i=void 0;do{i=(a=2*this.random()-1)*a+(o=2*this.random()-1)*o}while(i>=1||0===i);var s=Math.sqrt(-2*Math.log(i)/i);t=this.mean+this.stdDev*a*s,n=this.mean+this.stdDev*o*s,this.truncated&&!this.isValidTruncated(t)||(r=!0)}return this.truncated&&!this.isValidTruncated(n)||(this.nextVal=this.convertValue(n)),this.convertValue(t)},e.prototype.convertValue=function(e){return null==this.dtype||"float32"===this.dtype?e:Math.round(e)},e.prototype.isValidTruncated=function(e){return e<=this.upper&&e>=this.lower},e}(),ju=function(){function e(e,t,n,r){this.alpha=e,this.beta=1/t,this.dtype=n;var a=r||Math.random();this.randu=Hu.alea(a.toString()),this.randn=new Vu(0,1,n,!1,this.randu()),this.d=e<1?e+2/3:e-1/3,this.c=1/Math.sqrt(9*this.d)}return e.prototype.nextValue=function(){for(var e,t,n,r,a,o;;){do{r=this.randn.nextValue(),o=1+this.c*r}while(o<=0);if(o*=o*o,t=1-.331*(e=r*r)*e,n=.5*e+this.d*(1-o+Math.log(o)),(a=this.randu())<t||Math.log(a)<n)break}return o=1/this.beta*this.d*o,this.alpha<1&&(o*=Math.pow(this.randu(),1/this.alpha)),this.convertValue(o)},e.prototype.convertValue=function(e){return"float32"===this.dtype?e:Math.round(e)},e}(),Ju=function(){function e(e,t,n,r){var a=this;if(void 0===e&&(e=0),void 0===t&&(t=1),this.canReturnFloat=function(){return null==a.dtype||"float32"===a.dtype},this.min=e,this.range=t-e,this.dtype=n,null==r&&(r=Math.random()),"number"==typeof r&&(r=r.toString()),!this.canReturnFloat()&&this.range<=1)throw new Error("The difference between "+e+" - "+t+" <= 1 and dtype is not float");this.random=Hu.alea(r)}return e.prototype.convertValue=function(e){return this.canReturnFloat()?e:Math.round(e)},e.prototype.nextValue=function(){return this.convertValue(this.min+this.range*this.random())},e}();var Zu=la({randomGamma_:function(e,t,n,r,a){if(void 0===n&&(n=1),void 0===r&&(r="float32"),null==n&&(n=1),null==r&&(r="float32"),"float32"!==r&&"int32"!==r)throw new Error("Unsupported data type "+r);for(var o=new ju(t,n,r,a),i=eo(e,r),s=0;s<i.values.length;s++)i.values[s]=o.nextValue();return i.toTensor()}});var Yu=la({randomNormal_:function(e,t,n,r,a){if(void 0===t&&(t=0),void 0===n&&(n=1),null!=r&&"bool"===r)throw new Error("Unsupported data type "+r);for(var o=new Vu(t,n,r,!1,a),i=eo(e,r),s=0;s<i.values.length;s++)i.values[s]=o.nextValue();return i.toTensor()}});var Xu=la({randomUniform_:function(e,t,n,r,a){void 0===t&&(t=0),void 0===n&&(n=1),void 0===r&&(r="float32");for(var o=eo(e,r),i=new Ju(t,n,null,a),s=0;s<o.values.length;s++)o.values[s]=i.nextValue();return o.toTensor()}});function $u(e,t,n,r){if(void 0===n&&(n=1),void 0===r&&(r="float32"),0===n)throw new Error("Cannot have a step of zero");var a={start:e,stop:t,step:n,dtype:r};return $r.runKernel(Ft,{},a)}var Qu=la({real_:function(e){var t={input:ia(e,"input","real")};return $r.runKernel(Bt,t)}});var el=la({reciprocal_:function(e){var t={x:ia(e,"x","reciprocal")};return $r.runKernel(Ct,t)}});var tl=la({relu_:function(e){var t={x:ia(e,"x","relu")};return $r.runKernel(Pt,t)}});var nl=la({relu6_:function(e){var t={x:ia(e,"x","relu6")};return $r.runKernel(Kt,t)}});var rl=la({reverse_:function(e,t){var n={x:ia(e,"x","reverse")},r={dims:t};return $r.runKernel(qt,n,r)}});var al=la({reverse1d_:function(e){var t=ia(e,"x","reverse");return m(1===t.rank,(function(){return"Error in reverse1D: x must be rank 1 but got rank "+t.rank+"."})),rl(t,0)}});var ol=la({reverse2d_:function(e,t){var n=ia(e,"x","reverse");return m(2===n.rank,(function(){return"Error in reverse2D: x must be rank 2 but got rank "+n.rank+"."})),rl(n,t)}});var il=la({reverse3d_:function(e,t){var n=ia(e,"x","reverse");return m(3===n.rank,(function(){return"Error in reverse3D: x must be rank 3 but got rank "+n.rank+"."})),rl(n,t)}});var sl=la({reverse4d_:function(e,t){var n=ia(e,"x","reverse");return m(4===n.rank,(function(){return"Error in reverse4D: x must be rank 4 but got rank "+n.rank+"."})),rl(n,t)}});var ul=la({round_:function(e){var t={x:ia(e,"x","round")};return $r.runKernel(Wt,t)}});var ll=la({rsqrt_:function(e){var t={x:ia(e,"x","rsqrt","float32")};return $r.runKernel(Ut,t)}});function cl(e,t){if((D(e)&&"string"!==t||Array.isArray(e))&&"complex64"!==t)throw new Error("Error creating a new Scalar: value must be a primitive (number|boolean|string)");if("string"===t&&D(e)&&!(e instanceof Uint8Array))throw new Error("When making a scalar from encoded string, the value must be `Uint8Array`.");return ha(e,[],[],t)}var hl=la({selu_:function(e){var t={x:ia(e,"x","selu")};return $r.runKernel(Vt,t)}});var fl=la({separableConv2d_:function(e,t,n,r,a,o,i){void 0===o&&(o=[1,1]),void 0===i&&(i="NHWC");var s=ia(e,"x","separableConv2d"),u=ia(t,"depthwiseFilter","separableConv2d"),l=ia(n,"pointwiseFilter","separableConv2d"),c=s,h=!1;if(3===s.rank&&(h=!0,c=Ti(s,[1,s.shape[0],s.shape[1],s.shape[2]])),"NCHW"===i)throw new Error("separableConv2d currently does not support dataFormat NCHW; only NHWC is supported");m(4===c.rank,(function(){return"Error in separableConv2d: input must be rank 4, but got rank "+c.rank+"."})),m(4===u.rank,(function(){return"Error in separableConv2d: depthwise filter must be rank 4, but got rank "+u.rank+"."})),m(4===l.rank,(function(){return"Error in separableConv2d: pointwise filter must be rank 4, but got rank "+u.rank+"."})),m(1===l.shape[0],(function(){return"Error in separableConv2d: the first dimension of pointwise filter  must be 1, but got "+l.shape[0]+"."})),m(1===l.shape[1],(function(){return"Error in separableConv2d: the second dimension of pointwise filter must be 1, but got "+l.shape[1]+"."}));var f=u.shape[2],d=u.shape[3];m(l.shape[2]===f*d,(function(){return"Error in separableConv2d: the third dimension of pointwise filter must be "+f*d+", but got "+l.shape[2]+"."}));var p=cs(c,u,r,a,i,o),v=$i(p,l,1,"valid",i);return h?Ti(v,[v.shape[1],v.shape[2],v.shape[3]]):v}});var dl=function(e,t){return i(this,void 0,void 0,(function(){var n,r,a,o,i,u,l,c,h,f;return s(this,(function(s){switch(s.label){case 0:return n=ia(e,"x","setdiff1d"),r=ia(t,"y","setdiff1d"),m(n.dtype===r.dtype,(function(){return"x and y should have the same dtype, but got x ("+n.dtype+") and y ("+r.dtype+")."})),m(1===n.rank,(function(){return"x should be 1D tensor, but got x ("+n.shape+")."})),m(1===r.rank,(function(){return"y should be 1D tensor, but got y ("+r.shape+")."})),[4,n.data()];case 1:return a=s.sent(),[4,r.data()];case 2:for(o=s.sent(),i=new Set(o),u=0,h=0;h<a.length;h++)i.has(a[h])||u++;for(l=new Tr([u],n.dtype),c=new Tr([u],"int32"),h=0,f=0;h<a.length;h++)i.has(a[h])||(l.values[f]=a[h],c.values[f]=h,f++);return[2,[l.toTensor(),c.toTensor()]]}}))}))};var pl=la({sign_:function(e){var t={x:ia(e,"x","sign")};return $r.runKernel(Zt,t)}});var vl=la({sin_:function(e){var t={x:ia(e,"x","sin","float32")};return $r.runKernel("Sin",t)}});var gl=la({sinh_:function(e){var t={x:ia(e,"x","sinh")};return $r.runKernel(Jt,t)}});var ml=la({slice1d_:function(e,t,n){var r=ia(e,"x","slice1d");return m(1===r.rank,(function(){return"slice1d expects a rank-1 tensor, but got a rank-"+r.rank+" tensor"})),Ci(r,[t],[n])}});var yl=la({slice2d_:function(e,t,n){var r=ia(e,"x","slice2d");return m(2===r.rank,(function(){return"slice2d expects a rank-2 tensor, but got a rank-"+r.rank+" tensor"})),Ci(r,t,n)}});var bl=la({slice3d_:function(e,t,n){var r=ia(e,"x","slice3d");return m(3===r.rank,(function(){return"slice3d expects a rank-3 tensor, but got a rank-"+r.rank+" tensor"})),Ci(r,t,n)}});var wl=la({slice4d_:function(e,t,n){var r=ia(e,"x","slice4d");return m(4===r.rank,(function(){return"slice4d expects a rank-4 tensor, but got a rank-"+r.rank+" tensor"})),Ci(r,t,n)}});var kl=la({softmax_:function(e,t){void 0===t&&(t=-1);var n=ia(e,"logits","softmax","float32");if(-1===t&&(t=n.rank-1),t!==n.rank-1)throw Error("Softmax along a non-last dimension is not yet supported. Logits was rank "+n.rank+" and dim was "+t);var r={logits:n},a={dim:t};return $r.runKernel(tn,r,a)}});var xl=la({fft_:function(e){m("complex64"===e.dtype,(function(){return"The dtype for tf.spectral.fft() must be complex64 but got "+e.dtype+"."}));var t={input:e};return $r.runKernel("FFT",t)}});var El=la({ifft_:function(e){m("complex64"===e.dtype,(function(){return"The dtype for tf.spectral.ifft() must be complex64 but got "+e.dtype+"."}));var t={input:e};return $r.runKernel(tt,t)}});var Sl=la({irfft_:function(e){var t,n=e.shape[e.shape.length-1],r=e.size/n;if(n<=2){var a=Ti(e,[r,n]);t=El(a)}else{var o=[r,2*(n-1)],i=Ti(Qu(e),[r,n]),s=Ti(Fs(e),[r,n]),u=rl(Ci(i,[0,1],[r,n-2]),1),l=oi(rl(Ci(s,[0,1],[r,n-2]),1),cl(-1)),c=Fi([i,u],1),h=Fi([s,l],1);a=Ti(ca(c,h),[o[0],o[1]]);t=El(a)}if(t=Qu(t),3===e.rank&&0!==e.shape[0]){var f=t,d=e.shape[0];t=Ti(t,[d,t.shape[0]/d,t.shape[1]]),f.dispose()}return t}});var Al=la({split_:function(e,t,n){void 0===n&&(n=0);var r={x:ia(e,"x","split")},a={numOrSizeSplits:t,axis:n};return $r.runKernel(en,r,a)}});var _l=la({rfft_:function(e,t){m("float32"===e.dtype,(function(){return"The dtype for rfft() must be real value but got "+e.dtype}));var n,r=e.shape[e.shape.length-1],a=e.size/r;if(null!=t&&t<r){var o=e.shape.map((function(e){return 0})),i=e.shape.map((function(e){return e}));i[e.shape.length-1]=t,n=Ci(e,o,i),r=t}else if(null!=t&&t>r){var s=e.shape.map((function(e){return e}));s[e.shape.length-1]=t-r,n=Fi([e,fu(s)],e.shape.length-1),r=t}else n=e;var u=ms(n),l=Ti(ca(n,u),[a,r]),c=xl(l),h=Math.floor(r/2)+1,f=Qu(c),d=Fs(c),p=Al(f,[h,r-h],f.shape.length-1),v=Al(d,[h,r-h],d.shape.length-1),g=n.shape.slice();return g[n.shape.length-1]=h,Ti(ca(p[0],v[0]),g)}});var Nl=la({sqrt_:function(e){var t={x:ia(e,"x","sqrt","float32")};return $r.runKernel($t,t)}});var Il=la({squaredDifference_:function(e,t){var n,r=ia(e,"a","squaredDifference"),a=ia(t,"b","squaredDifference");r=(n=l(Wr(r,a),2))[0],a=n[1],ps(r.shape,a.shape);var o={a:r,b:a};return $r.runKernel(un,o,{})}});var Ml=la({squeeze_:function(e,t){var n=ia(e,"x","squeeze");return Ti(n,_(n.shape,t).newShape)}});var Tl=la({stack_:function(e,t){void 0===t&&(t=0);var n=sa(e,"tensors","stack","string_or_numeric");m(n.length>=1,(function(){return"Pass at least one tensor to tf.stack"})),n.length>0&&m(t<=n[0].rank,(function(){return"Axis must be <= rank of the tensor"}));var r=n,a={axis:t};return $r.runKernel(Mt,r,a)}});var Dl=la({step_:function(e,t){void 0===t&&(t=0);var n={x:ia(e,"x","step")},r={alpha:t};return $r.runKernel(xn,n,r)}});var Rl=la({stridedSlice_:function(e,t,n,r,a,o,i,s,u){void 0===a&&(a=0),void 0===o&&(o=0),void 0===i&&(i=0),void 0===s&&(s=0),void 0===u&&(u=0);var l={x:ia(e,"x","stridedSlice","string_or_numeric")},c={begin:t,end:n,strides:r,beginMask:a,endMask:o,ellipsisMask:i,newAxisMask:s,shrinkAxisMask:u};return $r.runKernel(ln,l,c)}});var Fl=la({tan_:function(e){var t={x:ia(e,"x","tan","float32")};return $r.runKernel("Tan",t)}});function Bl(e,t){b(e);var n=ra(e,t);if(1!==n.length)throw new Error("tensor1d() requires values to be a flat/TypedArray");return ha(e,null,n,t)}function Cl(e,t,n){if(b(e),null!=t&&2!==t.length)throw new Error("tensor2d() requires shape to have two numbers");var r=ra(e,n);if(2!==r.length&&1!==r.length)throw new Error("tensor2d() requires values to be number[][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor2d() requires shape to be provided when `values` are a flat/TypedArray");return ha(e,t,r,n)}var Pl=la({topk_:function(e,t,n){void 0===t&&(t=1),void 0===n&&(n=!0);var r=ia(e,"x","topk");if(0===r.rank)throw new Error("topk() expects the input to be of rank 1 or higher");var a=r.shape[r.shape.length-1];if(t<0)throw new Error("'k' passed to topk() must be >= 0 but got "+t);if(t>a)throw new Error("'k' passed to topk() must be <= the last dimension ("+a+") but got "+t);var o={x:r},i={k:t,sorted:n},s=l($r.runKernel(vn,o,i),2);return{values:s[0],indices:s[1]}}});var Ol=la({truncatedNormal_:function(e,t,n,r,a){if(void 0===t&&(t=0),void 0===n&&(n=1),null!=r&&"bool"===r)throw new Error("Unsupported data type $ { dtype }");for(var o=new Vu(t,n,r,!0,a),i=eo(e,r),s=0;s<i.values.length;s++)i.values[s]=o.nextValue();return i.toTensor()}});var Ll=la({unique_:function(e,t){void 0===t&&(t=0);var n=ia(e,"x","unique","string_or_numeric");m(n.rank>0,(function(){return"The input tensor must be at least 1D"}));var r={x:n},a={axis:t},o=l($r.runKernel(yn,r,a),2);return{values:o[0],indices:o[1]}}});var zl=la({unsortedSegmentSum_:function(e,t,n){var r=ia(e,"x","unsortedSegmentSum"),a=ia(t,"segmentIds","unsortedSegmentSum","int32");m(E(n),(function(){return"numSegments must be of dtype int"}));var o={x:r,segmentIds:a},i={numSegments:n};return $r.runKernel(wn,o,i)}});var Kl=la({unstack_:function(e,t){void 0===t&&(t=0);var n=ia(e,"x","unstack","string_or_numeric");m(t>=-n.shape.length&&t<n.shape.length,(function(){return"Axis = "+t+" is not in [-"+n.shape.length+", "+n.shape.length+")"}));var r={value:n},a={axis:t};return $r.runKernel(bn,r,a)}});function ql(e,t){for(var n=[],r=0;r<t.length;r++)t[r]&&n.push(r);var a=eo(e,"int32"),o=eo([n.length,e.length],"int32");for(r=0;r<n.length;r++){var i=a.indexToLoc(n[r]),s=r*e.length;o.values.set(i,s)}return o.toTensor()}var Wl=function(e){return i(this,void 0,void 0,(function(){var t,n,r;return s(this,(function(a){switch(a.label){case 0:return[4,(t=ia(e,"condition","whereAsync","bool")).data()];case 1:return n=a.sent(),r=ql(t.shape,n),e!==t&&t.dispose(),[2,r]}}))}))};var Ul=function(e,t,n){return i(this,void 0,void 0,(function(){var r,a,o,i,u,l,c,h,f,d,p,v,g;return s(this,(function(s){switch(s.label){case 0:for(r=ia(e,"tensor","boolMask"),a=ia(t,"mask","boolMask","bool"),o=null==n?0:n,i=a.rank,u=r.shape,m(i>0,(function(){return"mask cannot be scalar"})),y(u.slice(o,o+i),a.shape,"mask's shape must match the first K dimensions of tensor's shape,"),l=1,c=o;c<o+i;c++)l*=u[c];return h=u.slice(0,o).concat([l],u.slice(o+i)),f=Ti(r,h),d=Ti(a,[-1]),[4,Wl(d)];case 1:return p=s.sent(),v=Ml(p,[1]),g=Ts(f,v,o),e!==r&&r.dispose(),t!==a&&a.dispose(),v.dispose(),f.dispose(),d.dispose(),p.dispose(),[2,g]}}))}))};function Gl(e,t,n){if(void 0===n&&(n=null),0===e.rank)return ii(e);if(1!==e.rank&&null===n)return Gl(Ti(e,[-1]),t,n);if(1===e.rank||"number"==typeof n||Array.isArray(n)&&1===n.length){if(1===t)return Xs(ii(e),n);if(t===1/0)return Zs(ii(e),n);if(t===-1/0)return pu(ii(e),n);if("euclidean"===t||2===t)return Nl(Xs(Ru(ii(e),cl(2,"int32")),n));throw new Error("Error in norm: invalid ord value: "+t)}if(Array.isArray(n)&&2===n.length){if(1===t)return Zs(Xs(ii(e),n[0]),n[1]-1);if(t===1/0)return Zs(Xs(ii(e),n[1]),n[0]);if(t===-1/0)return pu(Xs(ii(e),n[1]),n[0]);if("fro"===t||"euclidean"===t)return Nl(Xs(yu(e),n));throw new Error("Error in norm: invalid ord value: "+t)}throw new Error("Error in norm: invalid axis: "+n)}var Hl=la({norm_:function(e,t,n,r){void 0===t&&(t="euclidean"),void 0===n&&(n=null),void 0===r&&(r=!1);var a=Gl(e=ia(e,"x","norm"),t,n),o=a.shape;if(r){var i=A(n,e.shape);o=tu(a.shape,i)}return Ti(a,o)}});var Vl=la({movingAverage_:function(e,t,n,r,a){void 0===a&&(a=!0);var o=ia(e,"v","movingAverage"),i=ia(t,"x","movingAverage"),s=ia(n,"decay","movingAverage");Ur(o,i),m(x(o.shape,i.shape),(function(){return"Shape mismatch in v and x"}));var u=cl(1),l=Ys(u,s),c=oi(Ys(i,o),l);if(a){m(null!=r,(function(){return"When using zeroDebias: true, step is required."}));var h=ia(r,"step","movingAverage");c=ai(c,Ys(u,Ru(s,h)))}return ni(o,c)}});var jl=la({scatterND_:function(e,t,n){var r=ia(e,"indices","scatterND","int32"),a=ia(t,"updates","scatterND");To(a,r,n);var o={indices:r,updates:a},i={shape:n};return $r.runKernel(Gt,o,i)}});var Jl=la({sparseToDense_:function(e,t,n,r){void 0===r&&(r=0);var a=ia(e,"sparseIndices","sparseToDense","int32"),o=ia(t,"sparseValues","sparseToDense"),i=ia(r,"defaultValue","sparseToDense",o.dtype);!function(e,t,n,r){if("int32"!==e.dtype)throw new Error("tf.sparseToDense() expects the indices to be int32 type, but the dtype was "+e.dtype+".");if(e.rank>2)throw new Error("sparseIndices should be a scalar, vector, or matrix, but got shape "+e.shape+".");var a=e.rank>0?e.shape[0]:1,o=e.rank>1?e.shape[1]:1;if(n.length!==o)throw new Error("outputShape has incorrect number of elements:, "+n.length+", should be: "+o+".");var i=t.size;if(0!==t.rank&&(1!==t.rank||i!==a))throw new Error("sparseValues has incorrect shape "+t.shape+", should be [] or ["+a+"]");if(t.dtype!==r.dtype)throw new Error("sparseValues.dtype must match defaultValues.dtype")}(a,o,n,i);var s={sparseIndices:a,sparseValues:o,defaultValue:i},u={outputShape:n};return $r.runKernel(sn,s,u)}});var Zl=la({gatherND_:function(e,t){var n=ia(t,"indices","gatherND","int32"),r={params:ia(e,"x","gatherND","string_or_numeric"),indices:n};return $r.runKernel(Xe,r)}});var Yl=la({dropout_:function(e,t,n,r){var a=ia(e,"x","dropout");if(m("float32"===a.dtype,(function(){return"x has to be a floating point tensor since it's going to be scaled, but got a "+a.dtype+" tensor instead."})),m(t>=0&&t<1,(function(){return"rate must be a float in the range [0, 1), but got "+t+"."})),0===t)return e instanceof Fr?a.clone():a;var o=function(e,t){if(null==t)return e.shape.slice();if(x(e.shape,t))return t;if(e.shape.length===t.length){for(var n=[],r=0;r<e.shape.length;r++)null==t[r]&&null!=e.shape[r]?n.push(e.shape[r]):n.push(t[r]);return n}return t}(a,n),i=1-t,s=ai(Ms(ni(Xu(o,0,1,"float32",r),i)),i);return oi(a,s)}});function Xl(e){return Math.floor(Math.pow(2,Math.ceil(Math.log(e)/Math.log(2))))}function $l(e,t,n){for(var r=1-e%2,a=new Float32Array(e),o=0;o<e;++o){var i=2*Math.PI*o/(e+r-1);a[o]=t-n*Math.cos(i)}return Bl(a,"float32")}var Ql=function(e,t,n){return void 0===n&&(n=1),i(this,void 0,void 0,(function(){var r,a,o,i,u,c,h,f,d,p,v,g,b,w;return s(this,(function(s){switch(s.label){case 0:return r=ia(e,"predictions","inTopK"),a=ia(t,"targets","inTopK"),m(r.rank>1,(function(){return"inTopK() expects the predictions to be of rank 2 or higher, but got "+r.rank})),m(r.rank-1===a.rank,(function(){return"predictions rank should be 1 larger than targets rank, but got predictions rank "+r.rank+" and targets rank "+a.rank})),y(r.shape.slice(0,r.shape.length-1),a.shape,"predictions's shape should be align with the targets' shape, except the last dimension."),o=r.shape[r.shape.length-1],m(n>0&&n<=o,(function(){return"'k' passed to inTopK() must be > 0 && <= the predictions last dimension ("+o+"), but got "+n})),[4,r.data()];case 1:return i=s.sent(),[4,a.data()];case 2:for(u=s.sent(),c=l([i.length/o,o],2),h=c[0],f=c[1],d=N("bool",h),p=0;p<h;p++){for(v=p*f,g=i.subarray(v,v+f),b=[],w=0;w<g.length;w++)b.push({value:g[w],index:w});for(b.sort((function(e,t){return t.value-e.value})),d[p]=0,w=0;w<n;w++)if(b[w].index===u[p]){d[p]=1;break}}return e!==r&&r.dispose(),t!==a&&a.dispose(),[2,fa(d,a.shape,"bool")]}}))}))};var ec=la({conv2DBackpropFilter_:function(e,t,n,r,a,o,i){void 0===o&&(o="NHWC");var s=e;3===e.rank&&(s=Ti(e,[1,e.shape[0],e.shape[1],e.shape[2]]));var u=t;3===u.rank&&(u=Ti(t,[1,t.shape[0],t.shape[1],t.shape[2]])),m(4===s.rank,(function(){return"Error in conv2dDerFilter: input must be rank 4, but got shape "+s.shape+"."})),m(4===u.rank,(function(){return"Error in conv2dDerFilter: dy must be rank 4, but got shape "+u.shape+"."})),m(4===n.length,(function(){return"Error in conv2dDerFilter: filterShape must be length 4, but got "+n+"."}));var l="NHWC"===o?s.shape[3]:s.shape[1],c="NHWC"===o?u.shape[3]:u.shape[1];m(l===n[2],(function(){return"Error in conv2dDerFilter: depth of input "+l+") must match input depth in filter ("+n[2]+"."})),m(c===n[3],(function(){return"Error in conv2dDerFilter: depth of dy ("+c+") must match output depth for filter ("+n[3]+")."})),null!=i&&m(E(a),(function(){return"Error in conv2dDerFilter: pad must be an integer when using, dimRoundingMode "+i+" but got pad "+a+"."}));var h={x:s,dy:u},f={strides:r,pad:a,dataFormat:o,dimRoundingMode:i,filterShape:n};return $r.runKernel(_e,h,f)}});function tc(e,t,n){if(null==n||"linear"===n)return e;if("relu"===n)return oi(e,Dl(t));throw new Error("Cannot compute gradient for fused activation "+n+".")}function nc(e,t){var n=t,r=ds(e.shape,t.shape);return r.length>0&&(n=Xs(n,r)),Ti(n,e.shape)}function rc(e,t,n,r){if("linear"===t)return e;if("relu"===t)return tl(e);if("elu"===t)return ks(e);if("relu6"===t)return nl(e);if("prelu"===t)return Fu(e,n);if("leakyrelu"===t)return Os(e,r);if("sigmoid"===t)return Bi(e);throw new Error("Unknown fused activation "+t+".")}var ac=function(e,t){return!(e>0)||"linear"===t};var oc=la({fusedConv2d_:function(e){var t=e.x,n=e.filter,r=e.strides,a=e.pad,o=e.dataFormat,i=void 0===o?"NHWC":o,s=e.dilations,u=void 0===s?[1,1]:s,c=e.dimRoundingMode,h=e.bias,f=e.activation,d=void 0===f?"linear":f,p=e.preluActivationWeights,v=e.leakyreluAlpha;if(d=d||"linear",!1===ac($r.state.gradientDepth,d)){var g=$i(t,n,r,a,i,u,c);return null!=h&&(g=ni(g,h)),rc(g,d,p,v)}var y=ia(t,"x","conv2d","float32"),b=ia(n,"filter","conv2d","float32"),w=y,k=!1;3===y.rank&&(k=!0,w=Ti(y,[1,y.shape[0],y.shape[1],y.shape[2]])),m(4===w.rank,(function(){return"Error in fused conv2d: input must be rank 4, but got rank "+w.rank+"."})),m(4===b.rank,(function(){return"Error in fused conv2d: filter must be rank 4, but got rank "+b.rank+"."})),null!=c&&m(E(a),(function(){return"Error in fused conv2d: pad must be an integer when using, dimRoundingMode "+c+" but got pad "+a+"."})),m(w.shape[3]===b.shape[2],(function(){return"Error in conv2d: depth of input ("+w.shape[3]+") must match input depth for filter "+b.shape[2]+"."})),m(Ii(r,u),(function(){return"Error in conv2D: Either strides or dilations must be 1. Got strides "+r+" and dilations '"+u+"'"})),m("NHWC"===i,(function(){return"Error in conv2d: got dataFormat of "+i+" but only NHWC is currently supported."}));var x,S,A=wi(w.shape,b.shape,r,u,a,c);null!=h&&(x=l(Wr(x=ia(h,"bias","fused conv2d"),y),1)[0],ps(A.outShape,x.shape)),null!=p&&(S=ia(p,"prelu weights","fused conv2d"));var _=function(e,t){var n=l(t,4),o=n[0],i=n[1],s=n[2],c=n[3],h=tc(e,s,d);m(Ni(u),(function(){return"Error in gradient of fused conv2D: dilation rates greater than 1 are not yet supported in gradients. Got dilations '"+u+"'"}));var f=[es(i.shape,h,o,r,a),ec(i,h,o.shape,r,a)];if(null!=c){var p=nc(c,h);f.push(p)}return f},N={x:w,filter:b,bias:x,preluActivationWeights:S},I={strides:r,pad:a,dataFormat:i,dilations:u,dimRoundingMode:c,activation:d,leakyreluAlpha:v};return null==h?Gs((function(e,t,n){var r=$r.runKernel(_n,N,I);return n([t,e,r]),k&&(r=Ti(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:_}}))(w,b):Gs((function(e,t,n,r){var a=$r.runKernel(_n,N,I);return r([t,e,a,n]),k&&(a=Ti(a,[a.shape[1],a.shape[2],a.shape[3]])),{value:a,gradFunc:_}}))(w,b,x)}});var ic=la({depthwiseConv2dNativeBackpropFilter_:function(e,t,n,r,a,o,i){void 0===o&&(o=[1,1]);var s=e;3===e.rank&&(s=Ti(e,[1,e.shape[0],e.shape[1],e.shape[2]]));var u=t;3===u.rank&&(u=Ti(t,[1,t.shape[0],t.shape[1],t.shape[2]]));var l={x:s,dy:u},c={strides:r,pad:a,dimRoundingMode:i,dilations:o,filterShape:n};return $r.runKernel(Pe,l,c)}});var sc=la({depthwiseConv2dNativeBackpropInput_:function(e,t,n,r,a,o,i){void 0===o&&(o=[1,1]);var s=t,u=!1;3===t.rank&&(u=!0,s=Ti(t,[1,t.shape[0],t.shape[1],t.shape[2]]));var l={dy:s,filter:n},c={strides:r,pad:a,dimRoundingMode:i,dilations:o,inputShape:e},h=$r.runKernel(Oe,l,c);return u?Ti(h,[h.shape[1],h.shape[2],h.shape[3]]):h}});var uc={__proto__:null,conv2d:oc,depthwiseConv2d:la({fusedDepthwiseConv2d_:function(e){var t,n=e.x,r=e.filter,a=e.strides,o=e.pad,i=e.dataFormat,s=void 0===i?"NHWC":i,u=e.dilations,c=void 0===u?[1,1]:u,h=e.dimRoundingMode,f=e.bias,d=e.activation,p=void 0===d?"linear":d,v=e.preluActivationWeights,g=e.leakyreluAlpha;if(!1===ac($r.state.gradientDepth,p)){var y=cs(n,r,a,o,s,c,h);return null!=f&&(y=ni(y,f)),rc(y,p,v,g)}var b=ia(n,"x","depthwiseConv2d","float32"),w=ia(r,"filter","depthwiseConv2d","float32"),k=b,x=!1;3===b.rank&&(x=!0,k=Ti(b,[1,b.shape[0],b.shape[1],b.shape[2]])),m(4===k.rank,(function(){return"Error in fused depthwiseConv2d: input must be rank 4, but got rank "+k.rank+"."})),m(4===w.rank,(function(){return"Error in fused depthwiseConv2d: filter must be rank 4, but got rank "+w.rank+"."})),m(k.shape[3]===w.shape[2],(function(){return"Error in fused depthwiseConv2d: number of input channels ("+k.shape[3]+") must match the inChannels dimension in filter "+w.shape[2]+"."})),null==c&&(c=[1,1]),m(Ii(a,c),(function(){return"Error in fused depthwiseConv2d: Either strides or dilations must be 1. Got strides "+a+" and dilations '"+c+"'"})),null!=h&&m(E(o),(function(){return"Error in fused depthwiseConv2d: pad must be an integer when using dimRoundingMode "+h+" but got pad "+o+"."}));var S,A,_=wi(k.shape,w.shape,a,c,o,h,!0);null!=f&&(t=l(Wr(S=ia(f,"bias","fused conv2d"),b),1),S=t[0],ps(_.outShape,S.shape)),null!=v&&(A=ia(v,"prelu weights","fused depthwiseConv2d"));var N=function(e,t){m(Ni(c),(function(){return"Error in gradient of fused depthwiseConv2d: dilation rates greater than 1 are not yet supported. Got dilations '"+c+"'"}));var n=l(t,4),r=n[0],i=n[1],s=n[2],u=n[3],f=tc(e,s,p),d=sc(i.shape,f,r,a,o,c,h),v=ic(i,f,r.shape,a,o,c,h);return null!=u?[d,v,nc(S,f)]:[d,v]},I={x:k,filter:w,bias:S,preluActivationWeights:A},M={strides:a,pad:o,dataFormat:s,dilations:c,dimRoundingMode:h,activation:p,leakyreluAlpha:g};return null==f?Gs((function(e,t,n){var r=$r.runKernel(Nn,I,M);return n([t,e,r]),x&&(r=Ti(r,[r.shape[1],r.shape[2],r.shape[3]])),{value:r,gradFunc:N}}))(k,w):Gs((function(e,t,n,r){var a=$r.runKernel(Nn,I,M);return r([t,e,a,n]),x&&(a=Ti(a,[a.shape[1],a.shape[2],a.shape[3]])),{value:a,gradFunc:N}}))(k,w,S)}}),matMul:la({fusedMatMul_:function(e){var t,n=e.a,r=e.b,a=e.transposeA,o=void 0!==a&&a,i=e.transposeB,s=void 0!==i&&i,u=e.bias,c=e.activation,h=void 0===c?"linear":c,f=e.preluActivationWeights,d=e.leakyreluAlpha;if(!1===ac($r.state.gradientDepth,h)){var p=yo(n,r,o,s);return null!=u&&(p=ni(p,u)),rc(p,h,f,d)}var v=ia(n,"a","fused matMul"),g=ia(r,"b","fused matMul");t=l(Wr(v,g),2),v=t[0],g=t[1];var y=o?v.shape[v.rank-2]:v.shape[v.rank-1],b=s?g.shape[g.rank-1]:g.shape[g.rank-2],w=o?v.shape[v.rank-1]:v.shape[v.rank-2],E=s?g.shape[g.rank-2]:g.shape[g.rank-1],S=v.shape.slice(0,-2),A=g.shape.slice(0,-2),_=k(S),N=k(A);m(v.rank>=2&&g.rank>=2&&v.rank===g.rank,(function(){return"Error in fused matMul: inputs must have the same rank of at least 2, got ranks "+v.rank+" and "+g.rank+"."})),m(x(S,A),(function(){return"Error in fused matMul: outer dimensions ("+S+") and ("+A+") of Tensors with shapes "+v.shape+" and "+g.shape+" must match."})),m(y===b,(function(){return"Error in fused matMul: inner shapes ("+y+") and ("+b+") of Tensors with shapes "+v.shape+" and "+g.shape+" and transposeA="+o+" and transposeB="+s+" must match."}));var I,M,T=v.shape.slice(0,-2).concat([w,E]),D=Ti(v,o?[_,y,w]:[_,w,y]),R=Ti(g,s?[N,E,b]:[N,b,E]);null!=u&&(I=l(Wr(I=ia(u,"bias","fused matMul"),v),1)[0],ps(T,I.shape)),null!=f&&(M=ia(f,"prelu weights","fused matMul"));var F=function(e,t){var n,r,a=l(t,4),i=a[0],c=a[1],f=a[2],d=a[3],p=tc(Ti(e,f.shape),f,h);return o||s?!o&&s?(n=yo(p,c,!1,!1),r=yo(p,i,!0,!1)):o&&!s?(n=yo(c,p,!1,!0),r=yo(i,p,!1,!1)):(n=yo(c,p,!0,!0),r=yo(p,i,!0,!0)):(n=yo(p,c,!1,!0),r=yo(i,p,!0,!1)),null!=u?[n,r,nc(d,p)]:[n,r]},B={a:D,b:R,bias:I,preluActivationWeights:M},C={transposeA:o,transposeB:s,activation:h,leakyreluAlpha:d};return null==u?Gs((function(e,t,n){var r=$r.runKernel(An,B,C);return n([e,t,r]),{value:Ti(r,T),gradFunc:F}}))(D,R):Gs((function(e,t,n,r){var a=$r.runKernel(An,B,C);return r([e,t,a,n]),{value:Ti(a,T),gradFunc:F}}))(D,R,I)}})};var lc=la({hammingWindow_:function(e){return $l(e,.54,.46)}});var cc=la({hannWindow_:function(e){return $l(e,.5,.5)}});var hc=la({frame_:function(e,t,n,r,a){void 0===r&&(r=!1),void 0===a&&(a=0);for(var o=0,i=[];o+t<=e.size;)i.push(Ci(e,o,t)),o+=n;if(r)for(;o<e.size;){var s=o+t-e.size,u=Fi([Ci(e,o,t-s),Is([s],a)]);i.push(u),o+=n}return 0===i.length?Cl([],[0,t]):Ti(Fi(i),[i.length,t])}});var fc=la({stft_:function(e,t,n,r,a){void 0===a&&(a=cc),null==r&&(r=Xl(t));var o=hc(e,t,n),i=oi(o,a(t));return _l(i,r)}});var dc=la({cropAndResize_:function(e,t,n,r,a,o){void 0===a&&(a="bilinear"),void 0===o&&(o=0);var i=ia(e,"image","cropAndResize"),s=ia(t,"boxes","cropAndResize","float32"),u=ia(n,"boxInd","cropAndResize","int32"),l=s.shape[0];m(4===i.rank,(function(){return"Error in cropAndResize: image must be rank 4,but got rank "+i.rank+"."})),m(2===s.rank&&4===s.shape[1],(function(){return"Error in cropAndResize: boxes must be have size ["+l+",4] but had shape "+s.shape+"."})),m(1===u.rank&&u.shape[0]===l,(function(){return"Error in cropAndResize: boxInd must be have size ["+l+"] but had shape "+s.shape+"."})),m(2===r.length,(function(){return"Error in cropAndResize: cropSize must be of length 2, but got length "+r.length+"."})),m(r[0]>=1&&r[1]>=1,(function(){return"cropSize must be atleast [1,1], but was "+r})),m("bilinear"===a||"nearest"===a,(function(){return"method must be bilinear or nearest, but was "+a}));var c={image:i,boxes:s,boxInd:u},h={method:a,extrapolationValue:o,cropSize:r};return $r.runKernel(Re,c,h)}});var pc=la({flipLeftRight_:function(e){var t=ia(e,"image","flipLeftRight","float32");m(4===t.rank,(function(){return"Error in flipLeftRight: image must be rank 4,but got rank "+t.rank+"."}));var n={image:t};return $r.runKernel(Ve,n,{})}});var vc=la({grayscaleToRGB_:function(e){var t=ia(e,"image","grayscaleToRGB"),n=t.rank-1,r=t.shape[n];m(t.rank>=2,(function(){return"Error in grayscaleToRGB: images must be at least rank 2, but got rank "+t.rank+"."})),m(1===r,(function(){return"Error in grayscaleToRGB: last dimension of a grayscale image should be size 1, but got size "+r+"."}));var a=new Array(t.rank);return a.fill(1,0,n),a[n]=3,_s(t,a)}});var gc=la({rotateWithOffset_:function(e,t,n,r){void 0===n&&(n=0),void 0===r&&(r=.5);var a=ia(e,"image","rotateWithOffset","float32");m(4===a.rank,(function(){return"Error in rotateWithOffset: image must be rank 4,but got rank "+a.rank+"."}));var o={image:a},i={radians:t,fillValue:n,center:r};return $r.runKernel(Sn,o,i)}});function mc(e,t,n,r,a,o){null==r&&(r=.5),null==a&&(a=Number.NEGATIVE_INFINITY),null==o&&(o=0);var i=e.shape[0];return n=Math.min(n,i),m(0<=r&&r<=1,(function(){return"iouThreshold must be in [0, 1], but was '"+r+"'"})),m(2===e.rank,(function(){return"boxes must be a 2D tensor, but was of rank '"+e.rank+"'"})),m(4===e.shape[1],(function(){return"boxes must have 4 columns, but 2nd dimension was "+e.shape[1]})),m(1===t.rank,(function(){return"scores must be a 1D tensor"})),m(t.shape[0]===i,(function(){return"scores has incompatible shape with boxes. Expected "+i+", but was "+t.shape[0]})),m(0<=o&&o<=1,(function(){return"softNmsSigma must be in [0, 1], but was '"+o+"'"})),{maxOutputSize:n,iouThreshold:r,scoreThreshold:a,softNmsSigma:o}}var yc=la({nonMaxSuppression_:function(e,t,n,r,a){void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY);var o=ia(e,"boxes","nonMaxSuppression","float32"),i=ia(t,"scores","nonMaxSuppression","float32"),s=mc(o,i,n,r,a),u={maxOutputSize:n=s.maxOutputSize,iouThreshold:r=s.iouThreshold,scoreThreshold:a=s.scoreThreshold};return $r.runKernel(St,{boxes:o,scores:i},u)}});function bc(e,t,n){var r=function(e,t,n){return function(e,t,n){var r=0,a=e.length,o=0,i=!1;for(;r<a;){var s=n(t,e[o=r+(a-r>>>1)]);s>0?r=o+1:(a=o,i=!s)}return i?r:-r-1}(e,t,n||wc)}(e,t,n),a=r<0?-(r+1):r;e.splice(a,0,t)}function wc(e,t){return e>t?1:e<t?-1:0}function kc(e,t,n,r,a){return Sc(e,t,n,r,a,0)}function xc(e,t,n,r,a,o){return Sc(e,t,n,r,a,0,!1,o,!0)}function Ec(e,t,n,r,a,o){return Sc(e,t,n,r,a,o,!0)}function Sc(e,t,n,r,a,o,i,s,u){void 0===i&&(i=!1),void 0===s&&(s=!1),void 0===u&&(u=!1);for(var l=[],h=0;h<t.length;h++)t[h]>a&&l.push({score:t[h],boxIndex:h,suppressBeginIndex:0});l.sort(Nc);for(var f=o>0?-.5/o:0,d=[],p=[];d.length<n&&l.length>0;){var v=l.pop(),g=v.score,m=v.boxIndex,y=v.suppressBeginIndex;if(g<a)break;for(var b=!1,w=d.length-1;w>=y;--w){var k=Ac(e,m,d[w]);if(k>=r){b=!0;break}if(v.score=v.score*_c(r,f,k),v.score<=a)break}v.suppressBeginIndex=d.length,b||(v.score===g?(d.push(m),p.push(v.score)):v.score>a&&bc(l,v,Nc))}var x=d.length,E=n-x;s&&E>0&&(d.push.apply(d,c(new Array(E).fill(0))),p.push.apply(p,c(new Array(E).fill(0))));var S={selectedIndices:d};return i&&(S.selectedScores=p),u&&(S.validOutputs=x),S}function Ac(e,t,n){var r=e.subarray(4*t,4*t+4),a=e.subarray(4*n,4*n+4),o=Math.min(r[0],r[2]),i=Math.min(r[1],r[3]),s=Math.max(r[0],r[2]),u=Math.max(r[1],r[3]),l=Math.min(a[0],a[2]),c=Math.min(a[1],a[3]),h=Math.max(a[0],a[2]),f=Math.max(a[1],a[3]),d=(s-o)*(u-i),p=(h-l)*(f-c);if(d<=0||p<=0)return 0;var v=Math.max(o,l),g=Math.max(i,c),m=Math.min(s,h),y=Math.min(u,f),b=Math.max(m-v,0)*Math.max(y-g,0);return b/(d+p-b)}function _c(e,t,n){var r=Math.exp(t*n*n);return n<=e?r:0}function Nc(e,t){return e.score-t.score||e.score===t.score&&t.boxIndex-e.boxIndex}var Ic=function(e,t,n,r,a){return void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),i(this,void 0,void 0,(function(){var o,i,u,l,c,h,f;return s(this,(function(s){switch(s.label){case 0:return o=ia(e,"boxes","nonMaxSuppressionAsync"),i=ia(t,"scores","nonMaxSuppressionAsync"),u=mc(o,i,n,r,a),n=u.maxOutputSize,r=u.iouThreshold,a=u.scoreThreshold,[4,Promise.all([o.data(),i.data()])];case 1:return l=s.sent(),c=l[0],h=l[1],f=kc(c,h,n,r,a).selectedIndices,o!==e&&o.dispose(),i!==t&&i.dispose(),[2,Bl(f,"int32")]}}))}))};var Mc=la({nonMaxSuppressionWithScore_:function(e,t,n,r,a,o){void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),void 0===o&&(o=0);var i=ia(e,"boxes","nonMaxSuppression"),s=ia(t,"scores","nonMaxSuppression"),u=mc(i,s,n,r,a,o),l={boxes:i,scores:s},c={maxOutputSize:n=u.maxOutputSize,iouThreshold:r=u.iouThreshold,scoreThreshold:a=u.scoreThreshold,softNmsSigma:o=u.softNmsSigma},h=$r.runKernel(_t,l,c);return{selectedIndices:h[0],selectedScores:h[1]}}});var Tc=function(e,t,n,r,a,o){return void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),void 0===o&&(o=0),i(this,void 0,void 0,(function(){var i,u,l,c,h,f,d,p,v;return s(this,(function(s){switch(s.label){case 0:return i=ia(e,"boxes","nonMaxSuppressionAsync"),u=ia(t,"scores","nonMaxSuppressionAsync"),l=mc(i,u,n,r,a,o),n=l.maxOutputSize,r=l.iouThreshold,a=l.scoreThreshold,o=l.softNmsSigma,[4,Promise.all([i.data(),u.data()])];case 1:return c=s.sent(),h=c[0],f=c[1],d=Ec(h,f,n,r,a,o),p=d.selectedIndices,v=d.selectedScores,i!==e&&i.dispose(),u!==t&&u.dispose(),[2,{selectedIndices:Bl(p,"int32"),selectedScores:Bl(v)}]}}))}))};var Dc=la({nonMaxSuppressionPadded_:function(e,t,n,r,a,o){void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),void 0===o&&(o=!1);var i=ia(e,"boxes","nonMaxSuppression"),s=ia(t,"scores","nonMaxSuppression"),u=mc(i,s,n,r,a,null),l={boxes:i,scores:s},c={maxOutputSize:u.maxOutputSize,iouThreshold:u.iouThreshold,scoreThreshold:u.scoreThreshold,padToMaxOutputSize:o},h=$r.runKernel(At,l,c);return{selectedIndices:h[0],validOutputs:h[1]}}});var Rc=function(e,t,n,r,a,o){return void 0===r&&(r=.5),void 0===a&&(a=Number.NEGATIVE_INFINITY),void 0===o&&(o=!1),i(this,void 0,void 0,(function(){var i,u,c,h,f,d,p,v,g,m,y,b;return s(this,(function(s){switch(s.label){case 0:return i=ia(e,"boxes","nonMaxSuppressionAsync"),u=ia(t,"scores","nonMaxSuppressionAsync"),c=mc(i,u,n,r,a,null),h=c.maxOutputSize,f=c.iouThreshold,d=c.scoreThreshold,[4,Promise.all([i.data(),u.data()])];case 1:return p=l.apply(void 0,[s.sent(),2]),v=p[0],g=p[1],m=xc(v,g,h,f,d,o),y=m.selectedIndices,b=m.validOutputs,i!==e&&i.dispose(),u!==t&&u.dispose(),[2,{selectedIndices:Bl(y,"int32"),validOutputs:cl(b,"int32")}]}}))}))};var Fc=la({resizeBilinear_:function(e,t,n,r){void 0===n&&(n=!1),void 0===r&&(r=!1);var a=ia(e,"images","resizeBilinear");m(3===a.rank||4===a.rank,(function(){return"Error in resizeBilinear: x must be rank 3 or 4, but got rank "+a.rank+"."})),m(2===t.length,(function(){return"Error in resizeBilinear: new shape must 2D, but got shape "+t+"."})),m(!1===r||!1===n,(function(){return"Error in resizeBilinear: If halfPixelCenters is true, alignCorners must be false."}));var o=a,i=!1;3===a.rank&&(i=!0,o=Ti(a,[1,a.shape[0],a.shape[1],a.shape[2]])),l(t,0);var s={images:o},u={alignCorners:n,halfPixelCenters:r,size:t},c=$r.runKernel(zt,s,u);return i?Ti(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});var Bc=la({resizeNearestNeighbor_:function(e,t,n,r){void 0===n&&(n=!1),void 0===r&&(r=!1);var a=ia(e,"images","resizeNearestNeighbor");m(3===a.rank||4===a.rank,(function(){return"Error in resizeNearestNeighbor: x must be rank 3 or 4, but got rank "+a.rank+"."})),m(2===t.length,(function(){return"Error in resizeNearestNeighbor: new shape must 2D, but got shape "+t+"."})),m("float32"===a.dtype||"int32"===a.dtype,(function(){return"`images` must have `int32` or `float32` as dtype"})),m(!1===r||!1===n,(function(){return"Error in resizeNearestNeighbor: If halfPixelCenters is true, alignCorners must be false."}));var o=a,i=!1;3===a.rank&&(i=!0,o=Ti(a,[1,a.shape[0],a.shape[1],a.shape[2]])),l(t,0);var s={images:o},u={alignCorners:n,halfPixelCenters:r,size:t},c=$r.runKernel(Lt,s,u);return i?Ti(c,[c.shape[1],c.shape[2],c.shape[3]]):c}});var Cc=la({threshold_:function(e,t,n,r){var a;void 0===t&&(t="binary"),void 0===n&&(n=!1),void 0===r&&(r=.5);var o,i,s,u,c=ia(e,"image","threshold"),h=c.shape[0]*c.shape[1],f=oi(Bl([r]),255);if(m(3===c.rank,(function(){return"Error in threshold: image must be rank 3,but got rank "+c.rank+"."})),m(3===c.shape[2]||1===c.shape[2],(function(){return"Error in threshold: image color channel must be equal to 3 or 1but got "+c.shape[2]+"."})),m("int32"===c.dtype||"float32"===c.dtype,(function(){return"Error in dtype: image dtype must be int32 or float32,but got dtype "+c.dtype+"."})),m("otsu"===t||"binary"===t,(function(){return"Method must be binary or otsu, but was "+t})),3===c.shape[2]){o=(a=l(Al(c,[1,1,1],-1),3))[0],i=a[1],s=a[2];var d=oi(o,.2989),p=oi(i,.587),v=oi(s,.114);u=ni(ni(d,p),v)}else u=e;"otsu"===t&&(f=function(e,t){for(var n,r,a,o,i,s,u=Bl([-1]),l=Bl([0]),c=Bl([0]),h=0;h<e.size-1;h++){n=Ci(e,0,h+1),r=Ci(e,h+1),i=ai(Xs(n),t),s=ai(Xs(r),t);var f=Xs(oi(n,$u(0,n.size)));a=ai(f,Xs(n));var d=Is(r.shape,n.size),p=ni($u(0,r.size),d),v=oi(r,p);o=ai(Xs(v),Xs(r));var g=Ys(a,o),m=Ys(a,o),y=oi(i,s);c=oi(oi(y,g),m);var b=Ds(c,l);l=gs(b,c,l),u=gs(b,Bl([h]),u)}return u}(Ui(to(ul(u),"int32"),fa([]),256),h));var g=n?zs(u,f):Ds(u,f);return to(oi(g,255),"int32")}});var Pc=la({transform_:function(e,t,n,r,a,o){void 0===n&&(n="nearest"),void 0===r&&(r="constant"),void 0===a&&(a=0);var i=ia(e,"image","transform","float32"),s=ia(t,"transforms","transform","float32");m(4===i.rank,(function(){return"Error in transform: image must be rank 4,but got rank "+i.rank+"."})),m(2===s.rank&&(s.shape[0]===i.shape[0]||1===s.shape[0])&&8===s.shape[1],(function(){return"Error in transform: Input transform should be batch x 8 or 1 x 8"})),m(null==o||2===o.length,(function(){return"Error in transform: outputShape must be [height, width] or null, but got "+o+"."}));var u={image:i,transforms:s},l={interpolation:n,fillMode:r,fillValue:a,outputShape:o};return $r.runKernel(gn,u,l)}});var Oc=la({bandPart_:function(e,t,n){m(t%1==0,(function(){return"bandPart(): numLower must be an integer, got "+t+"."})),m(n%1==0,(function(){return"bandPart(): numUpper must be an integer, got "+n+"."}));var r=ia(e,"a","bandPart");m(r.rank>=2,(function(){return"bandPart(): Rank must be at least 2, got "+r.rank+"."}));var a=r.shape,o=l(r.shape.slice(-2),2),i=o[0],s=o[1];if(!(t<=i))throw new Error("bandPart(): numLower ("+t+") must not be greater than the number of rows ("+i+").");if(!(n<=s))throw new Error("bandPart(): numUpper ("+n+") must not be greater than the number of columns ("+s+").");t<0&&(t=i),n<0&&(n=s);var u=Ti($u(0,i,1,"int32"),[-1,1]),c=$u(0,s,1,"int32"),h=Ys(u,c),f=ru(zs(h,cl(+t,"int32")),Rs(h,cl(-n,"int32"))),d=fu([i,s],r.dtype);return Ti(Tl(Kl(Ti(r,[-1,i,s])).map((function(e){return gs(f,e,d)}))),a)}});var Lc=la({gramSchmidt_:function(e){var t;if(Array.isArray(e)){t=!1,m(null!=e&&e.length>0,(function(){return"Gram-Schmidt process: input must not be null, undefined, or empty"}));for(var n=e[0].shape[0],r=function(t){m(e[t].shape[0]===n,(function(){return"Gram-Schmidt: Non-unique lengths found in the input vectors: ("+e[t].shape[0]+" vs. "+n+")"}))},a=1;a<e.length;++a)r(a)}else t=!0,e=Al(e,e.shape[0],0).map((function(e){return Ml(e,[0])}));m(e.length<=e[0].shape[0],(function(){return"Gram-Schmidt: Number of vectors ("+e.length+") exceeds number of dimensions ("+e[0].shape[0]+")."}));var o=[],i=e,s=function(e){o.push($r.tidy((function(){var t=i[e];if(e>0)for(var n=0;n<e;++n){var r=oi(Xs(oi(o[n],t)),o[n]);t=Ys(t,r)}return ai(t,Hl(t,"euclidean"))})))};for(a=0;a<e.length;++a)s(a);return t?Tl(o,0):o}});function zc(e,t){return void 0===t&&(t=!1),$r.tidy((function(){m(2===e.shape.length,(function(){return"qr2d() requires a 2D Tensor, but got a "+e.shape.length+"D Tensor."}));for(var n=e.shape[0],r=e.shape[1],a=Ns(n),o=no(e),i=Cl([[1]],[1,1]),s=no(i),u=n>=r?r:n,c=function(e){var t,u=o,c=s,h=a;t=l($r.tidy((function(){var t=Ci(o,[e,e],[n-e,1]),u=Hl(t),l=Ci(o,[e,e],[1,1]),c=gs(Ds(l,0),Cl([[-1]]),Cl([[1]])),h=Ys(l,oi(c,u)),f=ai(t,h);s=1===f.shape[0]?no(i):Fi([i,Ci(f,[1,0],[f.shape[0]-1,f.shape[1]])],0);var d=Vs(ai(yo(c,h),u)),p=Ci(o,[e,0],[n-e,r]),v=oi(d,s),g=wo(s);if(0===e)o=Ys(p,yo(v,yo(g,p)));else{var m=Ys(p,yo(v,yo(g,p)));o=Fi([Ci(o,[0,0],[e,r]),m],0)}var y=wo(v),b=Ci(a,[0,e],[n,a.shape[1]-e]);if(0===e)a=Ys(b,yo(yo(b,s),y));else{var w=Ys(b,yo(yo(b,s),y));a=Fi([Ci(a,[0,0],[n,e]),w],1)}return[s,o,a]})),3),s=t[0],o=t[1],a=t[2],ei([u,c,h])},h=0;h<u;++h)c(h);return!t&&n>r&&(a=Ci(a,[0,0],[n,r]),o=Ci(o,[0,0],[r,r])),[a,o]}))}var Kc,qc=la({qr_:function(e,t){if(void 0===t&&(t=!1),m(e.rank>=2,(function(){return"qr() requires input tensor to have a rank >= 2, but got rank "+e.rank})),2===e.rank)return zc(e,t);var n=e.shape.slice(0,e.shape.length-2).reduce((function(e,t){return e*t})),r=Kl(Ti(e,[n,e.shape[e.shape.length-2],e.shape[e.shape.length-1]]),0),a=[],o=[];return r.forEach((function(e){var n=l(zc(e,t),2),r=n[0],i=n[1];a.push(r),o.push(i)})),[Ti(Tl(a,0),e.shape),Ti(Tl(o,0),e.shape)]}});e.Reduction=void 0,(Kc=e.Reduction||(e.Reduction={}))[Kc.NONE=0]="NONE",Kc[Kc.MEAN=1]="MEAN",Kc[Kc.SUM=2]="SUM",Kc[Kc.SUM_BY_NONZERO_WEIGHTS=3]="SUM_BY_NONZERO_WEIGHTS";var Wc=la({computeWeightedLoss_:function(t,n,r){void 0===r&&(r=e.Reduction.SUM_BY_NONZERO_WEIGHTS);var a=ia(t,"losses","computeWeightedLoss"),o=null;null!=n&&(o=ia(n,"weights","computeWeightedLoss"));var i=null==o?a:oi(a,o);if(r===e.Reduction.NONE)return i;if(r===e.Reduction.SUM)return Xs(i);if(r===e.Reduction.MEAN){if(null==o)return hu(i);var s=a.size/o.size,u=ai(Xs(i),Xs(o));return s>1?ai(u,cl(s)):u}if(r===e.Reduction.SUM_BY_NONZERO_WEIGHTS){if(null==o)return ai(Xs(i),cl(a.size));var l=oi(o,du(a.shape)),c=to(Xs(xu(l,cl(0))),"float32");return ai(Xs(i),c)}throw Error("Unknown reduction: "+r)}});var Uc=la({absoluteDifference_:function(t,n,r,a){void 0===a&&(a=e.Reduction.SUM_BY_NONZERO_WEIGHTS);var o=ia(t,"labels","absoluteDifference"),i=ia(n,"predictions","absoluteDifference"),s=null;null!=r&&(s=ia(r,"weights","absoluteDifference")),y(o.shape,i.shape,"Error in absoluteDifference: ");var u=ii(Ys(o,i));return Wc(u,s,a)}});var Gc=la({cosineDistance_:function(t,n,r,a,o){void 0===o&&(o=e.Reduction.SUM_BY_NONZERO_WEIGHTS);var i=ia(t,"labels","cosineDistance"),s=ia(n,"predictions","cosineDistance"),u=null;null!=a&&(u=ia(a,"weights","cosineDistance")),y(i.shape,s.shape,"Error in cosineDistance: ");var l=cl(1),c=Ys(l,Xs(oi(i,s),r,!0));return Wc(c,u,o)}});var Hc=la({hingeLoss_:function(t,n,r,a){void 0===a&&(a=e.Reduction.SUM_BY_NONZERO_WEIGHTS);var o=ia(t,"labels","hingeLoss"),i=ia(n,"predictions","hingeLoss"),s=null;null!=r&&(s=ia(r,"weights","hingeLoss")),y(o.shape,i.shape,"Error in hingeLoss: ");var u=cl(1);o=Ys(oi(cl(2),o),u);var l=tl(Ys(u,oi(o,i)));return Wc(l,s,a)}});var Vc=la({huberLoss_:function(t,n,r,a,o){void 0===a&&(a=1),void 0===o&&(o=e.Reduction.SUM_BY_NONZERO_WEIGHTS);var i=ia(t,"labels","huberLoss"),s=ia(n,"predictions","huberLoss"),u=null;null!=r&&(u=ia(r,"weights","huberLoss")),y(i.shape,s.shape,"Error in huberLoss: ");var l=cl(a),c=ii(Ys(s,i)),h=vu(c,l),f=Ys(c,h),d=ni(oi(cl(.5),yu(h)),oi(l,f));return Wc(d,u,o)}});var jc=la({logLoss_:function(t,n,r,a,o){void 0===a&&(a=1e-7),void 0===o&&(o=e.Reduction.SUM_BY_NONZERO_WEIGHTS);var i=ia(t,"labels","logLoss"),s=ia(n,"predictions","logLoss"),u=null;null!=r&&(u=ia(r,"weights","logLoss")),y(i.shape,s.shape,"Error in logLoss: ");var l=cl(1),c=cl(a),h=Vs(oi(i,qs(ni(s,c)))),f=oi(Ys(l,i),qs(ni(Ys(l,s),c))),d=Ys(h,f);return Wc(d,u,o)}});var Jc=la({meanSquaredError_:function(t,n,r,a){void 0===a&&(a=e.Reduction.SUM_BY_NONZERO_WEIGHTS);var o=ia(t,"labels","meanSquaredError"),i=ia(n,"predictions","meanSquaredError"),s=null;null!=r&&(s=ia(r,"weights","meanSquaredError")),y(o.shape,i.shape,"Error in meanSquaredError: ");var u=Il(o,i);return Wc(u,s,a)}});var Zc=la({sigmoidCrossEntropy_:function(t,n,r,a,o){void 0===a&&(a=0),void 0===o&&(o=e.Reduction.SUM_BY_NONZERO_WEIGHTS);var i=ia(t,"multiClassLabels","sigmoidCrossEntropy"),s=ia(n,"logits","sigmoidCrossEntropy"),u=null;if(null!=r&&(u=ia(r,"weights","sigmoidCrossEntropy")),y(i.shape,s.shape,"Error in sigmoidCrossEntropy: "),a>0){var l=cl(a),c=cl(1),h=cl(.5);i=ni(oi(i,Ys(c,l)),oi(h,l))}var f=function(e,t){var n=ia(e,"labels","sigmoidCrossEntropyWithLogits"),r=ia(t,"logits","sigmoidCrossEntropyWithLogits");y(n.shape,r.shape,"Error in sigmoidCrossEntropyWithLogits: ");var a=tl(r),o=oi(r,n),i=Ws(Es(Vs(ii(r))));return ni(Ys(a,o),i)}(i,s);return Wc(f,u,o)}});var Yc=la({softmaxCrossEntropy_:function(t,n,r,a,o){void 0===a&&(a=0),void 0===o&&(o=e.Reduction.SUM_BY_NONZERO_WEIGHTS);var i=ia(t,"onehotLabels","softmaxCrossEntropy"),s=ia(n,"logits","softmaxCrossEntropy"),u=null;if(null!=r&&(u=ia(r,"weights","softmaxCrossEntropy")),y(i.shape,s.shape,"Error in softmaxCrossEntropy: "),a>0){var c=cl(a),h=cl(1),f=cl(i.shape[1]);i=ni(oi(i,Ys(h,c)),ai(c,f))}var d=function(e,t,n){if(void 0===n&&(n=-1),-1===n&&(n=t.rank-1),n!==t.rank-1)throw Error("Softmax cross entropy along a non-last dimension is not yet supported. Labels / logits was rank "+t.rank+" and dim was "+n);return Gs((function(e,t,r){var a=nu(t,[n],!0),o=Ys(to(t,"float32"),a);r([e,o]);var i=Vs(oi(o,e));return{value:Xs(i,[n]),gradFunc:function(e,t){var r=l(t,2),a=r[0],o=r[1],i=tu(e.shape,[n]);return[oi(Ti(e,i),Ys(to(a,"float32"),Es(o))),oi(Ti(e,i),Ys(Es(o),to(a,"float32")))]}}}))(e,t)}(i,s);return Wc(d,u,o)}});var Xc=la({sparseFillEmptyRows_:function(e,t,n,r){var a=ia(e,"indices","sparseFillEmptyRows"),o=ia(t,"values","sparseFillEmptyRows"),i=ia(n,"denseShape","sparseFillEmptyRows"),s=ia(r,"defaultValue","sparseFillEmptyRows",o.dtype);if(2!==a.rank)throw new Error("Indices should be Tensor2D but received shape\n        "+a.shape);if(1!==o.rank)throw new Error("Values should be Tensor1D but received shape "+o.shape);if(1!==i.rank)throw new Error("Dense shape should be Tensor1D but received shape "+i.shape);if(0!==s.rank)throw new Error("Default value should be a scalar but received shape "+s.shape);var u={indices:a,values:o,denseShape:i,defaultValue:s},l=$r.runKernel(nn,u);return{outputIndices:l[0],outputValues:l[1],emptyRowIndicator:l[2],reverseIndexMap:l[3]}}});var $c=la({sparseReshape_:function(e,t,n){var r=ia(e,"inputIndices","sparseReshape"),a=ia(t,"inputShape","sparseReshape"),o=ia(n,"newShape","sparseReshape");if(2!==r.rank)throw new Error("Input indices should be Tensor2D but received shape\n        "+r.shape);if(1!==a.rank)throw new Error("Input shape should be Tensor1D but received shape "+a.shape);if(1!==o.rank)throw new Error("New shape should be Tensor1D but received shape "+o.shape);var i={inputIndices:r,inputShape:a,newShape:o},s=$r.runKernel(rn,i);return{outputIndices:s[0],outputShape:s[1]}}});var Qc=la({sparseSegmentMean_:function(e,t,n){var r=ia(e,"data","sparseSegmentMean"),a=ia(t,"indices","sparseSegmentMean"),o=ia(n,"segmentIds","sparseSegmentMean");if(r.rank<1)throw new Error("Data should be at least 1 dimensional but received scalar");if(1!==a.rank)throw new Error("Indices should be Tensor1D but received shape\n          "+a.shape);if(1!==o.rank)throw new Error("Segment ids should be Tensor1D but received shape\n          "+o.shape);var i={data:r,indices:a,segmentIds:o};return $r.runKernel(an,i)}});var eh=la({sparseSegmentSum_:function(e,t,n){var r=ia(e,"data","sparseSegmentSum"),a=ia(t,"indices","sparseSegmentSum"),o=ia(n,"segmentIds","sparseSegmentSum");if(r.rank<1)throw new Error("Data should be at least 1 dimensional but received scalar");if(1!==a.rank)throw new Error("Indices should be Tensor1D but received shape\n         "+a.shape);if(1!==o.rank)throw new Error("Segment ids should be Tensor1D but received shape\n         "+o.shape);var i={data:r,indices:a,segmentIds:o};return $r.runKernel(on,i)}});var th=la({stringNGrams_:function(e,t,n,r,a,o,i,s){var u=ia(e,"data","stringNGrams","string");if("string"!==u.dtype)throw new Error("Data must be of datatype string");if(1!==u.shape.length)throw new Error("Data must be a vector, saw: "+u.shape);var l=ia(t,"dataSplits","stringNGrams");if("int32"!==l.dtype)throw new Error("Data splits must be of datatype int32");var c={separator:n,nGramWidths:r,leftPad:a,rightPad:o,padWidth:i,preserveShortSequences:s},h={data:u,dataSplits:l},f=$r.runKernel(cn,h,c);return{nGrams:f[0],nGramsSplits:f[1]}}});var nh=la({stringSplit_:function(e,t,n){void 0===n&&(n=!0);var r=ia(e,"input","stringSplit","string"),a=ia(t,"delimiter","stringSplit","string");if(1!==r.rank)throw new Error("Input should be Tensor1D but received shape "+r.shape);if(0!==a.rank)throw new Error("Delimiter should be a scalar but received shape "+a.shape);var o={skipEmpty:n},i={input:r,delimiter:a},s=$r.runKernel(hn,i,o);return{indices:s[0],values:s[1],shape:s[2]}}});var rh=la({stringToHashBucketFast_:function(e,t){var n=ia(e,"input","stringToHashBucketFast","string"),r={numBuckets:t};if(t<=0)throw new Error("Number of buckets must be at least 1");var a={input:n};return $r.runKernel(fn,a,r)}}),ah={fft:xl,ifft:El,rfft:_l,irfft:Sl},oh={hammingWindow:lc,hannWindow:cc,frame:hc,stft:fc},ih={flipLeftRight:pc,grayscaleToRGB:vc,resizeNearestNeighbor:Bc,resizeBilinear:Fc,rotateWithOffset:gc,cropAndResize:dc,nonMaxSuppression:yc,nonMaxSuppressionAsync:Ic,nonMaxSuppressionWithScore:Mc,nonMaxSuppressionWithScoreAsync:Tc,nonMaxSuppressionPadded:Dc,nonMaxSuppressionPaddedAsync:Rc,threshold:Cc,transform:Pc},sh={bandPart:Oc,gramSchmidt:Lc,qr:qc},uh={absoluteDifference:Uc,computeWeightedLoss:Wc,cosineDistance:Gc,hingeLoss:Hc,huberLoss:Vc,logLoss:jc,meanSquaredError:Jc,sigmoidCrossEntropy:Zc,softmaxCrossEntropy:Yc},lh={sparseFillEmptyRows:Xc,sparseReshape:$c,sparseSegmentMean:Qc,sparseSegmentSum:eh},ch={stringNGrams:th,stringSplit:nh,stringToHashBucketFast:rh},hh=function(e){function t(){return null!==e&&e.apply(this,arguments)||this}return o(t,e),t.prototype.minimize=function(e,t,n){void 0===t&&(t=!1);var r=this.computeGradients(e,n),a=r.value,o=r.grads;if(null!=n){var i=n.map((function(e){return{name:e.name,tensor:o[e.name]}}));this.applyGradients(i)}else this.applyGradients(o);return ei(o),t?a:(a.dispose(),null)},Object.defineProperty(t.prototype,"iterations",{get:function(){return null==this.iterations_&&(this.iterations_=0),this.iterations_},enumerable:!0,configurable:!0}),t.prototype.incrementIterations=function(){this.iterations_=this.iterations+1},t.prototype.computeGradients=function(e,t){return Us(e,t)},t.prototype.dispose=function(){null!=this.iterations_&&ei(this.iterations_)},t.prototype.saveIterations=function(){return i(this,void 0,void 0,(function(){return s(this,(function(e){return null==this.iterations_&&(this.iterations_=0),[2,{name:"iter",tensor:cl(this.iterations_,"int32")}]}))}))},t.prototype.getWeights=function(){return i(this,void 0,void 0,(function(){return s(this,(function(e){throw new Error("getWeights() is not implemented for this optimizer yet.")}))}))},t.prototype.setWeights=function(e){return i(this,void 0,void 0,(function(){return s(this,(function(e){throw new Error("setWeights() is not implemented for this optimizer class "+this.getClassName())}))}))},t.prototype.extractIterations=function(e){return i(this,void 0,void 0,(function(){var t;return s(this,(function(n){switch(n.label){case 0:return t=this,[4,e[0].tensor.data()];case 1:return t.iterations_=n.sent()[0],[2,e.slice(1)]}}))}))},t}(Ho);Object.defineProperty(hh,Symbol.hasInstance,{value:function(e){return null!=e.minimize&&null!=e.computeGradients&&null!=e.applyGradients}});var fh=function(e){function t(t,n,r){void 0===r&&(r=null);var a=e.call(this)||this;return a.learningRate=t,a.rho=n,a.epsilon=r,a.accumulatedGrads=[],a.accumulatedUpdates=[],null==r&&(a.epsilon=$r.backend.epsilon()),a}return o(t,e),t.prototype.applyGradients=function(e){var t=this;(Array.isArray(e)?e.map((function(e){return e.name})):Object.keys(e)).forEach((function(n,r){var a=$r.registeredVariables[n];null==t.accumulatedGrads[r]&&(t.accumulatedGrads[r]={originalName:n+"/accum_grad",variable:Qo((function(){return ms(a).variable(false)}))}),null==t.accumulatedUpdates[r]&&(t.accumulatedUpdates[r]={originalName:n+"/accum_var",variable:Qo((function(){return ms(a).variable(false)}))});var o=Array.isArray(e)?e[r].tensor:e[n];if(null!=o){var i=t.accumulatedGrads[r].variable,s=t.accumulatedUpdates[r].variable;Qo((function(){var e=ni(oi(i,t.rho),oi(yu(o),1-t.rho)),n=oi(ai(Nl(ni(s,t.epsilon)),Nl(ni(i,t.epsilon))),o),r=ni(oi(s,t.rho),oi(yu(n),1-t.rho));i.assign(e),s.assign(r);var u=ni(oi(n,-t.learningRate),a);a.assign(u)}))}})),this.incrementIterations()},t.prototype.dispose=function(){null!=this.accumulatedUpdates&&(ei(this.accumulatedGrads.map((function(e){return e.variable}))),ei(this.accumulatedUpdates.map((function(e){return e.variable}))))},t.prototype.getWeights=function(){return i(this,void 0,void 0,(function(){var e;return s(this,(function(t){switch(t.label){case 0:return e=c(this.accumulatedGrads,this.accumulatedUpdates),[4,this.saveIterations()];case 1:return[2,[t.sent()].concat(e.map((function(e){return{name:e.originalName,tensor:e.variable}})))]}}))}))},t.prototype.setWeights=function(e){return i(this,void 0,void 0,(function(){var t;return s(this,(function(n){switch(n.label){case 0:return[4,this.extractIterations(e)];case 1:return e=n.sent(),t=e.length/2,!1,this.accumulatedGrads=e.slice(0,t).map((function(e){return{originalName:e.name,variable:e.tensor.variable(false)}})),this.accumulatedUpdates=e.slice(t,2*t).map((function(e){return{originalName:e.name,variable:e.tensor.variable(false)}})),[2]}}))}))},t.prototype.getConfig=function(){return{learningRate:this.learningRate,rho:this.rho,epsilon:this.epsilon}},t.fromConfig=function(e,t){return new e(t.learningRate,t.rho,t.epsilon)},t}(hh);fh.className="Adadelta",jo(fh);var dh=function(e){function t(t,n){void 0===n&&(n=.1);var r=e.call(this)||this;return r.learningRate=t,r.initialAccumulatorValue=n,r.accumulatedGrads=[],r}return o(t,e),t.prototype.applyGradients=function(e){var t=this;(Array.isArray(e)?e.map((function(e){return e.name})):Object.keys(e)).forEach((function(n,r){var a=$r.registeredVariables[n];if(null==t.accumulatedGrads[r]){t.accumulatedGrads[r]={originalName:n+"/accumulator",variable:Qo((function(){return Is(a.shape,t.initialAccumulatorValue).variable(false)}))}}var o=Array.isArray(e)?e[r].tensor:e[n];if(null!=o){var i=t.accumulatedGrads[r].variable;Qo((function(){var e=ni(i,yu(o));i.assign(e);var n=ni(oi(ai(o,Nl(ni(e,$r.backend.epsilon()))),-t.learningRate),a);a.assign(n)}))}})),this.incrementIterations()},t.prototype.dispose=function(){null!=this.accumulatedGrads&&ei(this.accumulatedGrads.map((function(e){return e.variable})))},t.prototype.getWeights=function(){return i(this,void 0,void 0,(function(){return s(this,(function(e){switch(e.label){case 0:return[4,this.saveIterations()];case 1:return[2,[e.sent()].concat(this.accumulatedGrads.map((function(e){return{name:e.originalName,tensor:e.variable}})))]}}))}))},t.prototype.setWeights=function(e){return i(this,void 0,void 0,(function(){return s(this,(function(t){switch(t.label){case 0:return[4,this.extractIterations(e)];case 1:return e=t.sent(),!1,this.accumulatedGrads=e.map((function(e){return{originalName:e.name,variable:e.tensor.variable(false)}})),[2]}}))}))},t.prototype.getConfig=function(){return{learningRate:this.learningRate,initialAccumulatorValue:this.initialAccumulatorValue}},t.fromConfig=function(e,t){return new e(t.learningRate,t.initialAccumulatorValue)},t}(hh);dh.className="Adagrad",jo(dh);var ph=function(e){function t(t,n,r,a){void 0===a&&(a=null);var o=e.call(this)||this;return o.learningRate=t,o.beta1=n,o.beta2=r,o.epsilon=a,o.accumulatedFirstMoment=[],o.accumulatedSecondMoment=[],Qo((function(){o.accBeta1=cl(n).variable(),o.accBeta2=cl(r).variable()})),null==a&&(o.epsilon=$r.backend.epsilon()),o}return o(t,e),t.prototype.applyGradients=function(e){var t=this,n=Array.isArray(e)?e.map((function(e){return e.name})):Object.keys(e);Qo((function(){var r=Ys(1,t.accBeta1),a=Ys(1,t.accBeta2);n.forEach((function(n,o){var i=$r.registeredVariables[n];null==t.accumulatedFirstMoment[o]&&(t.accumulatedFirstMoment[o]={originalName:n+"/m",variable:Qo((function(){return ms(i).variable(false)}))}),null==t.accumulatedSecondMoment[o]&&(t.accumulatedSecondMoment[o]={originalName:n+"/v",variable:Qo((function(){return ms(i).variable(false)}))});var s=Array.isArray(e)?e[o].tensor:e[n];if(null!=s){var u=t.accumulatedFirstMoment[o].variable,l=t.accumulatedSecondMoment[o].variable,c=ni(oi(u,t.beta1),oi(s,1-t.beta1)),h=ni(oi(l,t.beta2),oi(yu(s),1-t.beta2)),f=ai(c,r),d=ai(h,a);u.assign(c),l.assign(h);var p=ni(oi(ai(f,ni(Nl(d),t.epsilon)),-t.learningRate),i);i.assign(p)}})),t.accBeta1.assign(oi(t.accBeta1,t.beta1)),t.accBeta2.assign(oi(t.accBeta2,t.beta2))})),this.incrementIterations()},t.prototype.dispose=function(){this.accBeta1.dispose(),this.accBeta2.dispose(),null!=this.accumulatedFirstMoment&&ei(this.accumulatedFirstMoment.map((function(e){return e.variable}))),null!=this.accumulatedSecondMoment&&ei(this.accumulatedSecondMoment.map((function(e){return e.variable})))},t.prototype.getWeights=function(){return i(this,void 0,void 0,(function(){var e;return s(this,(function(t){switch(t.label){case 0:return e=c(this.accumulatedFirstMoment,this.accumulatedSecondMoment),[4,this.saveIterations()];case 1:return[2,[t.sent()].concat(e.map((function(e){return{name:e.originalName,tensor:e.variable}})))]}}))}))},t.prototype.setWeights=function(e){return i(this,void 0,void 0,(function(){var t,n=this;return s(this,(function(r){switch(r.label){case 0:return[4,this.extractIterations(e)];case 1:return e=r.sent(),Qo((function(){n.accBeta1.assign(Ru(n.beta1,n.iterations_+1)),n.accBeta2.assign(Ru(n.beta2,n.iterations_+1))})),t=e.length/2,!1,this.accumulatedFirstMoment=e.slice(0,t).map((function(e){return{originalName:e.name,variable:e.tensor.variable(false)}})),this.accumulatedSecondMoment=e.slice(t,2*t).map((function(e){return{originalName:e.name,variable:e.tensor.variable(false)}})),[2]}}))}))},t.prototype.getConfig=function(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon}},t.fromConfig=function(e,t){return new e(t.learningRate,t.beta1,t.beta2,t.epsilon)},t}(hh);ph.className="Adam",jo(ph);var vh=function(e){function t(t,n,r,a,o){void 0===a&&(a=null),void 0===o&&(o=0);var i=e.call(this)||this;return i.learningRate=t,i.beta1=n,i.beta2=r,i.epsilon=a,i.decay=o,i.accumulatedFirstMoment=[],i.accumulatedWeightedInfNorm=[],Qo((function(){i.iteration=cl(0).variable(),i.accBeta1=cl(n).variable()})),null==a&&(i.epsilon=$r.backend.epsilon()),i}return o(t,e),t.prototype.applyGradients=function(e){var t=this,n=Array.isArray(e)?e.map((function(e){return e.name})):Object.keys(e);Qo((function(){var r=Ys(1,t.accBeta1),a=ai(-t.learningRate,ni(oi(t.iteration,t.decay),1));n.forEach((function(n,o){var i=$r.registeredVariables[n];null==t.accumulatedFirstMoment[o]&&(t.accumulatedFirstMoment[o]={originalName:n+"/m",variable:ms(i).variable(false)}),null==t.accumulatedWeightedInfNorm[o]&&(t.accumulatedWeightedInfNorm[o]={originalName:n+"/v",variable:ms(i).variable(false)});var s=Array.isArray(e)?e[o].tensor:e[n];if(null!=s){var u=t.accumulatedFirstMoment[o].variable,l=t.accumulatedWeightedInfNorm[o].variable,c=ni(oi(u,t.beta1),oi(s,1-t.beta1)),h=oi(l,t.beta2),f=ii(s),d=cu(h,f);u.assign(c),l.assign(d);var p=ni(oi(ai(a,r),ai(c,ni(d,t.epsilon))),i);i.assign(p)}})),t.iteration.assign(ni(t.iteration,1)),t.accBeta1.assign(oi(t.accBeta1,t.beta1))})),this.incrementIterations()},t.prototype.dispose=function(){this.accBeta1.dispose(),this.iteration.dispose(),null!=this.accumulatedFirstMoment&&ei(this.accumulatedFirstMoment.map((function(e){return e.variable}))),null!=this.accumulatedWeightedInfNorm&&ei(this.accumulatedWeightedInfNorm.map((function(e){return e.variable})))},t.prototype.getWeights=function(){return i(this,void 0,void 0,(function(){return s(this,(function(e){throw new Error("getWeights() is not implemented for Adamax yet.")}))}))},t.prototype.setWeights=function(e){return i(this,void 0,void 0,(function(){return s(this,(function(e){throw new Error("setWeights() is not implemented for Adamax yet.")}))}))},t.prototype.getConfig=function(){return{learningRate:this.learningRate,beta1:this.beta1,beta2:this.beta2,epsilon:this.epsilon,decay:this.decay}},t.fromConfig=function(e,t){return new e(t.learningRate,t.beta1,t.beta2,t.epsilon,t.decay)},t}(hh);vh.className="Adamax",jo(vh);var gh=function(e){function t(t){var n=e.call(this)||this;return n.learningRate=t,n.setLearningRate(t),n}return o(t,e),t.prototype.applyGradients=function(e){var t=this;(Array.isArray(e)?e.map((function(e){return e.name})):Object.keys(e)).forEach((function(n,r){var a=Array.isArray(e)?e[r].tensor:e[n];if(null!=a){var o=$r.registeredVariables[n];Qo((function(){var e=ni(oi(t.c,a),o);o.assign(e)}))}})),this.incrementIterations()},t.prototype.setLearningRate=function(e){this.learningRate=e,null!=this.c&&this.c.dispose(),this.c=ti(cl(-e))},t.prototype.dispose=function(){this.c.dispose()},t.prototype.getWeights=function(){return i(this,void 0,void 0,(function(){return s(this,(function(e){switch(e.label){case 0:return[4,this.saveIterations()];case 1:return[2,[e.sent()]]}}))}))},t.prototype.setWeights=function(e){return i(this,void 0,void 0,(function(){return s(this,(function(t){switch(t.label){case 0:return[4,this.extractIterations(e)];case 1:if(0!==(e=t.sent()).length)throw new Error("SGD optimizer does not have settable weights.");return[2]}}))}))},t.prototype.getConfig=function(){return{learningRate:this.learningRate}},t.fromConfig=function(e,t){return new e(t.learningRate)},t}(hh);gh.className="SGD",jo(gh);var mh=function(e){function t(t,n,r){void 0===r&&(r=!1);var a=e.call(this,t)||this;return a.learningRate=t,a.momentum=n,a.useNesterov=r,a.accumulations=[],a.m=cl(a.momentum),a}return o(t,e),t.prototype.applyGradients=function(e){var t=this;(Array.isArray(e)?e.map((function(e){return e.name})):Object.keys(e)).forEach((function(n,r){var a=$r.registeredVariables[n];if(null==t.accumulations[r]){t.accumulations[r]={originalName:n+"/momentum",variable:Qo((function(){return ms(a).variable(false)}))}}var o=t.accumulations[r].variable,i=Array.isArray(e)?e[r].tensor:e[n];null!=i&&Qo((function(){var e,n=ni(oi(t.m,o),i);e=t.useNesterov?ni(oi(t.c,ni(i,oi(n,t.m))),a):ni(oi(t.c,n),a),o.assign(n),a.assign(e)}))})),this.incrementIterations()},t.prototype.dispose=function(){this.m.dispose(),null!=this.accumulations&&ei(this.accumulations.map((function(e){return e.variable})))},t.prototype.setMomentum=function(e){this.momentum=e},t.prototype.getWeights=function(){return i(this,void 0,void 0,(function(){return s(this,(function(e){switch(e.label){case 0:return[4,this.saveIterations()];case 1:return[2,[e.sent()].concat(this.accumulations.map((function(e){return{name:e.originalName,tensor:e.variable}})))]}}))}))},t.prototype.setWeights=function(e){return i(this,void 0,void 0,(function(){return s(this,(function(t){switch(t.label){case 0:return[4,this.extractIterations(e)];case 1:return e=t.sent(),!1,this.accumulations=e.map((function(e){return{originalName:e.name,variable:e.tensor.variable(false)}})),[2]}}))}))},t.prototype.getConfig=function(){return{learningRate:this.learningRate,momentum:this.momentum,useNesterov:this.useNesterov}},t.fromConfig=function(e,t){return new e(t.learningRate,t.momentum,t.useNesterov)},t}(gh);mh.className="Momentum",jo(mh);var yh=function(e){function t(t,n,r,a,o){void 0===n&&(n=.9),void 0===r&&(r=0),void 0===a&&(a=null),void 0===o&&(o=!1);var i=e.call(this)||this;if(i.learningRate=t,i.decay=n,i.momentum=r,i.epsilon=a,i.accumulatedMeanSquares=[],i.accumulatedMoments=[],i.accumulatedMeanGrads=[],i.centered=o,null==a&&(i.epsilon=$r.backend.epsilon()),null==t)throw new Error("learningRate for RMSPropOptimizer must be defined.");return i}return o(t,e),t.prototype.applyGradients=function(e){var t=this;(Array.isArray(e)?e.map((function(e){return e.name})):Object.keys(e)).forEach((function(n,r){var a=$r.registeredVariables[n],o=!1;null==t.accumulatedMeanSquares[r]&&(t.accumulatedMeanSquares[r]={originalName:n+"/rms",variable:Qo((function(){return ms(a).variable(o)}))}),null==t.accumulatedMoments[r]&&(t.accumulatedMoments[r]={originalName:n+"/momentum",variable:Qo((function(){return ms(a).variable(o)}))}),null==t.accumulatedMeanGrads[r]&&t.centered&&(t.accumulatedMeanGrads[r]={originalName:n+"/mg",variable:Qo((function(){return ms(a).variable(o)}))});var i=Array.isArray(e)?e[r].tensor:e[n];if(null!=i){var s=t.accumulatedMeanSquares[r].variable,u=t.accumulatedMoments[r].variable;Qo((function(){var e=ni(oi(s,t.decay),oi(yu(i),1-t.decay));if(t.centered){var n=t.accumulatedMeanGrads[r].variable,o=ni(oi(n,t.decay),oi(i,1-t.decay)),l=ai(oi(i,t.learningRate),Nl(Ys(e,ni(yu(o),t.epsilon)))),c=ni(oi(u,t.momentum),l);s.assign(e),n.assign(o),u.assign(c);var h=Ys(a,c);a.assign(h)}else{var f=ni(oi(s,t.decay),oi(yu(i),1-t.decay));c=ni(oi(u,t.momentum),ai(oi(i,t.learningRate),Nl(ni(f,t.epsilon))));s.assign(f),u.assign(c);h=Ys(a,c);a.assign(h)}}))}})),this.incrementIterations()},t.prototype.dispose=function(){null!=this.accumulatedMeanSquares&&ei(this.accumulatedMeanSquares.map((function(e){return e.variable}))),null!=this.accumulatedMeanGrads&&this.centered&&ei(this.accumulatedMeanGrads.map((function(e){return e.variable}))),null!=this.accumulatedMoments&&ei(this.accumulatedMoments.map((function(e){return e.variable})))},t.prototype.getWeights=function(){return i(this,void 0,void 0,(function(){var e;return s(this,(function(t){switch(t.label){case 0:return e=c(this.accumulatedMeanSquares,this.accumulatedMoments),this.centered&&e.push.apply(e,c(this.accumulatedMeanGrads)),[4,this.saveIterations()];case 1:return[2,[t.sent()].concat(e.map((function(e){return{name:e.originalName,tensor:e.variable}})))]}}))}))},t.prototype.setWeights=function(e){return i(this,void 0,void 0,(function(){var t,n;return s(this,(function(r){switch(r.label){case 0:return[4,this.extractIterations(e)];case 1:return e=r.sent(),t=this.centered?e.length/3:e.length/2,n=!1,this.accumulatedMeanSquares=e.slice(0,t).map((function(e){return{originalName:e.name,variable:e.tensor.variable(n)}})),this.accumulatedMoments=e.slice(t,2*t).map((function(e){return{originalName:e.name,variable:e.tensor.variable(n)}})),this.centered&&(this.accumulatedMeanGrads=e.slice(2*t,3*t).map((function(e){return{originalName:e.name,variable:e.tensor.variable(n)}}))),[2]}}))}))},t.prototype.getConfig=function(){return{learningRate:this.learningRate,decay:this.decay,momentum:this.momentum,epsilon:this.epsilon,centered:this.centered}},t.fromConfig=function(e,t){return new e(t.learningRate,t.decay,t.momentum,t.epsilon,t.centered)},t}(hh);yh.className="RMSProp",jo(yh);var bh=function(){function e(){}return e.sgd=function(e){return new gh(e)},e.momentum=function(e,t,n){return void 0===n&&(n=!1),new mh(e,t,n)},e.rmsprop=function(e,t,n,r,a){return void 0===t&&(t=.9),void 0===n&&(n=0),void 0===r&&(r=null),void 0===a&&(a=!1),new yh(e,t,n,r,a)},e.adam=function(e,t,n,r){return void 0===e&&(e=.001),void 0===t&&(t=.9),void 0===n&&(n=.999),void 0===r&&(r=null),new ph(e,t,n,r)},e.adadelta=function(e,t,n){return void 0===e&&(e=.001),void 0===t&&(t=.95),void 0===n&&(n=null),new fh(e,t,n)},e.adamax=function(e,t,n,r,a){return void 0===e&&(e=.002),void 0===t&&(t=.9),void 0===n&&(n=.999),void 0===r&&(r=null),void 0===a&&(a=0),new vh(e,t,n,r,a)},e.adagrad=function(e,t){return void 0===t&&(t=.1),new dh(e,t)},e}(),wh={sgd:bh.sgd,momentum:bh.momentum,adadelta:bh.adadelta,adagrad:bh.adagrad,rmsprop:bh.rmsprop,adamax:bh.adamax,adam:bh.adam},kh="undefined"!=typeof requestAnimationFrame?requestAnimationFrame:"undefined"!=typeof setImmediate?setImmediate:function(e){return e()};var xh="->",Eh=/->/g;function Sh(e,t){for(var n=[],r=0;r<e.length;++r)0!==e[r].length&&-1===e[r].indexOf(t)&&-1!==t||n.push(r);return n}var Ah={__proto__:null,slice_util:Go,segment_util:{__proto__:null,segOpComputeOptimalWindowSize:function(e,t){var n,r=!1;for(e<=30?(n=e,r=!0):n=z(e,Math.floor(Math.sqrt(e)));!r;)n>t||n===e?r=!0:n=z(e,n+1);return n},computeOutShape:function(e,t,n){for(var r=[],a=e.length,o=0;o<a;o++)o!==t?r.push(e[o]):r.push(n);return r},collectGatherOpShapeInfo:function(e,t,n,r){var a=t.shape.length,o=e.shape.length;if(0!==r&&(r<-a||r>a))throw new Error("Expect batchDims in the range of [-"+a+", "+a+"], but got "+r);if(r<0&&(r+=a),r>o)throw new Error("batchDims ("+r+") must be less than rank(x) (\n    "+o+").");if(n<r)throw new Error("batchDims ("+r+") must be less than or equal to axis ("+n+").");for(var i=0;i<r;++i)if(e.shape[i]!==t.shape[i])throw new Error("x.shape["+i+"]: "+e.shape[i]+" should be equal to indices.shape["+i+"]: "+t.shape[i]+".");var s=e.shape[n],u=[],l=1,c=1,h=1;for(i=0;i<r;++i)u.push(e.shape[i]),l*=e.shape[i];for(i=r;i<n;i++)u.push(e.shape[i]),c*=e.shape[i];for(i=r;i<a;i++)u.push(t.shape[i]);for(i=n+1;i<o;i++)u.push(e.shape[i]),h*=e.shape[i];return{batchSize:l,sliceSize:h,outerSize:c,dimSize:s,outputShape:u}}},fromUint8ToStringArray:function(e){try{return e.map((function(e){return kr(e)}))}catch(e){throw new Error("Failed to decode encoded string bytes into utf-8, error: "+e)}},fromStringArrayToUint8:function(e){return e.map((function(e){return wr(e)}))},upcastType:qr,axesAreInnerMostDims:Qs,combineLocations:eu,computeOutAndReduceShapes:function(e,t){for(var n=[],r=e.length,a=0;a<r;a++)-1===t.indexOf(a)&&n.push(e[a]);return[n,t.map((function(t){return e[t]}))]},expandShapeToKeepDim:tu,assertAxesAreInnerMostDims:function(e,t,n){m(Qs(t,n),(function(){return e+" supports only inner-most axes for now. Got axes "+t+" and rank-"+n+" input."}))},getAxesPermutation:function(e,t){if(Qs(e,t))return null;for(var n=[],r=0;r<t;++r)-1===e.indexOf(r)&&n.push(r);return e.forEach((function(e){return n.push(e)})),n},getUndoAxesPermutation:function(e){return e.map((function(e,t){return[t,e]})).sort((function(e,t){return e[1]-t[1]})).map((function(e){return e[0]}))},getInnerMostAxes:function(e,t){for(var n=[],r=t-e;r<t;++r)n.push(r);return n},getBroadcastDims:function(e,t){for(var n=e.length,r=[],a=0;a<n;a++){var o=n-1-a,i=e[o]||1;(t[t.length-1-a]||1)>1&&1===i&&r.unshift(o)}return r},getReductionAxes:ds,assertAndGetBroadcastShape:ps,assertParamsConsistent:function(e,t){var n=e[0].length;e.forEach((function(e,t){m(e.length===n,(function(){return"Error in concat"+n+"D: rank of tensors["+t+"] must be the same as the rank of the rest ("+n+")"}))})),m(t>=0&&t<n,(function(){return"Error in concat"+n+"D: axis must be between 0 and "+(n-1)+"."}));var r=e[0];e.forEach((function(e,a){for(var o=0;o<n;o++)m(o===t||e[o]===r[o],(function(){return"Error in concat"+n+"D: Shape of tensors["+a+"] ("+e+") does not match the shape of the rest ("+r+") along the non-concatenated axis "+a+"."}))}))},computeOutShape:function(e,t){for(var n=e[0].slice(),r=1;r<e.length;r++)n[t]+=e[r][t];return n},computeDilation2DInfo:function(e,t,n,r,a,o){return void 0===a&&(a="NHWC"),wi(e,c(t,[e[3]]),n,o,r,null,null,Mi(a))},computePool2DInfo:bi,computePool3DInfo:function(e,t,n,r,a,o,i){void 0===i&&(i="NDHWC");var s,u,c=l(Si(t),3),h=c[0],f=c[1],d=c[2];if("NDHWC"===i)u="channelsLast",s=[h,f,d,e[4],e[4]];else{if("NCDHW"!==i)throw new Error("Unknown dataFormat "+i);u="channelsFirst",s=[h,f,d,e[1],e[1]]}return ki(e,s,n,r,a,!1,u,o)},computeConv2DInfo:wi,computeConv3DInfo:ki,computeDefaultPad:xi,tupleValuesAreOne:Ni,eitherStridesOrDilationsAreOne:Ii,convertConv2DDataFormat:Mi,getFusedDyActivation:tc,getFusedBiasGradient:nc,applyActivation:rc,shouldFuse:ac,PARALLELIZE_THRESHOLD:30,computeOptimalWindowSize:function(e){return e<=30?e:z(e,Math.floor(Math.sqrt(e)))},getImageCenter:function(e,t,n){return[n*("number"==typeof e?e:e[0]),t*("number"==typeof e?e:e[1])]},getReshaped:function(e,t,n,r){void 0===r&&(r=!0);var a=[];if(r)(a=a.concat(t.slice(0))).push(e[0]/n),a=a.concat(e.slice(1));else{a=a.concat(e[0]);for(var o=t.length,i=0;i<o;++i)a=a.concat([e[i+1]/t[i],t[i]]);a=a.concat(e.slice(o+1))}return a},getPermuted:function(e,t,n){void 0===n&&(n=!0);var r=[];if(n){r.push(t);for(var a=t+1;a<e;++a)a<=2*t?(r.push(a),r.push(a-(t+1))):r.push(a)}else{var o=[],i=[];for(a=1;a<e;++a)a>=2*t+1||a%2==1?i.push(a):o.push(a);r.push.apply(r,c(o)),r.push(0),r.push.apply(r,c(i))}return r},getReshapedPermuted:function(e,t,n,r){void 0===r&&(r=!0);var a=[];r?a.push(e[0]/n):a.push(e[0]*n);for(var o=1;o<e.length;++o)o<=t.length?r?a.push(t[o-1]*e[o]):a.push(e[o]/t[o-1]):a.push(e[o]);return a},getSliceBeginCoords:function(e,t){for(var n=[0],r=0;r<t;++r)n.push(e[r][0]);return n},getSliceSize:function(e,t,n){for(var r=e.slice(0,1),a=0;a<n;++a)r.push(e[a+1]-t[a][0]-t[a][1]);return r},prepareAndValidate:No,validateUpdateShape:Mo,validateInput:To,calculateShapes:Do,SELU_SCALEALPHA:1.7580993408473768,SELU_SCALE:1.0507009873554805,ERF_P:.3275911,ERF_A1:.254829592,ERF_A2:-.284496736,ERF_A3:1.421413741,ERF_A4:-1.453152027,ERF_A5:1.061405429,warn:j,log:function(){for(var e=[],t=0;t<arguments.length;t++)e[t]=arguments[t];Q().getBool("IS_TEST")||Q().getBool("PROD")||console.log.apply(console,c(e))},mergeRealAndImagArrays:function(e,t){if(e.length!==t.length)throw new Error("Cannot merge real and imag arrays of different lengths. real:"+e.length+", imag: "+t.length+".");for(var n=new Float32Array(2*e.length),r=0;r<n.length;r+=2)n[r]=e[r/2],n[r+1]=t[r/2];return n},splitRealAndImagArrays:function(e){for(var t=new Float32Array(e.length/2),n=new Float32Array(e.length/2),r=0;r<e.length;r+=2)t[r/2]=e[r],n[r/2]=e[r+1];return{real:t,imag:n}},complexWithEvenIndex:function(e){for(var t=Math.ceil(e.length/4),n=new Float32Array(t),r=new Float32Array(t),a=0;a<e.length;a+=4)n[Math.floor(a/4)]=e[a],r[Math.floor(a/4)]=e[a+1];return{real:n,imag:r}},complexWithOddIndex:function(e){for(var t=Math.floor(e.length/4),n=new Float32Array(t),r=new Float32Array(t),a=2;a<e.length;a+=4)n[Math.floor(a/4)]=e[a],r[Math.floor(a/4)]=e[a+1];return{real:n,imag:r}},getComplexWithIndex:function(e,t){return{real:e[2*t],imag:e[2*t+1]}},assignToTypedArray:function(e,t,n,r){e[2*r]=t,e[2*r+1]=n},exponents:function(e,t){for(var n=new Float32Array(e/2),r=new Float32Array(e/2),a=0;a<Math.ceil(e/2);a++){var o=(t?2:-2)*Math.PI*(a/e);n[a]=Math.cos(o),r[a]=Math.sin(o)}return{real:n,imag:r}},exponent:function(e,t,n){var r=(n?2:-2)*Math.PI*(e/t);return{real:Math.cos(r),imag:Math.sin(r)}},decodeEinsumEquation:function(e,t){var n=((e=e.replace(/\s/g,"")).length-e.replace(Eh,"").length)/xh.length;if(n<1)throw new Error("Equations without an arrow are not supported.");if(n>1)throw new Error('Equation must contain exactly one arrow ("->").');var r=l(e.split(xh),2),a=r[0],o=r[1];m(-1===a.indexOf("..."),(function(){return'The ellipsis notation ("...") is not supported yet.'}));var i=a.split(","),s=i.length;if(t!==s)throw new Error("Expected "+s+" input tensors, received "+t);if(s>2)throw new Error("Support for more than 2 input tensors is not implemented yet.");for(var u=[],c=function(e){var t=o[e];if(!i.some((function(e){return-1!==e.indexOf(t)})))throw new Error("Output subscripts contain the label "+t+" not present in the input subscripts.");-1===u.indexOf(t)&&u.push(t)},h=0;h<o.length;++h)c(h);for(h=0;h<a.length;++h){var f=a[h];-1===u.indexOf(f)&&","!==f&&u.push(f)}var d=new Array(i.length);for(h=0;h<s;++h){if(new Set(i[h].split("")).size!==i[h].length)throw new Error("Found duplicate axes in input component "+i[h]+". Support for duplicate axes in input is not implemented yet.");d[h]=[];for(var p=0;p<i[h].length;++p)d[h].push(u.indexOf(i[h][p]))}var v=u.length,g=[];for(h=o.length;h<v;++h)g.push(h);return{allDims:u,summedDims:g,idDims:d}},getEinsumPermutation:function(e,t){var n=new Array(e);n.fill(-1);for(var r=0;r<t.length;++r)n[t[r]]=r;var a=[];for(r=0;r<e;++r)-1===n[r]&&a.push(r);return{permutationIndices:n=n.filter((function(e){return-1!==e})),expandDims:a}},checkEinsumDimSizes:function(e,t,n){for(var r=new Array(e),a=function(e){for(var a=n[e].shape,o=function(n){void 0===r[t[e][n]]?r[t[e][n]]=a[n]:m(r[t[e][n]]===a[n],(function(){return"Expected dimension "+r[t[e][n]]+" at axis "+n+" of input shaped "+JSON.stringify(a)+", but got dimension "+a[n]}))},i=0;i<t[e].length;++i)o(i)},o=0;o<n.length;++o)a(o)},getEinsumComputePath:function(e,t){var n,r,a,o=e,i=[];0===e.length&&o.push(-1),a=e.length+1;for(var s=0;s<a;++s)i.push([]);var l=[];for(s=0;s<o.length;++s){var c=Sh(t,o[s]);try{for(var h=(n=void 0,u(c)),f=h.next();!f.done;f=h.next()){var d=f.value;-1===l.indexOf(d)&&(i[s].push(d),l.push(d))}}catch(e){n={error:e}}finally{try{f&&!f.done&&(r=h.return)&&r.call(h)}finally{if(n)throw n.error}}}return{path:o,steps:i}},isIdentityPermutation:function(e){return e.every((function(e,t){return e===t}))},prepareSplitSize:function(e,t,n){void 0===n&&(n=0);var r=[];if("number"==typeof t)m(e.shape[n]%t==0,(function(){return"Number of splits must evenly divide the axis."})),r=new Array(t).fill(e.shape[n]/t);else{m(t.reduce((function(e,t){return-1===t&&(e+=1),e}),0)<=1,(function(){return"There should be only one negative value in split array."}));var a=t.indexOf(-1);if(-1!==a){var o=t.reduce((function(e,t){return t>0?e+t:e}));t[a]=e.shape[n]-o}m(e.shape[n]===t.reduce((function(e,t){return e+t})),(function(){return"The sum of sizes must match the size of the axis dimension."})),r=t}return r}},_h={__proto__:null,nonMaxSuppressionV3Impl:kc,nonMaxSuppressionV4Impl:xc,nonMaxSuppressionV5Impl:Ec,whereImpl:ql};e.Abs="Abs",e.Acos=ne,e.Acosh=re,e.AdadeltaOptimizer=fh,e.AdagradOptimizer=dh,e.AdamOptimizer=ph,e.AdamaxOptimizer=vh,e.Add=ae,e.AddN=oe,e.All="All",e.Any="Any",e.ArgMax=ie,e.ArgMin=se,e.Asin=ue,e.Asinh=le,e.Atan=ce,e.Atan2=fe,e.Atanh=he,e.AvgPool=de,e.AvgPool3D=pe,e.AvgPool3DGrad="AvgPool3DGrad",e.AvgPoolGrad="AvgPoolGrad",e.BatchMatMul=ve,e.BatchToSpaceND=ge,e.Bincount=me,e.BroadcastArgs=ye,e.BroadcastTo="BroadcastTo",e.Cast=be,e.Ceil=we,e.ClipByValue=ke,e.Complex=xe,e.ComplexAbs=Ee,e.Concat=Se,e.Conv2D=Ae,e.Conv2DBackpropFilter=_e,e.Conv2DBackpropInput=Ne,e.Conv3D=Ie,e.Conv3DBackpropFilterV2="Conv3DBackpropFilterV2",e.Conv3DBackpropInputV2=Me,e.Cos="Cos",e.Cosh=Te,e.CropAndResize=Re,e.Cumsum=De,e.DataStorage=h,e.DenseBincount=Fe,e.DepthToSpace=Be,e.DepthwiseConv2dNative=Ce,e.DepthwiseConv2dNativeBackpropFilter=Pe,e.DepthwiseConv2dNativeBackpropInput=Oe,e.Diag=Le,e.Dilation2D=ze,e.Dilation2DBackpropFilter="Dilation2DBackpropFilter",e.Dilation2DBackpropInput="Dilation2DBackpropInput",e.Einsum=qe,e.Elu="Elu",e.EluGrad="EluGrad",e.Environment=Y,e.Equal=We,e.Erf="Erf",e.Exp="Exp",e.ExpandDims=Ue,e.Expm1=Ge,e.FFT="FFT",e.Fill=He,e.FlipLeftRight=Ve,e.Floor=je,e.FloorDiv=Je,e.FromPixels=En,e.FusedBatchNorm=Ze,e.FusedConv2D=_n,e.FusedDepthwiseConv2D=Nn,e.GatherNd=Xe,e.GatherV2=Ye,e.Greater=$e,e.GreaterEqual=Qe,e.IFFT=tt,e.Identity=et,e.Imag=nt,e.IsFinite=rt,e.IsInf=at,e.IsNan=ot,e.KernelBackend=f,e.LRN="LRN",e.LRNGrad="LRNGrad",e.LeakyRelu=it,e.Less=st,e.LessEqual=ut,e.LinSpace=lt,e.Log="Log",e.Log1p=ct,e.LogSoftmax="LogSoftmax",e.LogicalAnd=ht,e.LogicalNot=ft,e.LogicalOr=dt,e.Max="Max",e.MaxPool=vt,e.MaxPool3D=gt,e.MaxPool3DGrad="MaxPool3DGrad",e.MaxPoolGrad="MaxPoolGrad",e.MaxPoolWithArgmax=mt,e.Maximum=pt,e.Mean=yt,e.Min="Min",e.Minimum=bt,e.MirrorPad=wt,e.Mod="Mod",e.MomentumOptimizer=mh,e.Multinomial=kt,e.Multiply=xt,e.Neg="Neg",e.NonMaxSuppressionV3=St,e.NonMaxSuppressionV4=At,e.NonMaxSuppressionV5=_t,e.NotEqual=Et,e.OP_SCOPE_SUFFIX=ua,e.OneHot=It,e.OnesLike=Nt,e.Optimizer=hh,e.Pack=Mt,e.PadV2=Tt,e.Pool="Pool",e.Pow="Pow",e.Prelu=Dt,e.Prod=Rt,e.RMSPropOptimizer=yh,e.Range=Ft,e.Real=Bt,e.RealDiv=Ke,e.Reciprocal=Ct,e.Relu=Pt,e.Relu6=Kt,e.Reshape=Ot,e.ResizeBilinear=zt,e.ResizeBilinearGrad="ResizeBilinearGrad",e.ResizeNearestNeighbor=Lt,e.ResizeNearestNeighborGrad="ResizeNearestNeighborGrad",e.Reverse=qt,e.RotateWithOffset=Sn,e.Round=Wt,e.Rsqrt=Ut,e.SGDOptimizer=gh,e.ScatterNd=Gt,e.Select=Ht,e.Selu=Vt,e.Sigmoid=Yt,e.Sign=Zt,e.Sin="Sin",e.Sinh=Jt,e.Slice=jt,e.Softmax=tn,e.Softplus=Xt,e.SpaceToBatchND=Qt,e.SparseFillEmptyRows=nn,e.SparseReshape=rn,e.SparseSegmentMean=an,e.SparseSegmentSum=on,e.SparseToDense=sn,e.SplitV=en,e.Sqrt=$t,e.Square="Square",e.SquaredDifference=un,e.Step=xn,e.StridedSlice=ln,e.StringNGrams=cn,e.StringSplit=hn,e.StringToHashBucketFast=fn,e.Sub="Sub",e.Sum="Sum",e.Tan="Tan",e.Tanh=dn,e.Tensor=Fr,e.TensorBuffer=Tr,e.Tile=pn,e.TopK=vn,e.Transform=gn,e.Transpose=mn,e.Unique=yn,e.Unpack=bn,e.UnsortedSegmentSum=wn,e.Variable=zr,e.ZerosLike=kn,e._FusedMatMul=An,e.abs=ii,e.acos=si,e.acosh=ui,e.add=ni,e.addN=li,e.all=ci,e.any=hi,e.argMax=fi,e.argMin=di,e.asin=pi,e.asinh=vi,e.atan=gi,e.atan2=mi,e.atanh=yi,e.avgPool=Di,e.avgPool3d=Ri,e.backend=function(){return $r.backend},e.backend_util=Ah,e.basicLSTMCell=Oi,e.batchNorm=zi,e.batchNorm2d=Ki,e.batchNorm3d=qi,e.batchNorm4d=Wi,e.batchToSpaceND=Li,e.bincount=Ui,e.booleanMaskAsync=Ul,e.broadcastArgs=Gi,e.broadcastTo=Hi,e.browser=_o,e.buffer=eo,e.cast=to,e.ceil=Vi,e.clipByValue=ji,e.clone=no,e.complex=ca,e.concat=Fi,e.concat1d=Ji,e.concat2d=Zi,e.concat3d=Yi,e.concat4d=Xi,e.conv1d=Qi,e.conv2d=$i,e.conv2dTranspose=ts,e.conv3d=ns,e.conv3dTranspose=as,e.copyRegisteredKernels=function(e,t){Rn(e).forEach((function(e){Fn(Object.assign({},e,{backendName:t}))}))},e.cos=os,e.cosh=is,e.cosineWindow=$l,e.cumsum=ss,e.customGrad=Gs,e.denseBincount=us,e.deprecationWarn=function(e){Q().getBool("DEPRECATION_WARNINGS_ENABLED")&&console.warn(e+" You can disable deprecation warnings with tf.disableDeprecationWarnings().")},e.depthToSpace=ls,e.depthwiseConv2d=cs,e.device_util=ta,e.diag=hs,e.dilation2d=fs,e.disableDeprecationWarnings=function(){Q().set("DEPRECATION_WARNINGS_ENABLED",!1),console.warn("TensorFlow.js deprecation warnings have been disabled.")},e.dispose=ei,e.disposeVariables=function(){$r.disposeVariables()},e.div=ai,e.divNoNan=ys,e.dot=bs,e.dropout=Yl,e.einsum=ws,e.elu=ks,e.enableDebugMode=function(){Q().set("DEBUG",!0)},e.enableProdMode=function(){Q().set("PROD",!0)},e.enclosingPowerOfTwo=Xl,e.engine=function(){return $r},e.env=Q,e.equal=vs,e.erf=xs,e.exp=Es,e.expandDims=Ss,e.expm1=As,e.eye=Ns,e.fft=xl,e.fill=Is,e.findBackend=function(e){return $r.findBackend(e)},e.findBackendFactory=function(e){return $r.findBackendFactory(e)},e.floor=Ms,e.floorDiv=ri,e.fused=uc,e.gather=Ts,e.gatherND=Zl,e.gather_util=Io,e.getBackend=function(){return $r.backendName},e.getGradient=Dn,e.getKernel=Tn,e.getKernelsForBackend=Rn,e.grad=function(e){return m(L(e),(function(){return"The f passed in grad(f) must be a function"})),function(t,n){var r=ia(t,"x","tf.grad","string_or_numeric"),a=null!=n?ia(n,"dy","tf.grad"):null;return $r.tidy((function(){var t=$r.gradients((function(){return e(r)}),[r],a),n=t.value,o=t.grads;return null!=a&&y(n.shape,a.shape,"The shape of dy passed in grad(f)(x, dy) must match the shape returned by f(x)"),Hs(o),o[0]}))}},e.grads=function(e){return m(L(e),(function(){return"The f passed in grads(f) must be a function"})),function(t,n){m(Array.isArray(t),(function(){return"The args passed in grads(f)(args) must be an array of `Tensor`s or `TensorLike`s"}));var r=sa(t,"args","tf.grads","string_or_numeric"),a=null!=n?ia(n,"dy","tf.grads"):null;return $r.tidy((function(){var t=$r.gradients((function(){return e.apply(void 0,c(r))}),r,a),n=t.value,o=t.grads;return null!=a&&y(n.shape,a.shape,"The shape of dy passed in grads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),Hs(o),o}))}},e.greater=Ds,e.greaterEqual=Rs,e.ifft=El,e.imag=Fs,e.image=ih,e.inTopKAsync=Ql,e.io=mo,e.irfft=Sl,e.isFinite=Bs,e.isInf=Cs,e.isNaN=Ps,e.keep=ti,e.kernel_impls=_h,e.leakyRelu=Os,e.less=Ls,e.lessEqual=zs,e.linalg=sh,e.linspace=function(e,t,n){if(n<=0)throw new Error("The number of values should be positive.");var r={start:e,stop:t,num:n};return $r.runKernel(lt,{},r)},e.localResponseNormalization=Ks,e.log=qs,e.log1p=Ws,e.logSigmoid=Js,e.logSoftmax=$s,e.logSumExp=nu,e.logicalAnd=ru,e.logicalNot=au,e.logicalOr=ou,e.logicalXor=iu,e.losses=uh,e.matMul=yo,e.math=xo,e.max=Zs,e.maxPool=su,e.maxPool3d=uu,e.maxPoolWithArgmax=lu,e.maximum=cu,e.mean=hu,e.memory=function(){return $r.memory()},e.meshgrid=function(e,t,n){var r=(void 0===n?{}:n).indexing,a=void 0===r?"xy":r;if("xy"!==a&&"ij"!==a)throw new TypeError(a+" is not a valid third argument to meshgrid");if(void 0===e)return[];var o=ia(e,"x","meshgrid",e instanceof Fr?e.dtype:"float32");if(void 0===t)return[o];var i=ia(t,"y","meshgrid",t instanceof Fr?t.dtype:"float32"),s=k(o.shape),u=k(i.shape);return"xy"===a?(o=Ti(o,[1,-1]),i=Ti(i,[-1,1]),[yo(du([u,1],o.dtype),o),yo(i,du([1,s],i.dtype))]):(o=Ti(o,[-1,1]),i=Ti(i,[1,-1]),[yo(o,du([1,u],o.dtype)),yo(du([s,1],i.dtype),i)])},e.min=pu,e.minimum=vu,e.mirrorPad=gu,e.mod=mu,e.moments=bu,e.movingAverage=Vl,e.mul=oi,e.multiRNNCell=wu,e.multinomial=ku,e.neg=Vs,e.nextFrame=function(){return new Promise((function(e){return kh((function(){return e()}))}))},e.norm=Hl,e.notEqual=xu,e.oneHot=bo,e.ones=du,e.onesLike=Eu,e.op=la,e.outerProduct=Su,e.pad=Au,e.pad1d=_u,e.pad2d=Nu,e.pad3d=Iu,e.pad4d=Mu,e.pool=Du,e.pow=Ru,e.prelu=Fu,e.print=ro,e.prod=Bu,e.profile=function(e){return $r.profile(e)},e.rand=Cu,e.randomGamma=Zu,e.randomNormal=Yu,e.randomUniform=Xu,e.range=$u,e.ready=function(){return $r.ready()},e.real=Qu,e.reciprocal=el,e.registerBackend=function(e,t,n){return void 0===n&&(n=1),$r.registerBackend(e,t,n)},e.registerGradient=function(e){var t=e.kernelName;Mn.has(t)&&Q().getBool("DEBUG")&&j("Overriding the gradient for '"+t+"'"),Mn.set(t,e)},e.registerKernel=Fn,e.relu=tl,e.relu6=nl,e.removeBackend=function(e){$r.removeBackend(e)},e.reshape=Ti,e.reverse=rl,e.reverse1d=al,e.reverse2d=ol,e.reverse3d=il,e.reverse4d=sl,e.rfft=_l,e.round=ul,e.rsqrt=ll,e.scalar=cl,e.scatterND=jl,e.scatter_util=Ro,e.selu=hl,e.separableConv2d=fl,e.serialization=Jo,e.setBackend=function(e){return $r.setBackend(e)},e.setPlatform=function(e,t){Q().setPlatform(e,t)},e.setdiff1dAsync=dl,e.sigmoid=Bi,e.sign=pl,e.signal=oh,e.sin=vl,e.sinh=gl,e.slice=Ci,e.slice1d=ml,e.slice2d=yl,e.slice3d=bl,e.slice4d=wl,e.slice_util=Go,e.softmax=kl,e.softplus=js,e.spaceToBatchND=Tu,e.sparse=lh,e.sparseToDense=Jl,e.spectral=ah,e.split=Al,e.sqrt=Nl,e.square=yu,e.squaredDifference=Il,e.squeeze=Ml,e.stack=Tl,e.step=Dl,e.stridedSlice=Rl,e.string=ch,e.sub=Ys,e.sum=Xs,e.sumOutType=function(e){return qr(e,"int32")},e.tan=Fl,e.tanh=Pi,e.tensor=fa,e.tensor1d=Bl,e.tensor2d=Cl,e.tensor3d=Eo,e.tensor4d=function(e,t,n){if(b(e),null!=t&&4!==t.length)throw new Error("tensor4d() requires shape to have four numbers");var r=ra(e,n);if(4!==r.length&&1!==r.length)throw new Error("tensor4d() requires values to be number[][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor4d() requires shape to be provided when `values` are a flat array");return ha(e,t,r,n)},e.tensor5d=function(e,t,n){if(b(e),null!=t&&5!==t.length)throw new Error("tensor5d() requires shape to have five numbers");var r=ra(e,n);if(5!==r.length&&1!==r.length)throw new Error("tensor5d() requires values to be number[][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor5d() requires shape to be provided when `values` are a flat array");return ha(e,t,r,n)},e.tensor6d=function(e,t,n){if(b(e),null!=t&&6!==t.length)throw new Error("tensor6d() requires shape to have six numbers");var r=ra(e,n);if(6!==r.length&&1!==r.length)throw new Error("tensor6d() requires values to be number[][][][][][] or flat/TypedArray");if(1===r.length&&null==t)throw new Error("tensor6d() requires shape to be provided when `values` are a flat array");return ha(e,t=t||r,r,n)},e.tensor_util=Vr,e.test_util=$o,e.tidy=Qo,e.tile=_s,e.time=function(e){return $r.time(e)},e.topk=Pl,e.train=wh,e.transpose=wo,e.truncatedNormal=Ol,e.unique=Ll,e.unregisterGradient=function(e){if(!Mn.has(e))throw new Error("The gradient '"+e+"' for backend is not registered");Mn.delete(e)},e.unregisterKernel=function(e,t){var n=Bn(e,t);if(!In.has(n))throw new Error("The kernel '"+e+"' for backend '"+t+"' is not registered");In.delete(n)},e.unsortedSegmentSum=zl,e.unstack=Kl,e.upcastType=qr,e.util=xr,e.valueAndGrad=function(e){return m(L(e),(function(){return"The f passed in valueAndGrad(f) must be a function"})),function(t,n){m(t instanceof Fr,(function(){return"The x passed in valueAndGrad(f)(x) must be a tensor"})),m(null==n||n instanceof Fr,(function(){return"The dy passed in valueAndGrad(f)(x, dy) must be a tensor"}));var r=$r.gradients((function(){return e(t)}),[t],n),a=r.grads,o=r.value;return Hs(a),{grad:a[0],value:o}}},e.valueAndGrads=function(e){return m(L(e),(function(){return"The f passed in valueAndGrads(f) must be a function"})),function(t,n){m(Array.isArray(t)&&t.every((function(e){return e instanceof Fr})),(function(){return"The args passed in valueAndGrads(f)(args) must be array of tensors"})),m(null==n||n instanceof Fr,(function(){return"The dy passed in valueAndGrads(f)(args, dy) must be a tensor"}));var r=$r.gradients((function(){return e.apply(void 0,c(t))}),t,n);return null!=n&&y(r.value.shape,n.shape,"The shape of dy passed in valueAndGrads(f)([x1,...], dy) must match the shape returned by f([x1,...])"),Hs(r.grads),r}},e.variable=function(e,t,n,r){return void 0===t&&(t=!0),$r.makeVariable(e,t,n,r)},e.variableGrads=Us,e.version_core="3.10.0",e.where=gs,e.whereAsync=Wl,e.zeros=fu,e.zerosLike=ms,Object.defineProperty(e,"__esModule",{value:!0})}));
//# sourceMappingURL=tf-core.min.js.map
